#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;
my $query;

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);
$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $cimgurl = $perlQ->getImageDir(1);
my $limgurl = $perlQ->getImageDir(0);
my $aimgurl = $perlQ->getImgURL('admin/images');

my %alanguages = $perlQ->getLanguages('ADMIN');
my %languages = $perlQ->getLanguages;

#-->> Setting Variables

my $oldpasswd = $cgi->param('oldpasswd') || '';
my $newpasswd1 = $cgi->param('newpasswd1') || '';
my $newpasswd2 = $cgi->param('newpasswd2') || '';
my $sendmailpath = $cgi->param('sendmailpath') || '';
my $smtpserver = $cgi->param('smtpserver') || '';
my $summarylimit = $cgi->param('summarylimit') || 10;
my $textarealimit = $cgi->param('textarealimit') || 10;
my $popuplimit = $cgi->param('popuplimit') || 10;
my $template = $cgi->param('template') || '';
my $language = $cgi->param('language') || '';
my $alanguage = $cgi->param('alanguage') || '';
my $advanceinterface = $cgi->param('advanceinterface') || '';
my $incgibin = $cgi->param('incgibin') || '';
my $listsurvey = $cgi->param('listsurvey') || '';
my $timeout = $cgi->param('timeout') || 86400;
my $action = $cgi->param('action') || '';
my $cs = $cgi->param('cs') || 0;
my $cookiedomain = $cgi->param('cookiedomain') || '';

$summarylimit = ($summarylimit =~ /^(\d+)$/) ? $1 : 10;
$textarealimit = ($textarealimit =~ /^(\d+)$/) ? $1 : 10;
$popuplimit = ($popuplimit =~ /^(\d+)$/) ? $1 : 10;
$timeout = ($timeout =~ /^(\d+)$/) ? $1 : 86400;
$advanceinterface = ($advanceinterface =~ /^(y|n)$/) ? $1 : 'n';
$incgibin = ($incgibin =~ /^(y|n)$/) ? $1 : 'n';
$listsurvey = ($listsurvey =~ /^(y|n)$/) ? $1 : 'y';
$cs = ($cs =~ /^(\d+)$/) ? $1 : 0;

#-->> Modify

if ($action eq $lang->{'UploadDatabaseButton'}) {
	my $fh = $perlQ->getUploadFH('restorefile');
	if (!$fh) {
		$html->setMessage($lang->{'NoUploadError'});
	}
	else {
		require "Import.cgi";
		my $restoreb = $cgi->param('restoreb') || '';
		my $flag = ($restoreb eq 'erase') ? 'erase' : 'save';
		my @content = map { $_ =~ s/\r//g; $_; } <$fh>;
		&importSurvey($perlQ, \@content, 'BACKUP', $flag);
		if (!$html->getMessage) {
			$html->setMessage($lang->{'DatabaseRestored'});
		}
	}
}
elsif ($action eq $lang->{'URLDatabaseButton'}) {
	if ($cgi->param('restoreurl')) {
		eval {
			require LWP::UserAgent;

			my $browser = LWP::UserAgent->new(agent => "perlQuestionnaire v" . $perlQ->getVersion, cookie_jar => {}, requests_redirectable => ['GET', 'HEAD', 'POST']);
			my $req = HTTP::Request->new(GET => $cgi->param('restoreurl'));
			my $response = $browser->request($req);

			if ($response->is_success) {
				require "Import.cgi";
				my $restoreb = $cgi->param('restoreb') || '';
				my $flag = ($restoreb eq 'erase') ? 'erase' : 'save';
				my $content = $response->content;
				$content =~ s/\r//g;
				my @content = split(/\n/, $content);
				&importSurvey($perlQ, \@content, 'BACKUP', $flag);
				if (!$html->getMessage) {
					$html->setMessage($lang->{'DatabaseRestored'});
				}
			}
			else {
				$html->setMessage(sprintf($lang->{'URLReadError'}, $response->status_line));
			}
		};

		if ($@ && !$html->getMessage) {
			$html->setMessage($lang->{'LWPURLError'});
		}
	}
	else {
		$html->setMessage($lang->{'NoURLError'});
	}
}
elsif ($action) {
	my $message;

	if (!defined $languages{$language}) {
		if (defined $languages{'english'}) { $language = 'english'; }
		else { foreach my $lang (keys %languages) { $language = $lang; last; } }
	}

	if (!defined $alanguages{$alanguage}) {
		if (defined $alanguages{'english'}) { $alanguage = 'english'; }
		else { foreach my $lang (keys %alanguages) { $alanguage = $lang; last; } }
	}
	$perlQ->setLanguage($alanguage, 'ADMIN');
	$lang = $perlQ->getLanguage;

	my $ustring = "UPDATE perlQAdmin SET SMTPServer=?, SummaryLimit=?, TextareaLimit=?, PopupLimit=?, AdvanceInterface=?, Template=?, Language=?, AdminLanguage=?, InCgiBin=?, ListSurvey=?, TimeOut=?, CookieDomain=?";
	my @uvalues = ($smtpserver, $summarylimit, $textarealimit, $popuplimit, $advanceinterface, $template, $language, $alanguage, $incgibin, $listsurvey, $timeout, $cookiedomain);

	if ($sendmailpath && !(-x $sendmailpath)) {
		$message = "Specified Sendmail Path was invalid!";
	}
	else {
		$ustring .= ', SendmailPath=?';
		push(@uvalues, $sendmailpath);
	}

	if ($newpasswd1 || $newpasswd2) {
		if ($newpasswd1 eq $newpasswd2) {
			$query = $dbh->prepare("SELECT Passwd FROM perlQAdmin WHERE Passwd=?");
			if ($query->execute($oldpasswd) && $query->rows) {
				$ustring .= ", Passwd=?";
				push(@uvalues, $newpasswd1);
				eval {
					$dbh->do($ustring, undef, @uvalues);
				};

				if ($@) { $message = $lang->{'ConfigError'}; }
				else { $message = $lang->{'PasswordChanged'}; }
			}
			else { $message = $lang->{'IncorrectPassword'}; }
			$query->finish;
		}
		else { $message = $lang->{'PasswordMismatch'}; }
	}
	else {
		eval {
			$dbh->do($ustring, undef, @uvalues);
		};

		if (!$message) {
			if ($@) { $message = $lang->{'ConfigError'}; }
			else { $message = $lang->{'ConfigChanged'}; }
		}
	}

	if ($message) {
		$html->setMessage("<B>$lang->{'Status'}:</B> $message");
	}
}

#-->> Option Arrays

my $advancearray = [[$lang->{'Basic'}, "n"], [$lang->{'Advanced'}, "y"]];
my $yesnoarray = [[$lang->{'Yes'}, "y"], [$lang->{'No'}, "n"]];

#-->> Content

$query = $dbh->prepare("SELECT * FROM perlQAdmin LIMIT 1");
if ($query->execute && $query->rows) {
	my $maadmin = $query->fetchrow_hashref;

	$sendmailpath = $html->protectHTML($maadmin->{'SendmailPath'});
	$smtpserver = $html->protectHTML($maadmin->{'SMTPServer'});
	$summarylimit = $html->protectHTML($maadmin->{'SummaryLimit'});
	$textarealimit = $html->protectHTML($maadmin->{'TextareaLimit'});
	$popuplimit = $html->protectHTML($maadmin->{'PopupLimit'});
	$timeout = ($maadmin->{'TimeOut'} < 60) ? 86400 : $maadmin->{'TimeOut'};
	$template = $maadmin->{'Template'};
	$language = $maadmin->{'Language'};
	$alanguage = $maadmin->{'AdminLanguage'};
	$incgibin = ($maadmin->{'InCgiBin'} eq "y") ? "y" : "n";
	$listsurvey = ($maadmin->{'ListSurvey'} eq "y") ? "y" : "n";
	$advanceinterface = ($maadmin->{'AdvanceInterface'} eq "y") ? "y" : "n";
	$cookiedomain = $html->protectHTML($maadmin->{'CookieDomain'});
}
$query->finish;

my $surveyoptions = '';
$query = $dbh->prepare("SELECT SID,Name,AddDate FROM perlQSurvey ORDER BY AddDate DESC, Name");
$query->execute;
for (my $i = 0; $i < $query->rows; $i++) {
	my $masurvey = $query->fetchrow_hashref;
	my $surveyname = $masurvey->{'Name'};
	if (length($surveyname) > 30) { $surveyname = substr($surveyname,0,27)."..."; }
	$surveyname = substr($masurvey->{'AddDate'},0,10) . ": $surveyname";
	$surveyoptions .= "<option value=\"$masurvey->{'SID'}\">".$html->protectHTML($surveyname)."\n";
}
$query->finish;

my $contents = <<"END";

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
<FORM ACTION=admin.cgi METHOD=POST>
<TR>
	<TD COLSPAN=4><IMG SRC="$imgurl/headingadmin.gif" WIDTH=93 HEIGHT=17 ALT="$lang->{'ConfigurationTitle'}"></TD>
</TR>
END

if ((keys %alanguages) > 1) {
	$contents .= <<"END";

<TR>
  <TD ALIGN=right><NOBR><B>$lang->{'AdminLanguage'}:</B></NOBR></TD>
  <TD><A HREF="javascript:perlQHelp('a_alanguage', 'AdminLanguage')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
  <TD COLSPAN=2><SELECT NAME=alanguage CLASS=huge>
END

	foreach my $lang (keys %alanguages) {
		my $seltext = ($alanguage eq $lang) ? ' SELECTED' : '';
		$contents .= "<OPTION$seltext VALUE=\"$lang\">$alanguages{$lang}\n";
	}

	$contents .= <<"END";
  </SELECT></TD>
</TR>

END
}

$contents .= <<"END";
<TR>
	<TD ALIGN=right><B>$lang->{'DefaultTemplate'}:</B></TD>
	<TD><A HREF="javascript:perlQHelp('a_template', 'DefaultTemplate')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2><SELECT NAME=template CLASS=huge>

END

my %templates = $perlQ->getTemplates;
foreach my $temp (sort { $templates{$a} cmp $templates{$b} } keys %templates) {
	my $seltext = ($template eq $temp) ? ' SELECTED' : '';
	$contents .= "<OPTION$seltext VALUE=\"$temp\">$templates{$temp}\n";
}

$contents .= <<"END";

		</SELECT></TD>
</TR>
END

if ((keys %languages) > 1) {
	$contents .= <<"END";

<TR>
  <TD ALIGN=right><NOBR><B>$lang->{'DefaultLanguage'}:</B></NOBR></TD>
  <TD><A HREF="javascript:perlQHelp('a_language', 'DefaultLanguage')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
  <TD COLSPAN=2><SELECT NAME=language CLASS=huge>
END

	foreach my $lang (keys %languages) {
		my $seltext = ($language eq $lang) ? ' SELECTED' : '';
		$contents .= "<OPTION$seltext VALUE=\"$lang\">$languages{$lang}\n";
	}

	$contents .= <<"END";
  </SELECT></TD>
</TR>

END
}

$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'CookieDomain'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_cdomain', 'CookieDomain')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2><INPUT TYPE=text NAME=cookiedomain CLASS=huge VALUE="$cookiedomain"></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SendmailPath'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_sendmail', 'SendmailPath')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2><INPUT TYPE=text NAME=sendmailpath CLASS=huge VALUE="$sendmailpath"></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SMTPServer'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_smtpserver', 'SMTPServer')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>

END

eval { require Net::SMTP; };
if ($@) { $contents .= "<TD COLSPAN=2>$lang->{'RequiresNetSMTP'}</TD>\n"; }
else {
	$contents .= "<TD COLSPAN=2><INPUT TYPE=text NAME=smtpserver CLASS=huge VALUE=\"$smtpserver\"></TD>\n";
}


$contents .= <<"END";

</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'InCgiBin'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_cgibin','InCgiBin')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=incgibin CLASS=medium>

END
	
for (my $i=0; $i<@$yesnoarray; $i++) {
	my $selected = ($yesnoarray->[$i][1] eq $incgibin) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$yesnoarray->[$i][1]\">$yesnoarray->[$i][0]";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD ROWSPAN=13 ALIGN=CENTER WIDTH=250><IMG SRC="$aimgurl/perlQrot.gif" WIDTH=200 HEIGHT=200 BORDER=0 ALT="perlQ?"></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ListActiveSurveys'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_listsurvey','ListActiveSurveys')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=listsurvey CLASS=medium>

END

for (my $i=0; $i<@$yesnoarray; $i++) {
	my $selected = ($yesnoarray->[$i][1] eq $listsurvey) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$yesnoarray->[$i][1]\">$yesnoarray->[$i][0]";
}

$contents .= <<"END";

		</SELECT></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'EditorInterface'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_interface','EditorInterface')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=advanceinterface CLASS=medium>

END

for (my $i=0; $i<@$advancearray; $i++) {
	my $selected = ($advancearray->[$i][1] eq $advanceinterface) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$advancearray->[$i][1]\">$advancearray->[$i][0]";
}

my $surveyoptions = '';
my $query = $dbh->prepare("SELECT SID,Name,AddDate FROM perlQSurvey ORDER BY AddDate DESC");
if ($query->execute) {
 	for (my $i = 0; $i < $query->rows; $i++) {
		my $survref = $query->fetchrow_hashref;
		my $surveyname = substr($survref->{'AddDate'},0,10).': '.$survref->{'Name'};
		if (length($survref->{'Name'}) > 42) {
			$surveyname = substr($survref->{'Name'}, 0, 39).'...';
		}
		$surveyoptions .= "<OPTION VALUE=\"$survref->{'SID'}\">".$html->protectHTML($surveyname);
	}
}
$query->finish;

$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AdminTimeout'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_timeout','AdminTimeout')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=timeout CLASS=medium MAXLENGTH=5 VALUE="$timeout"> $lang->{'seconds'}</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SummaryDisplay'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_summarydisp','SummaryDisplay')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=summarylimit CLASS=medium MAXLENGTH=5 VALUE="$summarylimit"> $lang->{'entries'}</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'TextInputDisplay'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_textdisp','TextInputDisplay')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=textarealimit CLASS=medium MAXLENGTH=5 VALUE="$textarealimit"> $lang->{'entries'}</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'PopupDisplay'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_popupdisp','PopupDisplay')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=popuplimit CLASS=medium MAXLENGTH=5 VALUE="$popuplimit"> $lang->{'entries'}</TD>
</TR>
<TR>
	<TD COLSPAN=2></TD>
	<TD><INPUT TYPE=submit VALUE="$lang->{'ModifyOptionsButton'}"></TD>
</TR>
<TR>
	<TD COLSPAN=3>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=300>
	<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
	</TABLE>
	</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'CurrentPassword'}</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_password','CurrentPassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=password NAME=oldpasswd CLASS=medium MAXLENGTH=20 VALUE=""></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'NewPassword'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_password','NewPassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=password NAME=newpasswd1 CLASS=medium MAXLENGTH=20 VALUE=""></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'RetypePassword'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_password','RetypePassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=password NAME=newpasswd2 CLASS=medium MAXLENGTH=20 VALUE=""></TD>
</TR>
<TR>
	<TD COLSPAN=2></TD>
	<TD><INPUT TYPE=submit VALUE="$lang->{'ChangePasswordButton'}"></TD>
</TR>
<INPUT TYPE=hidden NAME=action VALUE="modify">
<INPUT TYPE=hidden NAME=cs VALUE="$cs">
</FORM>
<TR>
  <TD COLSPAN=4>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
	<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
	</TABLE>
	</TD>
</TR>
<FORM NAME="backup">
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'BackupDatabase'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_backup','BackupDatabase')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2><SELECT NAME="choosesurvey" STYLE="width: 280px;">
		<OPTION VALUE="0">$lang->{'BackupEntireDatabase'}$surveyoptions
		</SELECT>
		<INPUT TYPE=button ONCLICK="DownloadResult()" VALUE="$lang->{'DownloadDatabaseButton'}">
	</TD>
</TR>
</FORM>
<TR>
  <TD COLSPAN=4>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
	<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
	</TABLE>
	</TD>
</TR>
<FORM NAME="restore" ACTION="admin.cgi" ENCTYPE="multipart/form-data" METHOD=POST>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'RestoreDataFile'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_restorefile','RestoreDataFile')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2>
		<INPUT TYPE=file NAME="restorefile" SIZE=30>
		<INPUT TYPE=submit NAME="action" VALUE="$lang->{'UploadDatabaseButton'}">
	</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'RestoreFromURL'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_restoreurl','RestoreFromURL')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>

END

eval { require LWP; };
if ($@) { $contents .= "<TD COLSPAN=2>$lang->{'RequiresLWP'}</TD>\n"; }
else {
	$contents .= "<TD COLSPAN=2><INPUT TYPE=TEXT NAME=\"restoreurl\" class=large style=\"width: 270px;\"> <INPUT TYPE=submit NAME=\"action\" VALUE=\"$lang->{'URLDatabaseButton'}\"></TD>\n";
}

$contents .= <<"END";

</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'RestoreBehavior'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('a_restoreb','RestoreBehavior')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD COLSPAN=2><SELECT NAME="restoreb" class=huge><OPTION VALUE='save'>$lang->{'RestoreSAVE'}<OPTION VALUE='erase'>$lang->{'RestoreERASE'}</SELECT></TD>
</TR>
</FORM>
<TR>
  <TD COLSPAN=4>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
	<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
	</TABLE>
	</TD>
</TR>
</TR>
</TABLE>

END

open(JS, $perlQ->getFilePath('perlQMod/jsadmin.txt'));
my $jsinfo = join('', <JS>);
close(JS);

#-->> Output Page

$html->createPage('admin', "$lang->{'AdminTitle'} :: $lang->{'ConfigurationTitle'}", $contents, 1, $jsinfo, $cs);
