#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);
$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');

#-->> GET and POST Variables

my $cs = $cgi->param('cs') || 0;
my $sid = $cgi->param('sid') || 0;
my $uid = $cgi->param('uid') || 0;
my $action = $cgi->param('action') || '';
my $sortmethod = $cgi->param('sortmethod') || 'date';
my $sortdesc = $cgi->param('sortdesc') || '';
my $start = $cgi->param('start') || 0;

$cs = ($cs =~ /^(\d+)$/) ? $1 : 0;
$sid = ($sid =~ /^(\d+)$/) ? $1 : 0;
$uid = ($uid =~ /^(\d+)$/) ? $1 : 0;
$start = ($start =~ /^(\d+)$/) ? $1 : 0;

#-->> Delete Result

if ($action eq 'delete' && $uid && $sid) {
	eval {
		$dbh->do("DELETE FROM perlQAnswer WHERE UID=? AND SID=?", undef, $uid, $sid);
		$dbh->do("DELETE FROM perlQUser WHERE UID=? AND SID=?", undef, $uid, $sid);
	};

	my $message;
	if ($@) { $message = sprintf($lang->{'DeleteResultError'}, $uid); }
	else { $message = sprintf($lang->{'DeleteResultSuccess'}, $uid); }

	$html->setMessage("<B>$lang->{'Status'}:</B> $message");
}

#-->> Contents

my $contents = <<"END";

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
<FORM NAME=chooseform ACTION=survey.cgi METHOD=POST>
<TR>
	<TD><IMG SRC="$imgurl/headingsurvey1.gif" WIDTH=109 HEIGHT=22 ALT="$lang->{'ChooseASurvey'}"></TD>
</TR>
<TR>
	<TD ALIGN=center>
	<TABLE>
	<TR>
		<TD ALIGN=right><B>$lang->{'SelectSurvey'}:</B></TD>
		<TD><SELECT NAME=choosesurvey CLASS=huge ONCHANGE="ChangeSurvey()">

END

my $surveylist = [];
my $query = $dbh->prepare("SELECT * FROM perlQSurvey ORDER BY AddDate desc, Name");
$query->execute;
for (my $i = 0; $i < $query->rows; $i++) {
	$surveylist->[$i] = $query->fetchrow_hashref;
}
$query->finish;

my $emailconfirm = 0;
if (@$surveylist) {
	$contents .= "<OPTION VALUE=0>$lang->{'NoSurveySelected'}";
	for (my $i = 0; $i < @$surveylist; $i++) {
		my $selected = '';
		if ($surveylist->[$i]{'SID'} == $cs) {
			if (substr($surveylist->[$i]{'SurveyUsers'},2,1)) { $emailconfirm = 1; }
			$selected = ' SELECTED';
		}
		my $svname = (length($surveylist->[$i]{'Name'}) > 50) ? substr($surveylist->[$i]{'Name'},0,50)."..." : $surveylist->[$i]{'Name'};
		my $text = substr($surveylist->[$i]{'AddDate'},0,10) . ": $svname";
		$contents .= "<OPTION$selected VALUE=$surveylist->[$i]{'SID'}>" . $html->protectHTML($text);
	}
}
else {
	$contents .= "<OPTION VALUE=0>$lang->{'NoSurveyInDatabase'}";
}

$contents .= <<"END";

			</SELECT></TD>
	</TR>
	<TR>
		<TD></TD>
		<TD>

END

if ($emailconfirm) {
	$contents .= "<INPUT TYPE=button ONCLICK=\"ViewSurvey('v')\" VALUE=\"$lang->{'VerifiedResults'}\"> ";
	$contents .= "<INPUT TYPE=button ONCLICK=\"ViewSurvey('u')\" VALUE=\"$lang->{'UnverifiedResults'}\"> ";
	$contents .= "<INPUT TYPE=button ONCLICK=\"ViewSurvey('a')\" VALUE=\"$lang->{'AllResults'}\"> ";
}
else {
	$contents .= "<INPUT TYPE=button ONCLICK=\"ViewSurvey('a')\" VALUE=\"$lang->{'ViewResults'}\"> ";
}

$contents .= <<"END";

		</TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</FORM>
</TABLE>

END

if ($cs) {
	$sortdesc = ($sortdesc =~ /^(d|a)$/) ? $1 : (($sortmethod eq 'date') ? 'd' : 'a');
	my $limit = $perlQ->getAdminField('SummaryLimit') || 10;

	my $summary = &retrieveSummary($perlQ, $cs, $sortmethod, $sortdesc, $start, $limit);

	my $dlresults = '';
	if ($emailconfirm) {
		$dlresults .= "<INPUT TYPE=button ONCLICK=\"DownloadResult('$cs', 'v')\" VALUE=\"$lang->{'VerifiedResults'}\"> ";
		$dlresults .= "<INPUT TYPE=button ONCLICK=\"DownloadResult('$cs', 'u')\" VALUE=\"$lang->{'UnverifiedResults'}\"> ";
		$dlresults .= "<INPUT TYPE=button ONCLICK=\"DownloadResult('$cs', 'a')\" VALUE=\"$lang->{'AllResults'}\"> ";
	} else {
		$dlresults .= "<INPUT TYPE=button ONCLICK=\"DownloadResult('$cs', 'a')\" VALUE=\"$lang->{'DownloadResults'}\"> ";
	}

	$contents .= <<"END";

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
<FORM NAME=result>
<TR>
  <TD><IMG SRC="$imgurl/headingdlresults.gif" WIDTH=111 HEIGHT=17 ALT="$lang->{'DownloadResults'}"></TD>
</TR>
<TR>
	<TD ALIGN=center>
		<TABLE>
		<TR>
			<TD ALIGN=right><NOBR><B>$lang->{'FileFormat'}:</B></NOBR></TD>
			<TD><A HREF="javascript:perlQHelp('c_fileformat', 'FileFormat')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
			<TD><SELECT NAME=chooseresult CLASS=huge>
				<OPTION VALUE="csv">$lang->{'CSVName'}
				<OPTION VALUE="xml">$lang->{'XMLName'}
				<OPTION VALUE="xml-c">$lang->{'XMLCName'}
				<OPTION VALUE="sql">$lang->{'SQLName'}
				<OPTION VALUE="pex">$lang->{'PEXName'}
				<OPTION VALUE="perlQ">$lang->{'PERLQName'}
				</SELECT></TD>
		</TR>
		<TR>
			<TD COLSPAN=2></TD>
			<TD>$dlresults</TD>
		</TR>
		</TABLE>
	</TD>
</TR>
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR>
	<TD><IMG SRC="$imgurl/headingsummary.gif" WIDTH=105 HEIGHT=22 ALT="$lang->{'SurveySummary'}"></TD>
</TR>
<TR>
	<TD ALIGN=center>$summary</TD>
</TR>
</TABLE>

END
}

$contents .= <<"END";
<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
END

#-->> Output Page

open(JS, $perlQ->getFilePath('perlQMod/jschoose.txt'));
my $jsinfo = join('', <JS>);
close(JS);

$html->createPage('choose', "$lang->{'AdminTitle'} :: $lang->{'SurveyResultsTitle'}", $contents, 1, $jsinfo, $cs);

sub retrieveSummary {
	my ($perlQ, $sid, $sortmethod, $sortdesc, $start, $limit) = @_;
	my $dbh = $perlQ->getDBH;
	my $lang = $perlQ->getLanguage;
	my $imgurl = $perlQ->getImageDir;
	my $aimgurl = $perlQ->getImgURL('admin/images');

	my $masurvey;
	my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
	if ($query->execute($sid) && $query->rows) {
		$masurvey = $query->fetchrow_hashref;
	}
	$query->finish;

	my @qidlist = ();
	$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND Summary='y'");
	$query->execute($sid);
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maqlist = $query->fetchrow_hashref;
		push(@qidlist, $maqlist);
	}
	$query->finish;

	my ($sortfield, $sortorder, $emailitem) = ('CompleteDate', 'DESC', '');
	if ($sortdesc eq 'a') { $sortorder = ''; $emailitem = '~'; }

	if ($sortmethod eq 'email') {
		$sortfield = "IF(ISNULL(Email),\"$emailitem\",Email)";
	}
	elsif ($sortmethod eq 'ip') { $sortfield = 'IPAddr'; }

	$query = $dbh->prepare("SELECT UID, Email, EmailConfirm, IPAddr, DATE_FORMAT(CompleteDate, '$lang->{'MySQLDateFormatShort'}') as mdate FROM perlQUser WHERE SID=? ORDER BY $sortfield $sortorder LIMIT $start,$limit");
	$query->execute($sid);

	my (@userarray,@viewarray,@uidsidarray);
	my $coltype = (substr($masurvey->{'SurveyUsers'},2,1)) ? 'Email' : 'IPAddr';
	for (my $i = 0; $i < $query->rows; $i++) {
		my $mauid = $query->fetchrow_hashref;

		# Checking to see if Email Verification was used
		my $colname = $mauid->{$coltype} || '';
		if (length($colname) > 20) { $colname = substr($colname,0,20) . '...'; }
		$colname = $html->protectHTML($colname);
		if ($coltype eq 'Email') {
			if (!$colname) { $colname = $lang->{'notentered'}; }
			elsif ($mauid->{'EmailConfirm'} eq 'y') {
				$colname = "<b style=\"color: #009900;\">$colname</b>";
			}
			else {
				$colname = "<b style=\"color: #990000;\">$colname</b>";
			}
		}

		push(@uidsidarray, "sid=$sid&uid=$mauid->{'UID'}");
		push(@viewarray, "../view.cgi?sid=$sid&uid=$mauid->{'UID'}");
		my @answerarray = ($mauid->{'mdate'}, $colname);

		# Going through all the Questions

		for (my $j = 0; $j < @qidlist; $j++) {
			my $qquery = $dbh->prepare("SELECT Answer FROM perlQAnswer WHERE SID=? AND UID=? AND QID=?");
			if ($qquery->execute($sid, $mauid->{'UID'}, $qidlist[$j]->{'QID'}) &&
			    $qquery->rows) {
				my $maanswer = $qquery->fetchrow_hashref;
				if ($qidlist[$j]->{'Type'} ne 'textfield' && 
				    $qidlist[$j]->{'Type'} ne "textarea") {
					push(@answerarray, &processAnswer($perlQ, $qidlist[$j]->{'Answer'}, $maanswer->{'Answer'}));
				}
				else {
					push(@answerarray, $html->protectHTML($maanswer->{'Answer'}));
				}
			}
			else {
				push(@answerarray, '');
			}
			$qquery->finish;
		}
		push(@userarray, \@answerarray);
	}
	$query->finish;

	my $contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>\n";
	$contents .= "<TR>\n";
	$contents .= "<TD BGCOLOR=#333366 WIDTH=7><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=7 HEIGHT=1 ALT=\"\"></TD>";

	$contents .= &printColumn($perlQ, $sid, "DateCompleted", $sortmethod, $sortdesc, 0);

	my $columnname = ($emailconfirm) ? "EmailAddress" : "IPAddress";
	$contents .= &printColumn($perlQ, $sid, $columnname, $sortmethod, $sortdesc, 1);

	for (my $i = 0; $i < @qidlist; $i++) {
		my $question = $qidlist[$i]->{'Question'};
		if (length($question) > 20) { $question = substr($question,0,20) . '...'; }
		$contents .= &printColumn($perlQ, $sid, $question, $sortmethod, $sortdesc, $i+2);
	}
	$contents .= "<TD BGCOLOR=#333366 STYLE=\"color: #FFFFFF;\" ALIGN=right><B>$lang->{'Del'}</B></TD>";
	$contents .= "<TD BGCOLOR=#333366 ALIGN=right VALIGN=TOP><IMG SRC=\"$aimgurl/bound1.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
	$contents .= "</TR>\n";
	
	my $max = 0;
	$query = $dbh->prepare("SELECT COUNT(*) as num FROM perlQUser WHERE SID=?");
	if ($query->execute($sid) && $query->rows) {
		$max = ($query->fetchrow_array)[0];
	}
	$query->finish;

	my $realstart = ($start < $max && $start > 0) ? $start : 0;
	my $linecount = 0;
	for (my $j = 0; $j < @userarray; $j++) {
		my $leftimg = ($j % 2 == 0) ? "bound2.gif" : "bound7.gif";
		my $rightimg = ($j % 2 == 0) ? "bound3.gif" : "bound8.gif";
		my $delimg = ($j % 2 == 0) ? "delete1.gif" : "delete2.gif";
		my $bgcolor = ($j % 2 == 0) ? "#FFFFFF" : "#DDEEFF";

		my $anum = $j + 1 + $start;
		$contents .= "<TR>\n";
		$contents .= "<TD BACKGROUND=\"$aimgurl/$leftimg\" HEIGHT=13>&nbsp;</TD>";
		for (my $k = 0; $k < @{ $userarray[$j] }; $k++) {
			if ($k == 0) {
				my $surveydate = $userarray[$j]->[$k];
				$surveydate =~ s/\s/&nbsp;/g;
				$contents .= "<TD BGCOLOR=$bgcolor STYLE=\"padding-right: 2px;\" VALIGN=top><NOBR>$anum&nbsp;<A HREF=\"$viewarray[$j]\" CLASS=link TARGET=_blank>$surveydate</A></NOBR></TD>";
			}
			else {
				my $result = ($userarray[$j]->[$k] eq '') ? '&nbsp;' : $userarray[$j]->[$k];
				$contents .= "<TD BGCOLOR=$bgcolor VALIGN=top STYLE=\"border-left: 1px #333366 solid; padding-left: 2px; padding-right: 2px;\">$result</TD>";
			}
		}

		my $delurl = "choose.cgi?cs=$sid&sortmethod=$sortmethod&sortdesc=$sortdesc&start=$start&action=delete&$uidsidarray[$j]";
		$contents .= "<TD BGCOLOR=$bgcolor HEIGHT=15 ALIGN=right VALIGN=top STYLE=\"border-top: 1px $bgcolor solid;\">";
		$contents .= "<A HREF=\"javascript:DeleteEntry('$delurl','$anum')\">";
		$contents .= "<IMG SRC=\"$imgurl/$delimg\" WIDTH=13 HEIGHT=13 BORDER=0 ALT=\"$lang->{'X'}\"></A></TD>";
		$contents .= "<TD BACKGROUND=\"$aimgurl/$rightimg\" WIDTH=7>&nbsp;</TD>";
		$contents .= "</TR>\n";
		$linecount++;
	}

	my $colsize = @qidlist + 3;

	if ($linecount == 0) {
		$contents .= "<TR>\n";
		$contents .= "<TD BACKGROUND=\"$aimgurl/bound2.gif\">&nbsp;</TD>";
		$contents .= "<TD COLSPAN=$colsize ALIGN=center WIDTH=100%><BR>$lang->{'NoResults'}<BR><BR></TD>";
		$contents .= "<TD BACKGROUND=\"$aimgurl/bound3.gif\" WIDTH=7>&nbsp;</TD>";
		$contents .= "</TR>\n";
	}

	if ($realstart+$limit < $max || $realstart-$limit >= 0) {
		$contents .= "<TR>\n";
		$contents .= "<TD BGCOLOR=#333366 VALIGN=bottom><IMG SRC=\"$aimgurl/bound9.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
		$contents .= "<TD BGCOLOR=#333366 COLSPAN=$colsize ALIGN=center STYLE=\"color: #FFFFFF;\">";

		my $chooseloc = "choose.cgi?cs=$sid&sortmethod=$sortmethod&sortdesc=$sortdesc&start=";
		my $maxleftright = 7;
		my $lastindex = $max / $limit;
		$lastindex = (int($lastindex) == $lastindex) ? $lastindex : int($lastindex) + 1;

		# Previous Link

		if ($realstart - $limit >= 0) {
			my $prevloc = $chooseloc . ($realstart - $limit);
			$contents .= "<A HREF=\"$prevloc\" CLASS=link STYLE=\"color: #FFFFFF;\"><B>$lang->{'Previous'}</B></A> : ";
		}

		# Index Links

		for (my $k = 1; $k <= $lastindex; $k++) {
			my $startindex = int($start/$limit) + 1;
			if ($k == 1 || $k == $lastindex ||
					($k >= $startindex-$maxleftright && $k <= $startindex+$maxleftright)) {
				my $indexcc = ($k-1) * $limit + 1;
				my $indexloc = $chooseloc . (($k-1)*$limit);
				$contents .= ($k > 1) ? " " : "";
				$contents .= ($k == $lastindex && $k-1 > $startindex+$maxleftright && $lastindex > 2*$maxleftright+1) ? "... " : "";
				$contents .= ($indexcc-1 == $start) ? "<B STYLE=\"color: #99CCFF;\">[$k]</B>" : "<B><A HREF=\"$indexloc\" CLASS=link STYLE=\"color: #FFFFFF\">$k</A></B>";
				$contents .= ($k == 1 && $k+1 < $startindex-$maxleftright && $lastindex > 2*$maxleftright+1) ? " ..." : "";
			}
		}

		# Next Link

		if ($realstart+$limit < $max) {
			my $nextloc = $chooseloc . ($realstart+$limit);
			$contents .= " : <A HREF=\"$nextloc\" CLASS=link STYLE=\"color: #FFFFFF;\"><B>$lang->{'Next'}</B></A>";
		}

		$contents .= "</TD>";
		$contents .= "<TD BGCOLOR=#333366><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
		$contents .= "</TR>\n";
	}
	else {
		$contents .= "<TR>\n";
		$contents .= "<TD BGCOLOR=#333366><IMG SRC=\"$aimgurl/bound9.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
		$contents .= "<TD BGCOLOR=#333366 COLSPAN=$colsize ALIGN=center STYLE=\"color: #FFFFFF;\">";
		$contents .= "<TD BGCOLOR=#333366><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
		$contents .= "</TR>\n";
	}

	$contents .= "</TABLE>\n";

	return $contents;
}

sub processAnswer {
	my ($perlQ, $qanswer, $answer) = @_;
	my $processed = '';

	my (@choice1, @choice2, %hash);
	@choice1 = split(/\|\|\|/, $qanswer);
	for (my $i = 0; $i < @choice1; $i++) {
		@choice2 = split(/\|\|/, $choice1[$i]);
		my $aidletter = (substr($choice2[2],0,11) eq 'Textfield:(') ? 'O' : 'N';
		my $canswer = ($aidletter eq 'O') ? substr($choice2[2],11,-1) : $choice2[2];
		$hash{$aidletter.$choice2[1]} = $html->protectHTML($canswer);
	}

	@choice1 = split(/\|\|/, $answer);
	for(my $j = 0; $j < @choice1; $j++) {
		$processed .= $processed ? ", " : "";
		if (substr($choice1[$j],0,1) eq 'O') {
			@choice2 = split(/\|/, $choice1[$j]);
			$processed .= $choice2[1];
		}
		else { $processed .= $hash{$choice1[$j]}; }
	}

	return $processed;
}

sub printColumn {
	my ($perlQ, $sid, $columnname, $sortmethod, $sortdesc, $column) = @_;
	my $lang = $perlQ->getLanguage;
	my $aimgurl = $perlQ->getImgURL('admin/images');
	my %columnsort = ('DateCompleted' => 'date', 'EmailAddress' => 'email',
	    'IPAddress' => 'ip');
	my $colsort = $columnsort{$columnname} || '';

	my $desc = ($sortmethod eq $colsort) ? (($sortdesc eq 'a') ? 1 : 2) : 0;

	my $sortarrow = "<IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=1 HEIGHT=15 ALT=\"\">";
	if ($desc == 1) {
		$sortarrow = "<A HREF=\"choose.cgi?cs=$sid&sortmethod=$colsort&sortdesc=d\"><IMG SRC=\"$aimgurl/arrowup.gif\" WIDTH=15 HEIGHT=15 BORDER=0 ALT=\"$lang->{'AltUp'}\"></A>";
	}
	elsif ($desc == 2) {
		$sortarrow = "<A HREF=\"choose.cgi?cs=$sid&sortmethod=$colsort&sortdesc=a\"><IMG SRC=\"$aimgurl/arrowdown.gif\" WIDTH=15 HEIGHT=15 BORDER=0 ALT=\"$lang->{'AltDown'}\"></A>";
	}

	my $newsortdesc = ($sortmethod eq $colsort) ?
	    (($sortdesc eq 'a') ? 'd' : 'a') : (($column == 0) ? 'd' : 'a');
	my $sortloc = "choose.cgi?cs=$sid&sortmethod=$colsort&sortdesc=$newsortdesc";

	my $addstyle = '';
	if ($column > 0) {
		$addstyle = 'border-left: 1px #FFFFFF solid; padding-left: 2px;';
	}
	my $contents = "<TD BGCOLOR=#333366 STYLE=\"$addstyle padding-right: 2px;\">";
	$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>";
	$contents .= "<TD STYLE=\"color: white;\">";
	if ($colsort ne '') {
		$contents .= "<A HREF=\"$sortloc\" STYLE=\"color: white; text-decoration: none;\"><B>" . $html->protectHTML($lang->{$columnname}) . "</B></NOBR></A>";
	}
	else {
		$contents .= "<B>" . $html->protectHTML($columnname) . "</B>";
	}

	$contents .= "</TD>";
	$contents .= "<TD>$sortarrow</TD>";
	$contents .= "</TR></TABLE>";
	$contents .= "</TD>";

	return $contents;
}
