#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;
require "Export.cgi";

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);
$perlQ->setLanguage('', 'ADMIN');

#-->> Checking for SID and Stats Type

my $error = 0;
my %validtypes = map { $_ => 1 } qw(pex csv xml sql xml-c perlQ perlQS);

my $type = $cgi->param('tp') || 'csv';
my $sid = $cgi->param('sid') || 0;
my $stattype = $cgi->param('st') || 'a';

$type = $validtypes{$type} ? $type : 'csv';
$sid = ($sid =~ /^(\d+)$/) ? $1 : 0;
$stattype = ($stattype =~ /^(u|v|a)$/) ? $1 : 'a';


if ($sid) {
	my $query = $perlQ->getDBH->prepare("SELECT SID FROM perlQSurvey WHERE SID=?");
	if (!$query->execute($sid) || !$query->rows) {
		$error = 1;
	}
	$query->finish;
}
elsif ($type ne 'perlQ') {
	$error = 1;
}

#-->> Grabbing Downloadable Results

my $contents = '';
if (!$error) {
	if ($type eq 'perlQ' || $type eq 'perlQS') {
		my $swap = ($type eq 'perlQS') ? 1 : 0;
		my $num = $sid ? "_$sid" : '';
		my ($mday, $mon, $year) = (localtime(time))[3,4,5];
		$num .= '_' . sprintf('%04d-%02d-%02d', $year + 1900, $mon + 1, $mday);
		my $filename = ($type eq 'perlQS') ? 'surveyswap' : 'backup';
		print $cgi->header(-type => 'text/perlQ', -Pragma => 'no-cache',
		    '-Content-Disposition' => "attachment; filename=$filename$num\.perlQ");
		&backupAllData($perlQ, $sid, $swap);
	}
	elsif ($type eq 'pex') {
		$contents = &grabStats($perlQ, $sid, $stattype, $type);
		print $cgi->header(-type => 'application/vnd.ms-excel', -Pragma => 'no-cache',
		    '-Content-Length' => length($contents));
		print $contents;
	}
	elsif ($type eq 'xml' || $type eq 'xml-c' || $type eq 'sql' || $type eq 'csv') {
		my $ext = ($type eq 'xml-c') ? 'xml' : $type;
		print $cgi->header(-type => "text/$ext", -Pragma => 'no-cache',
		    '-Content-Disposition' => "attachment; filename=results_$sid\.$ext");
		&formatSurveyData($perlQ, $sid, $stattype, $type);
	}
	else {
		print $cgi->header(-status => '204 No Response');
	}
}
else {
	print $cgi->header(-status => '204 No Response');
}
$perlQ->exit;
