#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1, -redirecterror => 0);
my $cgi = $perlQ->getCGI;
my $html = $perlQ->getHTML;

#-->> GET and POST Variables

my $hd = $perlQ->getHTML->protectHTML($cgi->param('hd') || '');
my $loc = quotemeta($cgi->param('loc') || '');
$loc =~ s/[^\w]//g;

my %languages = $perlQ->getLanguages('HELP');
my $language = $perlQ->getAdminField('AdminLanguage');
if (!defined $languages{$language}) {
	if (defined $languages{'english'}) { $language = 'english'; }
	else { foreach my $lang (keys %languages) { $language = $lang; last; } }
}
my $helpfile = $perlQ->getFilePath("languages/$language/help/$loc.html");

$perlQ->setLanguage($language);
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;

if (!(-r "$helpfile") || !defined $lang->{$hd}) {
	$html->redirect('-url' => 'popuperror.cgi?errormsg=NoHelpFile');
}

open(F, "$helpfile");
my $helpdata = join('', <F>);
close(F);

my $contents = <<"END HELP";
  <TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
  <TR>
   <TD><IMG SRC="$imgurl/headinghelp.gif" WIDTH=61 HEIGHT=21 ALT="$lang->{'perlQHelp'}"></TD>
   <TD ALIGN=right><B>$lang->{$hd}</B>&nbsp;&nbsp;</TD>
  </TR>
  </TABLE>

  $helpdata

  <CENTER><BR><FORM>
    <INPUT TYPE=button ONCLICK="window.close();" VALUE="$lang->{'Close'}">
  </FORM></CENTER>
END HELP

open(T, $perlQ->getFilePath('admin/poptemplate.html'));
my $templatedata = join('', <T>);
close(T);

my $aurl = $perlQ->getImgURL('admin');
$templatedata =~ s/SRC="images\//SRC="$aurl\/images\//g;
$templatedata =~ s/HREF="template.css"/HREF="$aurl\/template.css"/g;

$templatedata =~ s/::SURVEYNAME::/$lang->{'perlQHelp'} :: $lang->{$hd}/g;
$templatedata =~ s/::CHARSET::/$lang->{'CHARSET'}/g;
$templatedata =~ s/::CONTENT::/$contents/g;

print $cgi->header;
print $templatedata;
$perlQ->exit;
