#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1, -redirecterror => 0);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Logging In

$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;

my $errormsg = $cgi->param('errormsg') || '';
if (defined $lang->{$errormsg}) {
	$html->setMessage($lang->{$errormsg});
}

my $errormessage = '';
if ($html->getMessage) {
	$errormessage = "<TR><TD ALIGN=center STYLE=\"color: red;\"><B>$lang->{'ErrorMessage'}:</B> ".$html->getMessage."</TD></TR>";
	$html->setMessage('');
}

if (!$errormessage) {
	if ($cgi->param('logoff')) { $perlQ->logout; }

	if (defined $cgi->param('perlQpasswd')) { $perlQ->login; }

	if ($perlQ->isAdmin) {
		$html->redirect('-url' => 'main.cgi');            
	}
}

#-->> Login Box

my $contents = <<"END";

<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
<FORM NAME=login ACTION=index.cgi METHOD=POST>
<TR>
	<TD ALIGN=center><IMG SRC="$imgurl/headinglogin.gif" WIDTH=73 HEIGHT=22 ALT="$lang->{'LoginTitle'}"></TD>
</TR>
<TR>
	<TD ALIGN=center>$lang->{'LoginPrompt'}</TD>
</TR>
$errormessage
<TR>
	<TD ALIGN=center>
	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
	<TR>
		<TD><B>$lang->{'Password'}:</B></TD>
		<TD><INPUT TYPE=password NAME=perlQpasswd CLASS=medium></TD>
		<TD><INPUT TYPE=submit VALUE="$lang->{'Login'}"></TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</FORM>
</TABLE>

<BR><BR>

END

open(JS, $perlQ->getFilePath('perlQMod/jslogin.txt'));
my $jsinfo = join('', <JS>);
close(JS);

#-->> Output Page

$perlQ->getHTML->createPage('login', "$lang->{'AdminTitle'} :: $lang->{'LoginTitle'}", $contents, 1, $jsinfo);
