#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);
$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');

# Perform some security checks to make sure users are taking care of themselves.
if (-e $perlQ->getFilePath('install.cgi')) {
	$html->setMessage("<b>$lang->{'SecurityAlert'}:</b> $lang->{'SecurityInstall'}");
}

my $query = $dbh->prepare("SELECT 1 FROM perlQAdmin WHERE Passwd='password'");
if ($query->execute && $query->rows) {
	$html->setMessage("<b>$lang->{'SecurityAlert'}:</b> $lang->{'SecurityPassword'}");
}
$query->finish;

my $cs = ($cgi->param('cs') || 0 =~ /^(\d+)$/) ? $1 : 0;

#-->> Content

my $version = $perlQ->getVersion;
my $contents = <<"END";

<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=600>
<TR><TD WIDTH=48></TD><TD WIDTH=500></TD><TD WIDTH=48></TD>
<TR>
	<TD>&nbsp;</TD>
	<TD COLSPAN=2><TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%><TR>
		 <TD><IMG SRC="$imgurl/headingoverview.gif" WIDTH=107 HEIGHT=22 ALT="$lang->{'OverviewTitle'}"></TD>
		 </TR></TABLE></TD>
</TR>
<TR><TD COLSPAN=3>&nbsp;</TD></TR>
<TR>
	<TD>&nbsp;</TD>
	<TD ALIGN=center>
	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>

END

my $scriptloc = $cgi->url;
if ($scriptloc =~ m#^(.*)/[^/]+/[^/]+$#) { $scriptloc = $1; }

$query = $dbh->prepare("SELECT *, DATE_FORMAT(StartDate, '$lang->{'MySQLDateFormat'}') as FStartDate, DATE_FORMAT(EndDate, '$lang->{'MySQLDateFormat'}') as FEndDate, (now() < StartDate) as Pending, (now() > EndDate) as Expired FROM perlQSurvey ORDER BY Active, Name");
$query->execute;
for (my $i = 0; $i < $query->rows; $i++) {
	my $masurvey = $query->fetchrow_hashref;

	my $responsect = 0;
	my $rquery = $dbh->prepare("SELECT COUNT(*) FROM perlQUser WHERE SID=?");
	if ($rquery->execute($masurvey->{'SID'}) && $rquery->rows) {
		$responsect = ($rquery->fetchrow_array)[0];
	}
	$rquery->finish;

	my $responsemsg = ($responsect == 1) ? $lang->{'response'} : $lang->{'responses'};
	$responsemsg = sprintf($responsemsg, $responsect);

	my $responseloc = "(<A HREF=\"choose.cgi?cs=$masurvey->{'SID'}\" CLASS=link STYLE=\"color: #336699;\">$responsemsg</A>)";

	my $editloc = "<A HREF=\"survey.cgi?cs=$masurvey->{'SID'}\" STYLE=\"color: #336699;\"><IMG SRC=\"$imgurl/edit.gif\" WIDTH=51 HEIGHT=15 BORDER=0 ALT=\"$lang->{'Edit'}\"></A>";

	my $surveyloc = "$scriptloc/fillsurvey.cgi?sid=$masurvey->{'SID'}";
	my $previewloc = "<A HREF=\"$surveyloc&action=preview\" CLASS=link TARGET=_new STYLE=\"color: #336699;\"><IMG SRC=\"$imgurl/preview.gif\" WIDTH=80 HEIGHT=15 BORDER=0 ALT=\"$lang->{'Preview'}\"></A>";

	my $svname = (length($masurvey->{'Name'}) > 30) ? substr($masurvey->{'Name'},0,30)."..." : $masurvey->{'Name'};

	my ($activeimg,$activebtn) = ('','');
	if ($masurvey->{'Active'} eq 'y') {
		if ($masurvey->{'Pending'} && substr($masurvey->{'StartDate'},0,10) ne "0000-00-00") {
			$activeimg = "<IMG SRC=\"$imgurl/textpending.gif\" WIDTH=58 HEIGHT=13 ALT=\"$lang->{'Pending'}\">";
			$activebtn = "<IMG SRC=\"$imgurl/buttonpending.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
		}
		elsif ($masurvey->{'Expired'} && substr($masurvey->{'EndDate'},0,10) ne "0000-00-00") {
			$activeimg = "<IMG SRC=\"$imgurl/textexpired.gif\" WIDTH=58 HEIGHT=13 ALT=\"$lang->{'Expired'}\">";
			$activebtn = "<IMG SRC=\"$imgurl/buttonpending.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
		}
		else {
			$activeimg = "<IMG SRC=\"$imgurl/textactive.gif\" WIDTH=46 HEIGHT=13 ALT=\"$lang->{'Active'}\">";
			$activebtn = "<IMG SRC=\"$imgurl/buttonactive.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
		}
	}
	else {
		$activeimg = "<IMG SRC=\"$imgurl/textnotactive.gif\" WIDTH=79 HEIGHT=13 ALT=\"$lang->{'NotActive'}\">";
		$activebtn = "<IMG SRC=\"$imgurl/buttondeactive.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
	}

	my $editorloc = "<A HREF=\"$surveyloc\" CLASS=link TARGET=_new STYLE=\"color: #6699CC;\">$svname</A>";

	$contents .= "<TR>";
	$contents .= "<TD ALIGN=right>$activeimg</TD><TD>$activebtn</TD>";
	$contents .= "<TD>";
	$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%><TR>";
	$contents .= "<TD STYLE=\"color: #6699CC; font-size: 12px;\"><NOBR><B>$editorloc</B></NOBR></TD>";
	$contents .= "<TD><NOBR>$responseloc</NOBR></TD>";
	$contents .= "<TD WIDTH=100% ALIGN=right>$editloc</TD><TD>$previewloc</TD>";
	$contents .= "</TR></TABLE>";
	$contents .= "</TD>";
	$contents .= "</TR>";
	if ($masurvey->{'Description'}) {
		$contents .= "<TR>";
		$contents .= "<TD COLSPAN=2 ALIGN=right VALIGN=top><NOBR><B>$lang->{'Description'}</B>:</NOBR></TD>";
		$contents .= "<TD>$masurvey->{'Description'}</TD>";
		$contents .= "</TR>";
	}
	my $sdtest = (substr($masurvey->{'StartDate'},0,10) ne "0000-00-00") ? 1 : 0;
	my $edtest = (substr($masurvey->{'EndDate'},0,10) ne "0000-00-00") ? 1 : 0;
	if ($masurvey->{'Active'} eq 'y' && ($sdtest || $edtest)) {
		$contents .= "<TR>";
		$contents .= "<TD COLSPAN=2 ALIGN=right><NOBR><B>$lang->{'ActiveDates'}</B>:</NOBR></TD>";
		if ($sdtest && !$edtest) {
			$contents .= "<TD>".sprintf($lang->{'StartsOn'}, $masurvey->{'FStartDate'})."</TD>";
		}
		elsif (!$sdtest && $edtest) {
			$contents .= "<TD>".sprintf($lang->{'EndsOn'}, $masurvey->{'FEndDate'})."</TD>";
		}
		else {
			$contents .= "<TD>".sprintf($lang->{'RunsBetween'}, $masurvey->{'FStartDate'}, $masurvey->{'FEndDate'})."</TD>";
		}
		$contents .= "</TR>";
	}

	if ($masurvey->{'Active'} eq 'y') {
		$contents .= "<TR>";
		$contents .= "<TD COLSPAN=2 ALIGN=right><NOBR><B>$lang->{'LinktoSurvey'}</B>:</NOBR></TD>";
		$contents .= "<TD><A HREF=\"$surveyloc\" TARGET=_new CLASS=link>$surveyloc</A></TD>";
		$contents .= "</TR>";

		if ($masurvey->{'SurveyResults'}) {
			my $statsloc = "$scriptloc/stats.cgi?sid=$masurvey->{'SID'}";
	 		$contents .= "<TR>";
	 		$contents .= "<TD COLSPAN=2 ALIGN=right><NOBR><B>$lang->{'PublicResults'}</B>:</NOBR></TD>";
	 		$contents .= "<TD><A HREF=\"$statsloc\" TARGET=_new CLASS=link>$statsloc</A></TD>";
	 		$contents .= "</TR>";
		}
	}

	$contents .= "<TR><TD COLSPAN=3>";
	$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%><TR>";
	$contents .= "<TD BACKGROUND=\"$aimgurl/border.gif\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=100 HEIGHT=1 ALT=\"\"></TD>";
	$contents .= "</TR></TABLE>";
	$contents .= "</TD></TR>\n";
}
$query->finish;

$contents .= <<"END";

	</TABLE>
	</TD>
	<TD>&nbsp;</TD>
</TR>
</TABLE>

END

#-->> Output Page

$perlQ->getHTML->createPage('main', "$lang->{'AdminTitle'} :: $lang->{'OverviewTitle'}", $contents, 1, '', $cs);
