#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);

#-->> Setting Variables

my $cq = $cgi->param('cq') || '';
my $cs = $cgi->param('cs') || 0;
my $action = $cgi->param('action') || '';
my $next = $cgi->param('next') || 0;
my $sortorder = $cgi->param('sortorder') || '';
my $qid = $cgi->param('qid') || 0;
my $fsubmit = $cgi->param('fsubmit') || '';

my $qQAsked = $cgi->param('questionasked') || '';
my $qQType = $cgi->param('type') || '';
my $qARequired = $cgi->param('required') || '';
my $qSSize = $cgi->param('mult') || '';
my $qQInstructions = $cgi->param('instructions') || '';
my $qQStyle = $cgi->param('questionstyle') || '';
my $qDAnswer = $cgi->param('defaultanswer') || '';
my $qAChoices = $cgi->param('answer') || '';
my $qCNumber = $cgi->param('colnumb') || '';
my $qAControl = $cgi->param('control') || '';
my $qACount = $cgi->param('answercount') || '';
my $qAStyle = $cgi->param('answertextstyle') || '';
my $qAIStyle = $cgi->param('answerinputstyle') || '';
my $qIStyle = $cgi->param('answerstyle') || '';
my $qIAttributes = $cgi->param('attributes') || '';
my $qSDisplay = $cgi->param('summary') || '';

#-->> Setting Interface in Advance

my $advance = 'n';
my $query;
if ($cs) {
	$query = $dbh->prepare("SELECT AdvanceInterface FROM perlQSurvey WHERE SID=?");
	if ($query->execute($cs) && $query->rows) {
		$advance = (($query->fetchrow_array)[0] eq 'y') ? 'y' : 'n';
	}
	$query->finish;
}

my $localadvance = $cgi->param('localadvance') || '';
if ($localadvance =~ /^(y|n)$/) { $advance = $1; }

#-->> Determining the Largest ID for Question Types radio, checkbox, select
#     and selectmult when Add/Modifying

my $largestid = 0;
if ($qAChoices && ($qQType eq 'radio' || $qQType eq 'checkbox' || $qQType eq 'select' || $qQType eq 'selectmult')) {
	my @choicearray = split(/\|\|\|/, $qAChoices);
	for (my $i = 0; $i < @choicearray; $i++) {
		my @parts = split(/\|\|/, $choicearray[$i]);
		if (@parts == 5) {
			$largestid = ($parts[1] > $largestid) ? $parts[1] : $largestid;
		}
	}
}

#-->> Add, Modify, Sort or Delete Question

my $message = '';
if ($action eq 'add') {
	if (($qQType ne 'checkbox' && $qQType ne 'selectmult') ||
      ($qAControl && &checkACount($qAControl, $qAChoices, $qACount))) {
		my $choose = "$qAControl:$qACount";
		if ($qQType eq 'textfield' || $qQType eq 'textarea' || $qQType eq 'htmlcontent' || ($qAChoices && &validateQAnswer($qAChoices))) {
			my @ifields = qw(SID SortOrder Question Type Mult DefaultAnswer Attributes QuestionStyle Answer AnswerTextStyle AnswerInputStyle AnswerStyle Required ColNumb Choose Summary Instructions);
			my @ivalues = ($cs, $next, $qQAsked, $qQType, $qSSize, $qDAnswer, $qIAttributes, $qQStyle, $qAChoices, $qAStyle, $qAIStyle, $qIStyle, $qARequired, $qCNumber, $choose, $qSDisplay, $qQInstructions);

			if ($largestid > 0) {
				push(@ifields, 'LargestAID');
				push(@ivalues, $largestid);
			}

			eval {
				$dbh->do("INSERT INTO perlQQuestion (QID," . join(',', @ifields) . ") VALUES (NULL," . join(',', map { '?' } @ivalues) . ")", undef, @ivalues);
				$message = $lang->{'AddQuestionSuccess'};
				$cq = $qQAsked = $qQType = $qARequired = $qSSize = $qQInstructions = $qQStyle = $qDAnswer = $qAChoices = $qCNumber = $qAControl = $qACount = $qAStyle = $qAIStyle = $qIStyle = $qIAttributes = $qSDisplay = "";
			};

			if ($@) { $message = $lang->{'AddQuestionError'}; }
		}
		else { $message = $lang->{'InvalidAnswerChoices'}; }
	}
	else { $message = $lang->{'InvalidNumberChoices'}; }

	eval {
		$dbh->do("UPDATE perlQSurvey SET AdvanceInterface=? WHERE SID=?", undef, $advance, $cs);
	};
}
elsif ($action eq 'modify') {
	my $modifyid = $cgi->param('modifyid') || 0;
	if ($modifyid) {
		if (($qQType ne 'checkbox' && $qQType ne 'selectmult') ||
			  ($qAControl && &checkACount($qAControl, $qAChoices, $qACount))) {
			my $choose = "$qAControl:$qACount";
			if ($qQType eq 'textfield' || $qQType eq 'textarea' || $qQType eq 'htmlcontent' || ($qAChoices && &validateQAnswer($qAChoices))) {
				my @mfields = qw(Type Question Answer Required Mult Choose Summary);
				my @mvalues = ($qQType, $qQAsked, $qAChoices, $qARequired, $qSSize,
				    $choose, $qSDisplay);

				if ($advance eq 'y') {
					push(@mfields, qw(Attributes QuestionStyle AnswerTextStyle
					    AnswerInputStyle DefaultAnswer AnswerStyle Instructions ColNumb));
					push(@mvalues, $qIAttributes, $qQStyle, $qAStyle, $qAIStyle,
					    $qDAnswer, $qIStyle, $qQInstructions, $qCNumber);
				}
				elsif ($qQType eq 'htmlcontent') {
					push(@mfields, 'Instructions');
					push(@mvalues, $qQInstructions);
				}

				if ($largestid > 0) {
					push(@mfields, 'LargestAID');
					push(@mvalues, $largestid);
				}
				
				eval {
					$dbh->do("UPDATE perlQQuestion SET " . join(',', map { $_ . '=?' } @mfields) . "WHERE QID=?", undef, @mvalues, $modifyid);
					$cq = $modifyid;
					$message = $lang->{'ModifyQuestionSuccess'};
				};
				
				if ($@) { $message = $lang->{'ModifyQuestionError'}; }
			}
			else { $message = $lang->{'InvalidAnswerChoices'}; }
		}
		else { $message = $lang->{'InvalidNumberChoices'}; }
	}

	eval {
		$dbh->do("UPDATE perlQSurvey SET AdvanceInterface=? WHERE SID=?", undef, $advance, $cs);
	};
}
elsif ($action eq 'delete') {
	my $deleteid = $cgi->param('deleteid') || 0;
	if ($deleteid) {
		$query = $dbh->prepare("SELECT SID,SortOrder FROM perlQQuestion WHERE QID=?");
		if ($query->execute($deleteid) && $query->rows) {
			my ($sid,$sortorder) = $query->fetchrow_array;
			
			eval {
				$dbh->do("LOCK TABLES perlQAnswer WRITE,perlQQuestion WRITE");
				$dbh->do("DELETE FROM perlQAnswer WHERE QID=?", undef, $deleteid);
				$dbh->do("DELETE FROM perlQQuestion WHERE QID=?", undef, $deleteid);

				if ($sortorder && $sid) {
					$dbh->do("UPDATE perlQQuestion SET SortOrder=(SortOrder-1) WHERE SortOrder>? AND SID=?", undef, $sortorder, $sid);
				}
				$message = $lang->{'DeleteQuestionSuccess'};
			};

			if ($@) { $message = $lang->{'DeleteQuestionError'}; }

			eval {
				$dbh->do("UNLOCK TABLES");
			};
		}
		else { $message = $lang->{'DeleteQuestionError'}; }
		$query->finish;
	}
}
elsif ($action eq 'store') {
	if ($sortorder) {
		eval {
			$dbh->do("DELETE FROM perlQQuestion WHERE SID=? AND Type='pagebreak'", undef, $cs);
		};

		my @orderarray = split(/\|\|/, $sortorder);
		my $success;
		for (my $i = 1; $i <= @orderarray; $i++) {
			if ($orderarray[$i-1] eq 'pagebreak') {
				eval {
					$dbh->do("INSERT INTO perlQQuestion (SID, QID, Type, SortOrder, Question) VALUES (?, NULL, 'pagebreak', ?, '<<----| $lang->{'PageBreak'} |---->>')", undef, $cs, $i);
				};
			}
			else {
				eval {
					$dbh->do("UPDATE perlQQuestion SET SortOrder=? WHERE QID =?", undef, $i, $orderarray[$i-1]);
				};
			}

			if ($@) { $message = $lang->{'StoreQuestionError'}; }
		}

		if (!$message) { $message = $lang->{'StoreQuestionSuccess'}; }
	}
}

if ($message) { $html->setMessage("<B>$lang->{'Status'}:</B> $message"); }

my $types = [['radio', $lang->{'radio'}], ['checkbox', $lang->{'checkbox'}],
    ['textfield', $lang->{'textfield'}], ['textarea', $lang->{'textarea'}],
    ['select', $lang->{'select'}], ['selectmult', $lang->{'selectmult'}],
		['htmlcontent', $lang->{'htmlcontent'}]];
my $choosearray = [[$lang->{'AnyNumber'}, 'a'], [$lang->{'Exactly'}, 'e'], [$lang->{'AtLeast'}, 'l'], [$lang->{'AtMost'}, 'm']];
my $advancearray = [[$lang->{'Basic'}, 'n'], [$lang->{'Advanced'}, 'y']];
my $required = [['y', $lang->{'Yes'}], ['n', $lang->{'No'}]];

my $tsurveyname = '';
if ($cs) {
	$query = $dbh->prepare("SELECT Name FROM perlQSurvey WHERE SID=?");
	if ($query->execute($cs) && $query->rows) {
		my $masurvey = $query->fetchrow_hashref;
		$tsurveyname = (length($masurvey->{'Name'}) > 65) ? substr($masurvey->{'Name'},0,65)."..." : $masurvey->{'Name'};
	}
	else {
		$html->redirect(-url => "survey.cgi");
	}
	$query->finish;
}
else {
	$html->redirect(-url => "survey.cgi");
}

$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? ORDER BY SortOrder");
$query->execute($cs);
my $tcount = 0;
my @questionlist;
my $cquestion;
for (my $i = 0; $i < $query->rows; $i++) {
	my $maquestion = $query->fetchrow_hashref;
	push(@questionlist, $maquestion);
	if ($cq == $maquestion->{'QID'}) {
		$cquestion = $maquestion;
		$largestid = $maquestion->{'LargestAID'};
	}
	$tcount++;
}
$query->finish;
$tcount++;

my $iQAsked = $html->protectHTML($qQAsked || $cquestion->{'Question'});
my $iQType = $html->protectHTML($qQType || $cquestion->{'Type'} || 'radio');
my $iARequired = $html->protectHTML($qARequired || $cquestion->{'Required'});
my $iSSize = $html->protectHTML($qSSize || $cquestion->{'Mult'} || 3);
my $iQInstructions = $html->protectHTML($qQInstructions || $cquestion->{'Instructions'});
my $iQStyle = $html->protectHTML($qQStyle || $cquestion->{'QuestionStyle'});
my $iDAnswer = $html->protectHTML($qDAnswer || $cquestion->{'DefaultAnswer'});
my $iAChoices = $html->protectHTML($qAChoices || $cquestion->{'Answer'});
my $iCNumber = $html->protectHTML($qCNumber || $cquestion->{'ColNumb'} || 1);

my ($iAControl, $iACount) = split(/:/, $cquestion->{'Choose'});
if ($qAControl && $qACount)
{
	$iAControl = $html->protectHTML($qAControl);
	$iACount = $html->protectHTML($qACount);
}

my $iAStyle = $html->protectHTML($qAStyle || $cquestion->{'AnswerTextStyle'});
my $iAIStyle = $html->protectHTML($qAIStyle || $cquestion->{'AnswerInputStyle'});
my $iIStyle = $html->protectHTML($qIStyle || $cquestion->{'AnswerStyle'});
my $iIAttributes = $html->protectHTML($qIAttributes || $cquestion->{'Attributes'});
my $iSDisplay = $html->protectHTML($qSDisplay || $cquestion->{'Summary'} || 'n');

my $contents = <<"END";

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
<FORM NAME=questionlist ACTION="question.cgi" METHOD=POST>
<TR>
	<TD COLSPAN=4><IMG SRC="$imgurl/headingquestion1.gif" WIDTH=115 HEIGHT=18 ALT="$lang->{'ListofQuestions'}"></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'CurrentSurvey'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('q_survey', 'CurrentSurvey')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>
		<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%><TR>
		<TD><A HREF="survey.cgi?cs=$cs" CLASS=link>$tsurveyname</A></TD>
		<TD ALIGN=right><A HREF="../fillsurvey.cgi?sid=$cs&action=preview" TARGET=_blank><IMG SRC="$imgurl/preview.gif" WIDTH=80 HEIGHT=15 BORDER=0 ALT="$lang->{'Preview'}"></A></TD>
		</TR></TABLE>
	</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'Questions'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('q_order', 'Questions')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=choosequestion CLASS=huge SIZE=10>

END

if (@questionlist) {
	for (my $i = 0; $i < @questionlist; $i++) {
		my $listedq = $questionlist[$i]->{'Question'};
		if (length($listedq) > 60) { $listedq = substr($listedq, 0, 60) . '...'; }
		$listedq = $html->protectHTML($listedq);

		if ($questionlist[$i]->{'Type'} ne 'pagebreak') {
			my $selected = ($questionlist[$i]->{'QID'} eq $cq) ? " SELECTED" : "";
			$contents .= "<OPTION$selected VALUE=$questionlist[$i]->{'QID'}>$listedq";
		}
		else { $contents .= "<OPTION VALUE=\"pagebreak\">$listedq"; }
	}
}
else {
	$contents .= "<OPTION VALUE=\"-1\">$lang->{'NoQuestions'}";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD VALIGN=middle>
	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
	<TR><TD><A HREF="javascript:MoveUp()"><IMG SRC="$aimgurl/buttonup.gif" WIDTH=15 HEIGHT=30 BORDER=0 ALT="$lang->{'AltUp'}"></A></TD></TR>
	<TR><TD><A HREF="javascript:MoveDown()"><IMG SRC="$aimgurl/buttondown.gif" WIDTH=15 HEIGHT=30 BORDER=0 ALT="$lang->{'AltDown'}"></A></TD></TR>
	</TABLE>
	</TD>
</TR>
<TR>
	<TD WIDTH=135 COLSPAN=2></TD>
	<TD COLSPAN=2><INPUT TYPE=button ONCLICK="ChangeQuestion()" VALUE="$lang->{'Edit'}">
		<INPUT TYPE=button ONCLICK="DeleteQuestion()" VALUE="$lang->{'Delete'}">
		<INPUT TYPE=button ONCLICK="AddPageBreak()" VALUE="$lang->{'AddPageBreak'}">
		<INPUT TYPE=button ONCLICK="StoreOrder()" VALUE="$lang->{'SaveOrder'}">
		<INPUT TYPE=button ONCLICK="PreviewQuestion($cs)" VALUE="$lang->{'Preview'}"></TD>
</TR>
<INPUT TYPE=hidden NAME=action VALUE="">
<INPUT TYPE=hidden NAME=deleteid VALUE="">
<INPUT TYPE=hidden NAME=sortorder VALUE="">
<INPUT TYPE=hidden NAME=cs VALUE="$cs">
<INPUT TYPE=hidden NAME=qid VALUE="$cq">
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 ID=AddLoc>
<FORM NAME=addquestion ACTION="question.cgi" METHOD=POST>
<TR>
	<TD COLSPAN=4>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
	<TR>
		<TD><IMG SRC="$imgurl/headingquestion2.gif" WIDTH=147 HEIGHT=22 ALT="$lang->{'AddModifyAQuestion'}"></TD>
	  <TD ALIGN=center><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD><TD>&nbsp;$lang->{'RequiredField'}</TD></TR></TABLE></TD>
		<TD ALIGN=right><B>$lang->{'Interface'}:</B> <SELECT NAME=localadvance ONCHANGE="ChangeInterface()">

END

for (my $i = 0; $i < @$advancearray; $i++) {
	my $selected = ($advance eq $advancearray->[$i][1]) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$advancearray->[$i][1]\">$advancearray->[$i][0]";
}

my ($qlabel,$qhelpfile) = ('Question','q_question');
if ($iQType eq 'htmlcontent') {
	($qlabel,$qhelpfile) = ('ContentName','q_contentname');
}
$contents .= <<"END";

			</SELECT></TD>
	</TR>
	</TABLE>
	</TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{$qlabel}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('$qhelpfile', '$qlabel')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=questionasked CLASS=huge VALUE="$iQAsked"></TD>
	<TD ALIGN=center><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'Type'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_type', 'Type')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=type CLASS=large ONCHANGE="TypeCheck()">

END

for (my $i=0; $i < @$types; $i++) {
	my $selected = ($iQType eq $types->[$i][0]) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$types->[$i][0]\">$types->[$i][1]";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD ALIGN=center><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD>
</TR>

END

if ($iQType ne 'htmlcontent') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'Required'}$lang->{'?'}</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_required', 'Required')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=required>

END

	for (my $j=0; $j < @$required; $j++) {
		my $selected = ($required->[$j][0] eq $iARequired) ? " SELECTED" : "";
		$contents .= "<OPTION$selected VALUE=\"$required->[$j][0]\">$required->[$j][1]";
	}

	$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>

END
}

if ($iQType eq 'selectmult') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SelectSize'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_selectsize', 'SelectSize')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=mult CLASS=medium VALUE="$iSSize"></TD>
	<TD ALIGN=center><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD>
</TR>

END
}

if ($advance eq 'y' || $iQType eq 'htmlcontent') {
	my ($ilabel,$ihelpfile,$ireq) = ('QuestionInstructions','q_instructions','');
	if ($iQType eq 'htmlcontent') {
		($ilabel,$ihelpfile,$ireq) = ('HTMLContent','q_htmlcontent',
		  "<IMG SRC=\"$imgurl/star.gif\" WIDTH=11 HEIGHT=11 ALT=\"$lang->{'*'}\">");
	}
	$contents .= <<"END";

<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{$ilabel}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('$ihelpfile', '$ilabel')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=instructions WRAP=physical>$iQInstructions</TEXTAREA></TD>
	<TD VALIGN=top>$ireq</TD>
</TR>

END
}

if ($advance eq 'y' && $iQType ne 'htmlcontent') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'QuestionTextStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_qstyle', 'QuestionTextStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=questionstyle CLASS=huge VALUE="$iQStyle"></TD>
	<TD></TD>
</TR>

END
}

if ($iQType eq "radio" || $iQType eq "checkbox" || $iQType eq "select" || $iQType eq "selectmult") {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'AnswerChoices'}:</B></NOBR></TD>
	<INPUT TYPE=hidden NAME=answer VALUE="$iAChoices">
	<TD VALIGN=top><A HREF="javascript:perlQHelp('q_answers', 'AnswerChoices')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=answeroptions CLASS=huge SIZE=10 ONCHANGE="ChangeChoice()"></SELECT></TD>
	<TD>
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR><TD ALIGN=center><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD></TR>
		<TR><TD HEIGHT=110 VALIGN=middle>
			<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
			<TR><TD><A HREF="javascript:MoveUpW()"><IMG SRC="$aimgurl/buttonup.gif" WIDTH=15 HEIGHT=30 BORDER=0 ALT="$lang->{'AltUp'}"></A></TD></TR>
			<TR><TD><A HREF="javascript:MoveDownW()"><IMG SRC="$aimgurl/buttondown.gif" WIDTH=15 HEIGHT=30 BORDER=0 ALT="$lang->{'AltDown'}"></A></TD></TR>
			</TABLE></TD></TR>
		</TABLE>
	</TD>
</TR>
<TR>
	<TD COLSPAN=2></TD>
	<TD>
		<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
		<TR>

END

my $typeclass = ($iQType eq "select" || $iQType eq "selectmult") ? 2 : 1;

	$contents .= <<"END";
			<TD><INPUT TYPE=text NAME=newanswer CLASS=wizard$typeclass ONFOCUS="ClearFieldW(0)" VALUE="$lang->{'AnswerChoicePrompt'}"></TD>
			<TD ALIGN=right>
			<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
			<TR>
END

	if ($iQType eq "select" || $iQType eq "selectmult") {
		$contents .= <<"END";

				<TD><INPUT TYPE=checkbox NAME=selectable CHECKED ONCLICK="UpdateChoice(false)"></TD>
				<TD>$lang->{'AnswerChoiceSelectable'}</TD>

END
	}
		$contents .= <<"END";

				<TD><INPUT TYPE=checkbox NAME=dselect ONCLICK="UpdateChoice(true)"></TD>
				<TD>$lang->{'AnswerChoiceSelected'}</TD>
			</TR>
			</TABLE>
			</TD>
		</TR>
		</TABLE>
	</TD>
	<TD></TD>
</TR>
<TR>
	<TD COLSPAN=2>
	<TD><NOBR><INPUT TYPE=button ONCLICK="AddAnswer(false)" VALUE="$lang->{'AddAnswer'}">
		<INPUT TYPE=button ONCLICK="AddAnswer(true)" VALUE="$lang->{'AddTextfield'}">
		<INPUT TYPE=button ONCLICK="ModifyW()" VALUE="$lang->{'Modify'}">
		<INPUT TYPE=button ONCLICK="DeleteAnswer()" VALUE="$lang->{'Delete'}"></NOBR></TD>
	<TD></TD>
</TR>

END
}
elsif ($iQType ne 'htmlcontent') {
	if ($advance eq 'y') {
		if ($iQType eq "textarea") {
			$contents .= <<"END";

<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'DefaultAnswer'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('q_defaultanswer', 'DefaultAnswer')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=defaultanswer CLASS=huge>$iDAnswer</TEXTAREA></TD>
	<TD></TD>
</TR>

END
		}
		else {
			$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>Default Answer:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_defaultanswer', 'Default Answer')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=defaultanswer CLASS=huge VALUE="$iDAnswer"></TD>
	<TD></TD>
</TR>

END
		}
	}
}

if ($iQType eq "checkbox" || $iQType eq "selectmult") {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'NumberofAnswers'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_numanswers', 'NumberofAnswers')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=control>

END

	for (my $j=0; $j < @$choosearray; $j++) {
		my $selected = ($iAControl eq $choosearray->[$j][1]) ? " SELECTED" : "";
		$contents .= "<OPTION$selected VALUE=\"$choosearray->[$j][1]\">$choosearray->[$j][0]";
	}

	$contents .= <<"END";

		</SELECT>
		<INPUT TYPE=text NAME=answercount CLASS=small VALUE="$iACount">
		</TD>
	<TD></TD>
</TR>

END
}

if ($iQType eq "radio" || $iQType eq "checkbox") {
	if ($advance eq 'y') {
		$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'NumberofColumns'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_numcolumns', 'NumberofColumns')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=colnumb CLASS=medium VALUE="$iCNumber"></TD>
	<TD></TD>
</TR>

END
	}
}

if ($advance eq 'y' && $iQType ne 'htmlcontent') {
	$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AnswerInputStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_astyle', 'AnswerInputStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answerinputstyle CLASS=huge VALUE="$iAIStyle"></TD>
	<TD></TD>
</TR>
END

	if ($iQType ne 'textarea' && $iQType ne 'textfield') {
		$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AnswerTextStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_astyle', 'AnswerTextStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answertextstyle CLASS=huge VALUE="$iAStyle"></TD>
	<TD></TD>
</TR>
END
	}

	$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'TextInputStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_istyle', 'TextInputStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answerstyle CLASS=huge VALUE="$iIStyle"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'TextInputAttributes'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_textatt', 'TextInputAttributes')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=attributes CLASS=huge VALUE="$iIAttributes"></TD>
	<TD></TD>
</TR>

END
}

if ($iQType ne 'htmlcontent') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'DisplayinSummary'}$lang->{'?'}</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('q_summary', 'DisplayinSummary')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=summary>

END

	for (my $j=0; $j < @$required; $j++) {
		my $done = 0;
		my $optext = $required->[$j][0];
		if ($optext eq $iSDisplay) { $done = 1; }
		my $selected = ($optext eq $iSDisplay || (!$done && $optext eq 'n')) ? " SELECTED" : "";
		$contents .= "<OPTION$selected VALUE=\"$optext\">$required->[$j][1]";
	}

	$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>

END
}

my $addbutton = "<INPUT TYPE=button ONCLICK=\"AddModifyQuestion(0)\" VALUE=\"$lang->{'AddQuestion'}\">";
my $modbutton = $cq ? "<INPUT TYPE=button ONCLICK=\"AddModifyQuestion(1)\" VALUE=\"$lang->{'ModifyQuestion'}\">" : "";

$contents .= <<"END";

<TR>
	<TD WIDTH=135 COLSPAN=2></TD>
	<TD COLSPAN=2>$addbutton $modbutton
		<INPUT TYPE=button ONCLICK="ClearForm($cs)" VALUE="$lang->{'ClearForm'}"></TD>
</TR>
<INPUT TYPE=hidden NAME=action VALUE="">
<INPUT TYPE=hidden NAME=modifyid VALUE="$cq">
<INPUT TYPE=hidden NAME=cs VALUE="$cs">
<INPUT TYPE=hidden NAME=cq VALUE="$cq">
<INPUT TYPE=hidden NAME=next VALUE="$tcount">
<INPUT TYPE=hidden NAME=fsubmit VALUE="true">
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>

END

#-->> Output Page

open(JS, $perlQ->getFilePath('perlQMod/jsquestion.txt'));
my $jsinfo = join('', <JS>);
close(JS);

$jsinfo .= <<"END JS";
<SCRIPT>
function QuestionOBJ (QID, SortOrder, Type) {
	this.QID = QID;
	this.SortOrder = SortOrder;
	this.Type = Type;
}

var ctype = "$qQType";
var tempquestionobj = new QuestionOBJ();
var cs = "$cs";
var cq = "$cq";
var qt = "$qQType";
var largestid = "$largestid";

var questions = new Array(
END JS

for (my $i = 0; $i < @questionlist; $i++) {
  if ($i > 0) { $jsinfo .= ", "; }
  $jsinfo .= "new QuestionOBJ(";
  $jsinfo .= '"' . $html->protectHTML($questionlist[$i]->{'QID'}) . '",';
  $jsinfo .= '"' . $html->protectHTML($questionlist[$i]->{'SortOrder'}) . '",';
  $jsinfo .= '"' . $html->protectHTML($questionlist[$i]->{'Type'}) . '")';
}
$jsinfo .= ");\n";

# The variables below are used for the answer wizard.
$jsinfo .= <<"END JS";

var fieldinit = false;
var deleteinit = false;
var checkboxarray = new Array();
var checkboxarray2 = new Array();
var addtextfield = false;

</SCRIPT>
END JS

$html->createPage('question', "$lang->{'AdminTitle'} :: $lang->{'QuestionEditorTitle'}", $contents, 1, $jsinfo, $cs);

sub checkACount {
	my ($control, $answer, $answercount) = @_;
  my @answerchoice = split(/\|\|\|/, $answer);      
  my $acount = 0;      
  for (my $i = 0; $i < @answerchoice; $i++) {      
    if (substr($answerchoice[$i], -1) eq "Y") { $acount++; }
  }
  if ($control eq "a" || ($answercount >= 1 && $answercount <= $acount)) {
		return 1;
	}
	return 0;      
}

sub validateQAnswer {
	my $qanswer = shift;      
	my $valid = 1;      

	my @choices = split(/\|\|\|/, $qanswer);      
	for (my $i = 0; $i < @choices; $i++) {      
		my @parts = split(/\|\|/, $choices[$i]);
		if (@parts != 5) { $valid = 0; }
		else {
			$valid = (length($parts[0]) == 4) ? $valid : 0;
			$valid = ($parts[1] > 0) ? $valid : 0;
			$valid = ($parts[2] ne '') ? $valid : 0;
			$valid = ($parts[3] eq "N" || $parts[3] eq "D") ? $valid : 0;
			$valid = ($parts[4] eq "Y" || $parts[4] eq "N") ? $valid : 0;
		}
	}      

	return $valid;
}
