#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\..\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/../perlQMod"); }
else { unshift (@INC, "../perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-inadmin => 1);
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Logging In

$perlQ->isAdmin(-redirecterrors => 1);
$perlQ->setLanguage('', 'ADMIN');
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');
my %languages = $perlQ->getLanguages;

#-->> Setting Variables

my $cs = $cgi->param('cs') || 0;
$cs = ($cs =~ /^(\d+)$/) ? $1 : 0;
my $advance = 'n';
my $defaulttemplate = 'default';
my $message = $cgi->param('message') || '';

my $query = $dbh->prepare("SELECT AdvanceInterface,Template,SendmailPath,SMTPServer FROM perlQAdmin LIMIT 1");
my $maadmin;
if ($query->execute && $query->rows) {
	$maadmin = $query->fetchrow_hashref;
	if ($maadmin->{'AdvanceInterface'} eq 'y') { $advance = 'y'; }
	if ($maadmin->{'Template'}) { $defaulttemplate = $maadmin->{'Template'}; }
}
$query->finish;

#-->> Setting Interface

if ($cs) {
	$query = $dbh->prepare("SELECT AdvanceInterface FROM perlQSurvey WHERE SID=?");
	if ($query->execute($cs) && $query->rows) {
		my $tadvance = ($query->fetchrow_array)[0];
		$advance = ($tadvance =~ /^(y|n)$/) ? $1 : $advance;
	}
	$query->finish;
}

$advance = (($cgi->param('localadvance') || '') =~ /^(y|n)$/) ? $1 : $advance;

my $action = $cgi->param('action') || '';

my $surveyresults = (($cgi->param('surveyresults') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $oncomplete = (($cgi->param('oncomplete') || 0) =~ /^(\d+)$/) ? $1 : 0;

if ($action eq 'add' || $action eq 'modify') {
	if (!$surveyresults && $oncomplete == 1) {
		$oncomplete = 0;
		$message = $lang->{'RedirectPrivateError'};
	}
}

my $modifyid = (($cgi->param('modifyid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $activateid = (($cgi->param('activateid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $activate = (($cgi->param('activate') || '') eq 'y') ? 'y' : 'n';
my $deleteid = (($cgi->param('deleteid') || 0) =~ /^(\d+)$/) ? $1 : 0;

my $surveyname = $cgi->param('surveyname') || '';
my $description = $cgi->param('description') || '';
my $adminnotes = $cgi->param('adminnotes') || '';
my $surveywidth = $cgi->param('surveywidth') || '';
my $questionstyle = $cgi->param('questionstyle') || '';
$questionstyle =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $answerstyle = $cgi->param('answerstyle') || '';
$answerstyle =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $answertextstyle = $cgi->param('answertextstyle') || '';
$answertextstyle =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $answerinputstyle = $cgi->param('answerinputstyle') || '';
$answerinputstyle =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $errorstyle = $cgi->param('errorstyle') || '';
$errorstyle =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $template = $cgi->param('template') || '';
my $language = $cgi->param('language') || '';
if (!defined $languages{$language}) {
	if (defined $languages{'english'}) { $language = 'english'; }
	else { foreach my $lang (keys %languages) { $language = $lang; last; } }
}
my $redirecturl = $cgi->param('redirecturl') || '';
my $completed = $cgi->param('completed') || '';
my $verifyemail = $cgi->param('verifyemail') || '';
my $emailfrom = $cgi->param('emailfrom') || '';
my $emailsubject = $cgi->param('emailsubject') || '';
my $questionnumb = (($cgi->param('questionnumb') || '') eq 'y') ? 'y' : 'n';
my $surveyusersip = $cgi->param('surveyusersip') ? 1 : 0;
my $surveyusersck = $cgi->param('surveyusersck') ? 1 : 0;
my $surveyusersem = $cgi->param('surveyusersem') ? 1 : 0;
my $surveyusers = sprintf("%01d%01d%01d", $surveyusersip, $surveyusersck, $surveyusersem);

my $resultswidth = (($cgi->param('resultswidth') || 500) =~ /^(\d+)$/) ? $1 : 500;
my $resultsborder = $cgi->param('resultsborder') || '';
$resultsborder =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $resultsanswer = $cgi->param('resultsanswer') || '';
$resultsanswer =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $resultsstats = $cgi->param('resultsstats') || '';
$resultsstats =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;
my $resultsgraph = $cgi->param('resultsgraph') || '';
$resultsgraph =~ s/STYLE\s*=\s*"?([^"]*)"?/$1/;

my $submitimagesrc = $cgi->param('submitimagesrc') || '';
my $submitimagealt = $cgi->param('submitimagealt') || '';
my $submitimagewidth = $cgi->param('submitimagewidth') || 0;
my $submitimageheight = $cgi->param('submitimageheight') || 0;
my $resultsimagesrc = $cgi->param('resultsimagesrc') || '';
my $resultsimagealt = $cgi->param('resultsimagealt') || '';
my $resultsimagewidth = $cgi->param('resultsimagewidth') || 0;
my $resultsimageheight = $cgi->param('resultsimageheight') || 0;
my $nextimagesrc = $cgi->param('nextimagesrc') || '';
my $nextimagealt = $cgi->param('nextimagealt') || '';
my $nextimagewidth = $cgi->param('nextimagewidth') || 0;
my $nextimageheight = $cgi->param('nextimageheight') || 0;

my $sdmonth = $cgi->param('sdmonth') || '';
my $sdday = $cgi->param('sdday') || '';
my $sdyear = $cgi->param('sdyear') || '';
my $sdhr = $cgi->param('sdhr') || '';
my $sdmt = $cgi->param('sdmt') || '';
my $sdsc = $cgi->param('sdsc') || '';

my $edmonth = $cgi->param('edmonth') || '';
my $edday = $cgi->param('edday') || '';
my $edyear = $cgi->param('edyear') || '';
my $edhr = $cgi->param('edhr') || '';
my $edmt = $cgi->param('edmt') || '';
my $edsc = $cgi->param('edsc') || '';
my $indent = $cgi->param('indent') || '';

my $responsenotice = $cgi->param('responsenotice') || 0;
my $responseemail = $cgi->param('responseemail') || '';

#-->> Option Arrays

my $qnumb = [[$lang->{'Yes'}, 'y'], [$lang->{'No'}, 'n']];
my $advancearray = [[$lang->{'Basic'}, 'n'], [$lang->{'Advanced'}, 'y']];
my $startyear = 2000;
my $endyear = $startyear + 50;

#-->> Add, Modify or Delete Surveys

if ($action eq 'add') {
	if ($surveyname ne '') {

		if ($advance eq 'n') {
			$resultswidth = 500;
			$resultsborder = 'background-color: #333366; color: #FFFFFF; text-decoration: none;';
			$resultsanswer = 'background-color: #FFFFFF; color: #333366;';
			$resultsstats = 'background-color: #DDEEFF; color: #333366;';
			$resultsgraph = 'background-color: #333366; height: 8px;';

			$submitimagealt = $lang->{'Submit'};
			$resultsimagealt = $lang->{'ShowResults'};
			$nextimagealt = $lang->{'Next'};
		}

		my @ifields = qw(Name Description AdminNotes Width Indent QuestionStyle
		    AnswerTextStyle AnswerInputStyle AnswerStyle Template Language
		    ErrorStyle SurveyUsers SurveyResults OnComplete RedirectURL Completed
		    QuestionNumb VerifyEmail EmailFrom EmailSubject AdvanceInterface
		    ResultsWidth ResultsBorder ResultsAnswer ResultsStats ResultsGraph
				SubmitImageSrc SubmitImageWidth SubmitImageHeight SubmitImageText
				ResultImageSrc ResultImageWidth ResultImageHeight ResultImageText
				NextImageSrc NextImageWidth NextImageHeight NextImageText
				ResponseNotice ResponseEmail);

		my @ivalues = ($surveyname, $description, $adminnotes, $surveywidth,
		    $indent, $questionstyle, $answertextstyle, $answerinputstyle,
		    $answerstyle, $template, $language, $errorstyle, $surveyusers,
		    $surveyresults, $oncomplete, $redirecturl, $completed, $questionnumb,
		    $verifyemail, $emailfrom, $emailsubject, $advance, $resultswidth,
		    $resultsborder, $resultsanswer, $resultsstats, $resultsgraph,
				$submitimagesrc, $submitimagewidth, $submitimageheight, $submitimagealt,
				$resultsimagesrc, $resultsimagewidth, $resultsimageheight,
				$resultsimagealt, $nextimagesrc, $nextimagewidth, $nextimageheight,
				$nextimagealt, $responsenotice, $responseemail);

		my ($startdate, $enddate) = ('', '');
		if ($advance eq 'y') {
			if ($sdmonth || $sdday || $sdyear) {
				if ($perlQ->dateValid($sdsc,$sdmt,$sdhr,$sdday,$sdmonth,$sdyear)) {
					$startdate = "$sdyear-$sdmonth-$sdday $sdhr:$sdmt:$sdsc";
					push(@ifields, 'StartDate');
					push(@ivalues, $startdate);
				}
				else {
					$message = sprintf($lang->{'InvalidDateError'}, $lang->{'StartingDate'});
				}
			}
			if ($edmonth || $edday || $edyear) {
				if ($perlQ->dateValid($edsc,$edmt,$edhr,$edday,$edmonth,$edyear)) {
					push(@ifields, 'EndDate');
					push(@ivalues, $enddate);
					$enddate = "$edyear-$edmonth-$edday $edhr:$edmt:$edsc";
				}
				else {
					$message = sprintf($lang->{'InvalidDateError'}, $lang->{'EndingDate'});
				}
			}

			if ($startdate && $enddate && !&dateOrder($sdhr,$sdmt,$sdsc,$sdmonth,$sdday,$sdyear,$edhr,$edmt,$edsc,$edmonth,$edday,$edyear)) {
				$startdate = "";
				$enddate = "";
				$message = sprintf($lang->{'DateOrderError'}, $lang->{'StartingDate'}, $lang->{'EndingDate'});
			}
		}

		eval {
			$dbh->do("INSERT INTO perlQSurvey (SID,AddDate," . join(',', @ifields) . ") VALUES (NULL,NOW()," . join(',', map { '?' } @ivalues) . ")", undef, @ivalues);
			$cs = $dbh->{'mysql_insertid'};
			if (!$message) { $message = $lang->{'AddSurveySuccess'}; }
		};
			
		if ($@) { $message = $lang->{'AddSurveyError'}; }
	}
}
elsif ($action eq 'activate') {
	if ($activateid && $activate) {
		eval {
			$dbh->do("UPDATE perlQSurvey SET Active=? WHERE SID=?", undef, $activate, $activateid);
		};

		if ($@) { $message = $lang->{'ActivateSurveyError'}; }
	}
}
elsif ($action eq 'delete') {
	if ($deleteid) {
		eval {
			$dbh->do("DELETE FROM perlQAnswer WHERE SID=?", undef, $deleteid);
			$dbh->do("DELETE FROM perlQUser WHERE SID=?", undef, $deleteid);
			$dbh->do("DELETE FROM perlQQuestion WHERE SID=?", undef, $deleteid);
			$dbh->do("DELETE FROM perlQSurvey WHERE SID=?", undef, $deleteid);
			$message = $lang->{'DeleteSurveySuccess'};
		};

		if ($@) { $message = $lang->{'DeleteSurveyError'}; }
	}
}
elsif ($action eq 'modify') {
	if ($surveyname && $modifyid) {

		my %mfields = ('Name' => $surveyname, 'SurveyUsers' => $surveyusers,
		    'SurveyResults' => $surveyresults, 'Template' => $template,
		    'Language' => $language, 'AdvanceInterface' => $advance);

		my ($startdate, $enddate) = ('', '');
		if ($advance eq 'y') {
			%mfields = (%mfields, 'Description' => $description,
			    'AdminNotes' => $adminnotes, 'QuestionStyle' => $questionstyle,
			    'AnswerTextStyle' => $answertextstyle, 'AnswerStyle' => $answerstyle,
			    'AnswerInputStyle' => $answerinputstyle, 'Width' => $surveywidth,
			    'Indent' => $indent, 'ErrorStyle' => $errorstyle,
			    'OnComplete' => $oncomplete, 'RedirectURL' => $redirecturl,
			    'Completed' => $completed, 'QuestionNumb' => $questionnumb,
			    'VerifyEmail' => $verifyemail, 'EmailFrom' => $emailfrom,
			    'EmailSubject' => $emailsubject, 'ResultsWidth' => $resultswidth,
			    'ResultsBorder' => $resultsborder, 'ResultsAnswer' => $resultsanswer,
			    'ResultsStats' => $resultsstats, 'ResultsGraph' => $resultsgraph,
					'SubmitImageSrc' => $submitimagesrc, 'SubmitImageWidth' => $submitimagewidth,
					'SubmitImageHeight' => $submitimageheight, 'SubmitImageText' => $submitimagealt,
					'ResultImageSrc' => $resultsimagesrc, 'ResultImageWidth' => $resultsimagewidth,
					'ResultImageHeight' => $resultsimageheight, 'ResultImageText' => $resultsimagealt,
					'NextImageSrc' => $nextimagesrc, 'NextImageWidth' => $nextimagewidth,
					'NextImageHeight' => $nextimageheight, 'NextImageText' => $nextimagealt,
					'ResponseNotice' => $responsenotice, 'ResponseEmail' => $responseemail);

			if ($sdmonth || $sdday || $sdyear) {
				if ($perlQ->dateValid($sdsc,$sdmt,$sdhr,$sdday,$sdmonth,$sdyear)) {
					$startdate = "$sdyear-$sdmonth-$sdday $sdhr:$sdmt:$sdsc";
					$mfields{'StartDate'} = $startdate;
				}
				else {
					$message = sprintf($lang->{'InvalidDateError'}, $lang->{'StartingDate'});
				}
			}
			if ($edmonth || $edday || $edyear) {
				if ($perlQ->dateValid($edsc,$edmt,$edhr,$edday,$edmonth,$edyear)) {
					$enddate = "$edyear-$edmonth-$edday $edhr:$edmt:$edsc";
					$mfields{'EndDate'} = $enddate;
				}
				else {
					$message = sprintf($lang->{'InvalidDateError'}, $lang->{'EndingDate'});
				}
			}

			if ($startdate && $enddate && !&dateOrder($sdhr,$sdmt,$sdsc,$sdmonth,$sdday,$sdyear,$edhr,$edmt,$edsc,$edmonth,$edday,$edyear)) {
				$startdate = "";
				$enddate = "";
				$message = sprintf($lang->{'DateOrderError'}, $lang->{'StartingDate'}, $lang->{'EndingDate'});
			}

		}

		eval {
			$dbh->do('UPDATE perlQSurvey SET ' . join(',', map { $_ . '=?' } (keys %mfields)) . 'WHERE SID=?', undef, values %mfields, $modifyid);
			if (!$message) { $message = $lang->{'ModifySurveySuccess'}; }
		};

		if ($@ && !$message) { $message = $lang->{'ModifySurveyError'}; }
	}
}
elsif ($action eq $lang->{'RetrieveSurvey'}) {
	if ($cgi->param('importurl')) {
		eval {
			require LWP::UserAgent;

			my $browser = LWP::UserAgent->new(agent => "perlQuestionnaire v" . $perlQ->getVersion, cookie_jar => {}, requests_redirectable => ['GET', 'HEAD', 'POST']);
			my $req = HTTP::Request->new(GET => $cgi->param('importurl'));
			my $response = $browser->request($req);

			if ($response->is_success) {
				require "Import.cgi";
				my $content = $response->content;
				$content =~ s/\r//g;
				my @content = split(/\n/, $content);
				$cs = &importSurvey($perlQ, \@content, 'SWAP', 'save');
				if (!$message && $cs) {
					$message = $lang->{'ImportSurveySuccess'};
				}
			}
			else {
				$message = sprintf($lang->{'URLReadError'}, $response->status_line);
			}
		};

		if ($@ && !$message) { $message = $lang->{'LWPURLError'}; }
	}
	else { $message = $lang->{'ImportURLEmpty'}; }
}
elsif ($action eq $lang->{'ImportSurvey'}) {
	my $fh = $perlQ->getUploadFH('importfile');
	if (!$fh) {
		$message = $lang->{'ImportFileEmpty'};
	}
	else {
		require "Import.cgi";
		my @content = map { $_ =~ s/\r//g; $_; } <$fh>;
		$cs = &importSurvey($perlQ, \@content, 'SWAP', 'save');
		if ($cs && !$message) { $message = $lang->{'ImportSurveySuccess'}; }
	}
}

if ($message) { $html->setMessage("<B>$lang->{'Status'}:</B> $message"); }

$query = $dbh->prepare("SELECT *, month(StartDate) as sdmn, month(EndDate) as edmn, month(now()) as nwmn, dayofmonth(StartDate) as sddm, dayofmonth(EndDate) as eddm, dayofmonth(now()) as nwdm, year(StartDate) as sdyr, year(EndDate) as edyr, year(now()) as nwyr, hour(StartDate) as sdhr, hour(EndDate) as edhr, minute(StartDate) as sdmt, minute(EndDate) as edmt, second(StartDate) as sdsc, second(EndDate) as edsc, (now() < StartDate) as Pending, (now() > EndDate) as Expired FROM perlQSurvey ORDER BY AddDate desc, Name");
$query->execute;

my ($count,$csurvey) = (0,-1);
my ($textimg, $buttonimg) = ('','');
my @surveylist = ();
for (my $i = 0; $i < $query->rows; $i++) {
	my $masurvey = $query->fetchrow_hashref;

	if ($cs && $cs == $masurvey->{'SID'}) {
		$csurvey = $count;
		if ($masurvey->{'Active'} eq 'y') {
			if ($masurvey->{'Pending'} && substr($masurvey->{'StartDate'},0,10) ne "0000-00-00") {
				$textimg = "<IMG SRC=\"$imgurl/textpending.gif\" WIDTH=58 HEIGHT=13 ALT=\"$lang->{'Pending'}\">";
				$buttonimg = "<IMG SRC=\"$imgurl/buttonpending.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
			}
			elsif ($masurvey->{'Expired'} && substr($masurvey->{'EndDate'},0,10) ne "0000-00-00") {
				$textimg = "<IMG SRC=\"$imgurl/textexpired.gif\" WIDTH=58 HEIGHT=13 ALT=\"$lang->{'Expired'}\">";
				$buttonimg = "<IMG SRC=\"$imgurl/buttonpending.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
			}
			else {
				$textimg = "<IMG SRC=\"$imgurl/textactive.gif\" WIDTH=46 HEIGHT=13 ALT=\"$lang->{'Active'}\">";
				$buttonimg = "<IMG SRC=\"$imgurl/buttonactive.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
			}
		}
		else {
			$textimg = "<IMG SRC=\"$imgurl/textnotactive.gif\" WIDTH=79 HEIGHT=13 ALT=\"$lang->{'NotActive'}\">";
			$buttonimg = "<IMG SRC=\"$imgurl/buttondeactive.gif\" WIDTH=13 HEIGHT=13 ALT=\"\">";
		}
	}

	push(@surveylist, $masurvey);
	$count++;
}
$query->finish;

my $contents = <<"END";

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
<FORM NAME=choosesurvey ACTION=survey.cgi METHOD=POST>
<TR>
	<TD COLSPAN=3><IMG SRC="$imgurl/headingsurvey1.gif" WIDTH=109 HEIGHT=22 ALT="$lang->{'ChooseASurvey'}"></TD>
</TR>
<TR>
	<TD ALIGN=right WIDTH=120><NOBR><B>$lang->{'SelectSurvey'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_select', 'SelectSurvey')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=choosesurvey CLASS=huge ONCHANGE="ChangeSurvey()">

END

my $shortsvname = '';
if (@surveylist) {
	$contents .= "<OPTION VALUE=0>$lang->{'NoSurveySelected'}";
	for (my $i = 0; $i < @surveylist; $i++) {
		my $svname = (length($surveylist[$i]->{'Name'}) > 50) ? substr($surveylist[$i]->{'Name'},0,50)."..." : $surveylist[$i]->{'Name'};
		my $selected = '';
		if ($csurvey == $i) {
			$selected = ' SELECTED';
			$shortsvname = $svname;
		}
		my $text = substr($surveylist[$i]->{'AddDate'},0,10).": ".$svname;
		$contents .= "<OPTION $selected VALUE=".$surveylist[$i]->{'SID'}.">".$html->protectHTML($text);
	}
}
else { $contents .= "<OPTION VALUE=0>$lang->{'NoSurveyInDatabase'}"; }

my $csurveydata = ($csurvey >= 0) ? $surveylist[$csurvey] : {};
my $tsurveyname = $html->protectHTML($csurveydata->{'Name'});
my $tdescription = $html->protectHTML($csurveydata->{'Description'});
my $tadminnotes = $html->protectHTML($csurveydata->{'AdminNotes'});
my $tsurveywidth = $html->protectHTML($csurveydata->{'Width'});
my $tindent = $html->protectHTML($csurveydata->{'Indent'});
my $tquestionstyle = $html->protectHTML($csurveydata->{'QuestionStyle'});
my $tanswertextstyle = $html->protectHTML($csurveydata->{'AnswerTextStyle'});
my $tanswerinputstyle = $html->protectHTML($csurveydata->{'AnswerInputStyle'});
my $tanswerstyle = $html->protectHTML($csurveydata->{'AnswerStyle'});
my $terrorstyle = $html->protectHTML($csurveydata->{'ErrorStyle'});
my $tredirecturl = $html->protectHTML($csurveydata->{'RedirectURL'});
$template = ($csurvey >= 0) ? $csurveydata->{'Template'} : $perlQ->getAdminField('Template');
$language = ($csurvey >= 0) ? $csurveydata->{'Language'} : $perlQ->getAdminField('DefaultLanguage');

my $tresultswidth = $html->protectHTML($csurveydata->{'ResultsWidth'});
my $tresultsborder = $html->protectHTML($csurveydata->{'ResultsBorder'});
my $tresultsanswer = $html->protectHTML($csurveydata->{'ResultsAnswer'});
my $tresultsstats = $html->protectHTML($csurveydata->{'ResultsStats'});
my $tresultsgraph = $html->protectHTML($csurveydata->{'ResultsGraph'});

my $tsubmitimagesrc = $html->protectHTML($csurveydata->{'SubmitImageSrc'});
my $tsubmitimagewidth = $html->protectHTML($csurveydata->{'SubmitImageWidth'});
my $tsubmitimageheight = $html->protectHTML($csurveydata->{'SubmitImageHeight'});
my $tsubmitimagealt = $html->protectHTML($csurveydata->{'SubmitImageText'});
my $tresultimagesrc = $html->protectHTML($csurveydata->{'ResultImageSrc'});
my $tresultimagewidth = $html->protectHTML($csurveydata->{'ResultImageWidth'});
my $tresultimageheight = $html->protectHTML($csurveydata->{'ResultImageHeight'});
my $tresultimagealt = $html->protectHTML($csurveydata->{'ResultImageText'});
my $tnextimagesrc = $html->protectHTML($csurveydata->{'NextImageSrc'});
my $tnextimagewidth = $html->protectHTML($csurveydata->{'NextImageWidth'});
my $tnextimageheight = $html->protectHTML($csurveydata->{'NextImageHeight'});
my $tnextimagealt = $html->protectHTML($csurveydata->{'NextImageText'});

my $tresponseemail = $html->protectHTML($csurveydata->{'ResponseEmail'});
my $rnsel1 = $csurveydata->{'ResponseNotice'} == 1 ? ' selected' : '';
my $rnsel2 = $csurveydata->{'ResponseNotice'} == 2 ? ' selected' : '';

if ($csurvey < 0) {
	$tresultswidth = '500';
	$tresultsborder = 'background-color: #333366; color: #FFFFFF; text-decoration: none;';
	$tresultsanswer = 'background-color: #FFFFFF; color: #333366;';
	$tresultsstats = 'background-color: #DDEEFF; color: #333366;';
	$tresultsgraph = 'background-color: #333366; height: 8px;';

	$tsubmitimagealt = $html->protectHTML($lang->{'Submit'});
	$tresultimagealt = $html->protectHTML($lang->{'ShowResults'});
	$tnextimagealt = $html->protectHTML($lang->{'Next'});
}

my $active = (($csurveydata->{'Active'} || '') eq "y") ? $lang->{'Deactivate'} : $lang->{'Activate'};
$activate = (($csurveydata->{'Active'} || '') eq "y") ? "off" : "on";
my $activebutton = $cs ? "<INPUT TYPE=button ONCLICK=\"ActivateSurvey('$activate')\" VALUE=\"$active\">" : "";

my $editbutton = $cs ? "<INPUT TYPE=button ONCLICK=\"EditSurvey()\" VALUE=\"$lang->{'EditQuestions'}\">" : "";
my $previewbutton = $cs ? "<INPUT TYPE=button ONCLICK=\"PreviewSurvey($cs)\" VALUE=\"$lang->{'Preview'}\">" : "";
my $deletebutton = $cs ? "<INPUT TYPE=button ONCLICK=\"DeleteSurvey()\" VALUE=\"$lang->{'Delete'}\">" : "";
my $exportbutton = $cs ? "<INPUT TYPE=button ONCLICK=\"ExportSurvey()\" VALUE=\"$lang->{'Export'}\">" : "";

$contents .= <<"END";

		</SELECT></TD>
</TR>
<TR>
	<TD ALIGN=right>$textimg</TD>
	<TD>$buttonimg</TD>
	<TD>$editbutton $previewbutton $activebutton $exportbutton $deletebutton</TD>
</TR>
<INPUT TYPE=hidden NAME=action VALUE="activate">
<INPUT TYPE=hidden NAME=activate VALUE="">
<INPUT TYPE=hidden NAME=activateid VALUE="">
<INPUT TYPE=hidden NAME=deleteid VALUE="">
<INPUT TYPE=hidden NAME=cs VALUE="$cs">
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
<FORM NAME=addsurvey METHOD=POST>
<TR>
	<TD COLSPAN=4>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
	<TR>
		<TD><IMG SRC="$imgurl/headingsurvey2.gif" WIDTH=136 HEIGHT=22 ALT="$lang->{'AddModifyASurvey'}"></TD>
		<TD ALIGN=center><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD><TD>&nbsp;$lang->{'RequiredField'}</TD></TR></TABLE></TD>
		<TD ALIGN=right><B>$lang->{'Interface'}:</B> <SELECT NAME=localadvance ONCHANGE="ChangeInterface()">

END

for (my $i = 0; $i < @$advancearray; $i++) {
	my $selected = ($advance eq $advancearray->[$i][1]) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"".$advancearray->[$i][1]."\">".$advancearray->[$i][0];
}

$contents .= <<"END";

			</SELECT></TD>
	</TR>
	</TABLE>
	</TD>
</TR>
<TR>
	<TD ALIGN=right WIDTH=120><NOBR><B>$lang->{'SurveyName'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_name', 'SurveyName')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=surveyname CLASS=huge VALUE="$tsurveyname"></TD>
	<TD><IMG SRC="$imgurl/star.gif" WIDTH=11 HEIGHT=11 ALT="$lang->{'*'}"></TD>
</TR>

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SurveyTemplate'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_template', 'SurveyTemplate')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=template CLASS=huge>

END

my %templates = $perlQ->getTemplates;
foreach my $temp (sort { $templates{$a} cmp $templates{$b} } keys %templates) {
	my $seltext = ($temp eq $template) ? ' SELECTED' : '';
	$contents .= "<OPTION$seltext VALUE=\"$temp\">$templates{$temp}</OPTION>\n";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>

END

if ((keys %languages) > 1) {

$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SurveyLanguage'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_language', 'SurveyLanguage')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=language CLASS=huge>

END

foreach my $lang (sort { $languages{$a} cmp $languages{$b} } keys %languages) {
	my $seltext = ($lang eq $language) ? ' SELECTED' : '';
	$contents .= "<OPTION$seltext VALUE=\"$lang\">$languages{$lang}</OPTION>\n";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>

END
}

$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'UserRestrictions'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_users', 'UserRestrictions')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>

END

my $tsurveyusers = $csurveydata->{'SurveyUsers'};
my ($checkedip,$checkedck,$checkedem) = ('','','');
if (length($tsurveyusers || '') == 3) {
	$checkedip = (substr($tsurveyusers,0,1)) ? ' CHECKED' : '';
	$checkedck = (substr($tsurveyusers,1,1)) ? ' CHECKED' : '';
	$checkedem = (substr($tsurveyusers,2,1)) ? ' CHECKED' : '';
}

$contents .= "<TD><INPUT TYPE=checkbox$checkedip ID=\"f_surveyusersip\" NAME=surveyusersip></TD><TD>&nbsp;</TD><TD><LABEL FOR=\"f_surveyusersip\">$lang->{'UniqueIPAddress'}</LABEL></TD><TD>&nbsp;&nbsp;</TD>";
$contents .= "<TD><INPUT TYPE=checkbox$checkedck ID=\"f_surveyusersck\" NAME=surveyusersck></TD><TD>&nbsp;</TD><TD><LABEL FOR=\"f_surveyusersck\">$lang->{'Cookies'}</LABEL></TD><TD>&nbsp;&nbsp;</TD>";

if ($maadmin->{'SendmailPath'} || $maadmin->{'SMTPServer'}) {
	$contents .= "<TD><INPUT TYPE=checkbox$checkedem ID=\"f_surveyusersem\" NAME=surveyusersem></TD><TD>&nbsp;</TD><TD><LABEL FOR=\"f_surveyusersem\">$lang->{'VerifiedEmailAddress'}</LABEL></TD><TD>&nbsp;&nbsp;</TD>";
}

$contents .= <<"END";

		</TR></TABLE></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'SurveyDescription'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('s_description', 'SurveyDescription')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=description WRAP=physical>$tdescription</TEXTAREA></TD>
	<TD></TD>
</TR>
END

if ($advance eq 'y') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'SurveyInstructions'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('s_instructions', 'SurveyInstructions')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=adminnotes WRAP=physical>$tadminnotes</TEXTAREA></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'StartingDate'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_usedates', 'StartingDate')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>

END

$contents .= "<SELECT NAME=sdmonth><OPTION VALUE=\"0\">---";
for (my $i = 0; $i < 12; $i++) {
	my $selected = ($i+1 == $csurveydata->{'sdmn'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"".($i+1)."\">$lang->{'MonthNames'}[$i]";
}
$contents .= "</SELECT>&nbsp;";
$contents .= "<SELECT NAME=sdday><OPTION VALUE=\"0\">--";

for (my $i=1; $i<=31; $i++) {
	my $selected = ($i == $csurveydata->{'sddm'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">$i";
}
$contents .= "</SELECT>&nbsp;";
$contents .= "<SELECT NAME=sdyear><OPTION VALUE=\"0\">----";
for (my $i=$startyear; $i<$endyear; $i++) {
	my $selected = ($i == $csurveydata->{'sdyr'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">$i";
}
$contents .= "</SELECT>&nbsp;&nbsp;";
$contents .= "<B>$lang->{'Time'}:</B> <SELECT NAME=sdhr>";
for (my $i=0; $i<24; $i++) {
	my $selected = ($i == $csurveydata->{'sdhr'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">".sprintf("%02d",$i);
}
$contents .= "</SELECT>&nbsp;:&nbsp;";
$contents .= "<SELECT NAME=sdmt>";
for (my $i=0; $i<60; $i++) {
	my $selected = ($i == $csurveydata->{'sdmt'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">" . sprintf("%02d", $i);
}
$contents .= "</SELECT>&nbsp;:&nbsp;";
$contents .= "<SELECT NAME=sdsc>";
for (my $i=0; $i<60; $i++) {
	my $selected = ($i == $csurveydata->{'sdsc'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">" . sprintf("%02d", $i);
}
$contents .= "</SELECT>";

$contents .= <<"END";

	</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'EndingDate'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_usedates', 'EndingDate')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>

END

my $seledhr = ($csurvey >= 0) ? $csurveydata->{'edhr'} : "23";
my $seledmt = ($csurvey >= 0) ? $csurveydata->{'edmt'} : "59";
my $seledsc = ($csurvey >= 0) ? $csurveydata->{'edsc'} : "59";

$contents .= "<SELECT NAME=edmonth><OPTION VALUE=\"0\">---";
for (my $i=0; $i<12; $i++) {
	my $selected = ($i+1 == $csurveydata->{'edmn'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"".($i+1)."\">$lang->{'MonthNames'}[$i]";
}
$contents .= "</SELECT>&nbsp;";
$contents .= "<SELECT NAME=edday><OPTION VALUE=\"0\">--";
for (my $i=1; $i<=31; $i++) {
	my $selected = ($i == $csurveydata->{'eddm'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">$i";
}
$contents .= "</SELECT>&nbsp;";
$contents .= "<SELECT NAME=edyear><OPTION VALUE=\"0\">----";
for (my $i=$startyear; $i<$endyear; $i++) {
	my $selected = ($i == $csurveydata->{'edyr'}) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">$i";
}
$contents .= "</SELECT>&nbsp;&nbsp;";
$contents .= "<B>$lang->{'Time'}:</B> <SELECT NAME=edhr>";
for (my $i=0; $i<24; $i++) {
	my $selected = ($i == $seledhr) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">" . sprintf("%02d", $i);
}
$contents .= "</SELECT>&nbsp;:&nbsp;";
$contents .= "<SELECT NAME=edmt>";
for (my $i=0; $i<60; $i++) {
	my $selected = ($i == $seledmt) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">" . sprintf("%02d", $i);
}
$contents .= "</SELECT>&nbsp;:&nbsp;";
$contents .= "<SELECT NAME=edsc>";
for (my $i=0; $i<60; $i++) {
	my $selected = ($i == $seledsc) ? " SELECTED" : "";
	$contents .= "<OPTION$selected VALUE=\"$i\">" . sprintf("%02d", $i);
}
$contents .= "</SELECT>";

$contents .= <<"END";

	</TD>
	<TD></TD>
</TR>

END
}

if ($advance eq 'y') {
	$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SurveyWidth'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_width', 'SurveyWidth')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=surveywidth CLASS=medium VALUE="$tsurveywidth"> $lang->{'Pixels'} $lang->{'OrPercent'}</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AnswerIndentation'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_indent', 'AnswerIndentation')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=indent CLASS=medium VALUE="$tindent"> $lang->{'Pixels'}</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AutoNumbering'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_autonum', 'AutoNumbering')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=questionnumb>

END

for (my $j=0; $j<@$qnumb; $j++) {
	my $selected = ($qnumb->[$j][1] eq $csurveydata->{'QuestionNumb'}) ? "SELECTED" : "";
	$contents .= "<OPTION $selected VALUE=\"$qnumb->[$j][1]\">$qnumb->[$j][0]";
}

$contents .= <<"END";

		</SELECT></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'QuestionTextStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_qstyle', 'QuestionTextStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=questionstyle CLASS=huge VALUE="$tquestionstyle"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AnswerInputStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_aistyle', 'AnswerInputStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answerinputstyle CLASS=huge VALUE="$tanswerinputstyle"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'AnswerTextStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_astyle', 'AnswerTextStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answertextstyle CLASS=huge VALUE="$tanswertextstyle"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'TextInputStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_istyle', 'TextInputStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=answerstyle CLASS=huge VALUE="$tanswerstyle"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ErrorTextStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_estyle', 'ErrorTextStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=errorstyle CLASS=huge VALUE="$terrorstyle"></TD>
	<TD></TD>
</TR>

END
}

if ($advance eq 'y') {
	if ($maadmin->{'SendmailPath'} || $maadmin->{'SMTPServer'}) {
		my $verifyemail = $html->protectHTML($lang->{'EmailDefaultMessage'});
		my $emailfrom = $html->protectHTML($lang->{'EmailDefaultFrom'});
		my $emailsubject = $html->protectHTML(sprintf($lang->{'EmailDefaultSubject'}, ''));
		if ($csurvey >= 0) {
			$verifyemail = $csurveydata->{'VerifyEmail'} ? $html->protectHTML($csurveydata->{'VerifyEmail'}) : $verifyemail;
			$emailfrom = $csurveydata->{'EmailFrom'} ? $html->protectHTML($csurveydata->{'EmailFrom'}) : $emailfrom;
			$emailsubject = $csurveydata->{'EmailSubject'} ? $html->protectHTML($csurveydata->{'EmailSubject'}) : $emailsubject;
		}

		$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'EmailFrom'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_email', 'VerificationEmail')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=emailfrom CLASS=huge MAXLENGTH=255 VALUE="$emailfrom"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'EmailSubject'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_email', 'VerificationEmail')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=emailsubject CLASS=huge MAXLENGTH=255 VALUE="$emailsubject"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'VerificationEmail'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('s_email', 'VerificationEmail')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=verifyemail>$verifyemail</TEXTAREA></TD>
	<TD></TD>
</TR>
END
	}
	
	my $tcompleted = ($csurvey >= 0 && $csurveydata->{'Completed'}) ? $html->protectHTML($csurveydata->{'Completed'}) : $html->protectHTML($html->printMessage($lang->{'SurveyCompleted'}));

	my $resultssel2 = (($csurveydata->{'SurveyResults'} || 0) == 2) ? ' SELECTED' : '';
	my $resultssel1 = ($resultssel2 eq '' && $csurveydata->{'SurveyResults'}) ? ' SELECTED' : '';
	my $oncompsel1 = ($csurveydata->{'OnComplete'} == 1) ? ' selected' : '';
	my $oncompsel2 = ($csurveydata->{'OnComplete'} == 2) ? ' selected' : '';
	my $oncompsel3 = ($csurveydata->{'OnComplete'} == 3) ? ' selected' : '';
	$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'UponCompletion'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_oncompletion', 'UponCompletion')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME=oncomplete class=huge>
		<OPTION VALUE=0>$lang->{'UCDisplayNotice'}
		<OPTION VALUE=1$oncompsel1>$lang->{'UCRedirectResults'}
		<OPTION VALUE=2$oncompsel2>$lang->{'UCRedirectURL'}
		<OPTION VALUE=3$oncompsel3>$lang->{'UCRedirectResponse'}
	</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right VALIGN=top><NOBR><B>$lang->{'CompletionNotice'}:</B></NOBR></TD>
	<TD VALIGN=top><A HREF="javascript:perlQHelp('s_completion', 'CompletionNotice')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TEXTAREA NAME=completed WRAP=physical>$tcompleted</TEXTAREA></TD>
	<TD></TD>
</TR>

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'RedirectURL'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_redirecturl', 'RedirectURL')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=redirecturl CLASS=huge VALUE="$tredirecturl"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SurveyResults'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_results', 'SurveyResults')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME="surveyresults" class=huge>
		<OPTION VALUE=0>$lang->{'SRPrivate'}
		<OPTION VALUE=1$resultssel1>$lang->{'SRPublic'}
		<OPTION VALUE=2$resultssel2>$lang->{'SRButton'}
	</SELECT></TD>
	<TD></TD>

END

	if ($maadmin->{'SendmailPath'} || $maadmin->{'SMTPServer'}) {
		$contents .= <<"END";
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResponseNotice'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_responsenotice', 'ResponseNotice')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><SELECT NAME="responsenotice" class=huge>
		<OPTION VALUE=0>$lang->{'RNNone'}
		<OPTION VALUE=1$rnsel1>$lang->{'RNEmailLink'}
		<OPTION VALUE=2$rnsel2>$lang->{'RNEmailSummary'}
	</SELECT></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResponseEmail'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_responseemail', 'ResponseEmail')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=responseemail CLASS=huge VALUE="$tresponseemail"></TD>
	<TD></TD>
</TR>
END
	}

		$contents .= <<"END";

<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResultsTableWidth'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_rwidth', 'ResultsTableWidth')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=resultswidth CLASS=medium VALUE="$tresultswidth"> $lang->{'Pixels'}</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResultsBorderStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_rborder', 'ResultsBorderStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=resultsborder CLASS=huge VALUE="$tresultsborder"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResultsAnswerStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_ranswer', 'ResultsAnswerStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=resultsanswer CLASS=huge VALUE="$tresultsanswer"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResultsStatsStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_rstats', 'ResultsStatsStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=resultsstats CLASS=huge VALUE="$tresultsstats"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'StatsGraphStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_rgraph', 'StatsGraphStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><INPUT TYPE=text NAME=resultsgraph CLASS=huge VALUE="$tresultsgraph"></TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'SubmitButtonStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_buttonstyle', 'SubmitButtonStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
	<TR>
	<TD><B>$lang->{'ButtonText'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=submitimagealt CLASS=mini VALUE="$tsubmitimagealt"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonWidth'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=submitimagewidth CLASS=tiny VALUE="$tsubmitimagewidth"></TD>
	<TD><IMG SRC="images/invdot.gif" WIDTH=10 HEIGHT=1 BORDER=0 ALT=""></TD>
	<TD><B>$lang->{'ButtonHeight'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=submitimageheight CLASS=tiny VALUE="$tsubmitimageheight"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonSrc'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=submitimagesrc CLASS=mini VALUE="$tsubmitimagesrc"></TD>
	</TR>
	</TABLE>
	</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'ResultsButtonStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_buttonstyle', 'ResultsButtonStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
	<TR>
	<TD><B>$lang->{'ButtonText'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=resultsimagealt CLASS=mini VALUE="$tresultimagealt"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonWidth'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=resultsimagewidth CLASS=tiny VALUE="$tresultimagewidth"></TD>
	<TD><IMG SRC="images/invdot.gif" WIDTH=10 HEIGHT=1 BORDER=0 ALT=""></TD>
	<TD><B>$lang->{'ButtonHeight'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=resultsimageheight CLASS=tiny VALUE="$tresultimageheight"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonSrc'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=resultsimagesrc CLASS=mini VALUE="$tresultimagesrc"></TD>
	</TR>
	</TABLE>
	</TD>
	<TD></TD>
</TR>
<TR>
	<TD ALIGN=right><NOBR><B>$lang->{'NextButtonStyle'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_buttonstyle', 'NextButtonStyle')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
	<TR>
	<TD><B>$lang->{'ButtonText'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=nextimagealt CLASS=mini VALUE="$tnextimagealt"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonWidth'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=nextimagewidth CLASS=tiny VALUE="$tnextimagewidth"></TD>
	<TD><IMG SRC="images/invdot.gif" WIDTH=10 HEIGHT=1 BORDER=0 ALT=""></TD>
	<TD><B>$lang->{'ButtonHeight'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=nextimageheight CLASS=tiny VALUE="$tnextimageheight"></TD>
	<TD>&nbsp;&nbsp;&nbsp;</TD>
	<TD><B>$lang->{'ButtonSrc'}:</B></TD>
	<TD>&nbsp;</TD>
	<TD><INPUT TYPE=text NAME=nextimagesrc CLASS=mini VALUE="$tnextimagesrc"></TD>
	</TR>
	</TABLE>
	</TD>
	<TD></TD>
</TR>
END
}

my $modifybtn = $cs ? "<INPUT TYPE=button ONCLICK=\"ModifySurvey()\" VALUE=\"$lang->{'ModifySurvey'}\">" : "";

$contents .= <<"END";

<TR>
	<TD WIDTH=135 COLSPAN=2></TD>
	<TD COLSPAN=2><INPUT TYPE=button ONCLICK="AddSurvey()" VALUE="$lang->{'AddSurvey'}"> $modifybtn
		<INPUT TYPE=button ONCLICK="ClearForm()" VALUE="$lang->{'ClearForm'}"></TD>
</TR>
<INPUT TYPE=hidden NAME=action VALUE="">
<INPUT TYPE=hidden NAME=modifyid VALUE="$cs">
<INPUT TYPE=hidden NAME=cs VALUE="$cs">
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>
<BR>

<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
<FORM ENCTYPE="multipart/form-data" ACTION="survey.cgi" NAME=importsurvey METHOD=POST>
<TR>
	<TD COLSPAN=3><IMG SRC="$imgurl/headingimport.gif" WIDTH=107 HEIGHT=22 ALT="$lang->{'ImportASurvey'}"></TD>
</TR>
<TR>
	<TD ALIGN=right WIDTH=120><NOBR><B>$lang->{'UploadDataFile'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_importfile', 'UploadDataFile')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
	<TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><INPUT TYPE=file NAME="importfile" SIZE=35></TD><TD>&nbsp;</TD><TD><INPUT TYPE=submit name="action" VALUE="$lang->{'ImportSurvey'}"></TD></TR></TABLE></TD>
</TR>
<TR>
	<TD ALIGN=right WIDTH=120><NOBR><B>$lang->{'FetchFromURL'}:</B></NOBR></TD>
	<TD><A HREF="javascript:perlQHelp('s_importurl', 'FetchFromURL')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>

END

eval { require LWP; };
if ($@) { $contents .= "<TD>$lang->{'RequiresLWP'}</TD>"; }
else {
	$contents .= "<TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><INPUT TYPE=text name=\"importurl\" class=large style=\"width: 250px;\"></TD><TD>&nbsp;</TD><TD><INPUT TYPE=submit name=\"action\" VALUE=\"$lang->{'RetrieveSurvey'}\"></TD></TR></TABLE></TD>\n";
}

$contents .= <<"END";

</TR>
</FORM>
</TABLE>

<BR>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>
<TR><TD BACKGROUND="$aimgurl/border.gif"><IMG SRC="$aimgurl/invdot.gif" WIDTH=100 HEIGHT=1 ALT=""></TD></TR>
</TABLE>

END

#-->> Output Page

open(JS, $perlQ->getFilePath('perlQMod/jssurvey.txt'));
my $jsinfo = join('', <JS>);
close(JS);

$jsinfo .= "<SCRIPT>\nvar currentsurvey = \"$cs\";\n</SCRIPT>\n\n";

$html->createPage('survey', "$lang->{'AdminTitle'} :: $lang->{'SurveyEditorTitle'}", $contents, 1, $jsinfo, $cs);

sub dateOrder {
	my ($sdhr,$sdmt,$sdsc,$sdmonth,$sdday,$sdyear,$edhr,$edmt,$edsc,$edmonth,$edday,$edyear) = @_;
	if ($sdyear > $edyear) { return 0; }
	if ($sdyear < $edyear) { return 1; }
	if ($sdmonth > $edmonth) { return 0; }
	if ($sdmonth < $edmonth) { return 1; }
	if ($sdday > $edday) { return 0; }
	if ($sdday < $edday) { return 1; }
	if ($sdhr > $edhr) { return 0; }
	if ($sdhr < $edhr) { return 1; }
	if ($sdmt > $edmt) { return 0; }
	if ($sdmt < $edmt) { return 1; }
	if ($sdsc > $edsc) { return 0; }
	if ($sdsc < $edsc) { return 1; }

	return 1;
}
