#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Include Files

use strict;
require "State.cgi";
import perlQMod::State;
require "Question.cgi";
require "View.cgi";

my $perlQ = perlQMod::State->new;
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Setting Variables

my $sid = (($cgi->param('sid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $uid = (($cgi->param('uid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $upasswd = $cgi->param('upasswd') || '';
my $csubmit = $cgi->param('csubmit') || 0;

#-->> Check UID and SID

if (!$uid || !$sid) { $html->redirect(-url => 'error.cgi'); }

my $masurvey = 0;
my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
if ($query->execute($sid) && $query->rows) {
	$masurvey = $query->fetchrow_hashref;
}
$query->finish;

if (!$masurvey) { $html->redirect(-url => 'error.cgi'); }

#-->> Set Language...

$perlQ->setLanguage($masurvey->{'Language'});
my $lang = $perlQ->getLanguage;

#-->> Create Form

my ($contents, $errormsg);
my $errorstyle = 'color: red;';
if ($upasswd) {
	if ($masurvey->{'ErrorStyle'}) { $errorstyle = $masurvey->{'ErrorStyle'}; }

	$query = $dbh->prepare("SELECT * FROM perlQUser WHERE SID=? AND UID=? AND Confirm=?");
	if ($query->execute($sid, $uid, $upasswd) && $query->rows) {
		my $mauser = $query->fetchrow_hashref;
		if ($mauser->{'EmailConfirm'} eq 'n') {
			eval {
				$dbh->do("UPDATE perlQUser SET EmailConfirm='y' WHERE SID=? AND UID=?", undef, $sid, $uid);
			};
		}
			
		if ($masurvey->{'OnComplete'} == 1 && $masurvey->{'SurveyResults'}) {
			$query->finish;
			$html->redirect(-url => "stats.cgi?sid=$sid");
		}
		elsif ($masurvey->{'OnComplete'} == 2 && $masurvey->{'RedirectURL'}) {
			$query->finish;
			$html->redirect(-url => $html->protectHTML($masurvey->{'RedirectURL'}));
		}
		elsif ($masurvey->{'OnComplete'} == 3) {
			$contents = $lang->{'YourResponse'}.'<BR><BR>';
			$contents .= &recreateSurvey($perlQ, $sid, $uid, 0, $masurvey, 1);
		}
		elsif ($masurvey->{'Completed'}) { $contents = $masurvey->{'Completed'}; }
		else { $contents = $html->printMessage($lang->{'SurveyCompleted'}); }
	}
	else {
		$errormsg = sprintf($lang->{'ConfirmIncorrect'}, $html->protectHTML($upasswd));
	}
	$query->finish;
}

if (!$upasswd || $errormsg) {
	if (!$errormsg && $csubmit) { $errormsg = $lang->{'ConfirmEmpty'}; }

	my $button = &getButton($perlQ, $masurvey, 'submit');
	$contents = "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=$masurvey->{'Width'}><TR><TD ALIGN=center><TABLE CELLSPACING=0 CELLPADDING=2 BORDER=0>\n";
	$contents .= "<TR><TD>$lang->{'ConfirmRequest'}</TD></TR>\n";
	$contents .= "</TABLE>\n";
	$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";
	if ($errormsg) {
	 $contents .= "<TR><TD COLSPAN=3 STYLE=\"$errorstyle\">$errormsg</TD></TR>\n";
	}
	$contents .= "<FORM ACTION=confirm.cgi METHOD=POST>\n";
	$contents .= "<INPUT TYPE=hidden NAME=sid VALUE=$sid>\n";
	$contents .= "<INPUT TYPE=hidden NAME=uid VALUE=$uid>\n";
	$contents .= "<INPUT TYPE=hidden NAME=csubmit VALUE=1>\n";
	$contents .= "<TR>\n";
	$contents .= "<TD>$lang->{'ConfirmPrompt'}</TD>\n";
	$contents .= "<TD><INPUT TYPE=text NAME=upasswd VALUE=\"".$html->protectHTML($upasswd)."\"></TD>\n";
	$contents .= "<TD>$button</TD>\n";
	$contents .= "</TR>\n";
	$contents .= "</FORM>\n";
	$contents .= "</TABLE></TD></TR></TABLE>\n";
}

#-->> Output Page

my $title = sprintf($lang->{'ConfirmTitle'}, $masurvey->{'Name'});
$html->createPage($sid, $title, $contents, 0, '');
