#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Include Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new;
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Set Default Language...
$perlQ->setLanguage;
my $lang = $perlQ->getLanguage;

#-->> Contents

my $contents = <<"END";

<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=600>
<TR><TD WIDTH=48></TD><TD WIDTH=500></TD><TD WIDTH=48></TD>
<TR>
	<TD></TD>
	<TD COLSPAN=2><h2>$lang->{'SurveyList'}</h2></TD>
</TR>
<TR>
	<TD>&nbsp;</TD>
	<TD ALIGN=center>
	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
	<TR><TD COLSPAN=2><HR SIZE=1 NOSHADE></TD></TR>

END

if ($perlQ->getAdminField('ListSurvey') eq 'y') {

	my $query = $dbh->prepare("SELECT *, UNIX_TIMESTAMP() as unw, UNIX_TIMESTAMP(StartDate) as usd, UNIX_TIMESTAMP(EndDate) as ued FROM perlQSurvey WHERE Active='y' ORDER BY Active, Name");
	$query->execute;
	for (my $i = 0; $i < $query->rows; $i++) {
		my $masurvey = $query->fetchrow_hashref;
		my $sid = $masurvey->{'SID'};
		my $validtime = 1;
		$validtime = (substr($masurvey->{'StartDate'},0,10) ne "0000-00-00") ?
		    (($masurvey->{'unw'} >= $masurvey->{'usd'}) ? $validtime: 0) : $validtime;
		$validtime = (substr($masurvey->{'EndDate'},0,10) ne "0000-00-00") ?
		    (($masurvey->{'unw'} <= $masurvey->{'ued'}) ? $validtime : 0) : $validtime;
		if ($validtime) {
			my $responseloc = '';
			if ($masurvey->{'SurveyResults'}) {
				my $rquery = $dbh->prepare("SELECT COUNT(*) as ct FROM perlQUser WHERE SID=?");
				my $responsect = 0;
				if ($rquery->execute($sid) && $rquery->rows) {
					$responsect = ($rquery->fetchrow_array)[0];
				}
				$rquery->finish;

				my $responsemsg = ($responsect == 1) ? $lang->{'response'} : $lang->{'responses'};
				$responsemsg = sprintf($responsemsg, $responsect);
				$responseloc = "(<A HREF=\"stats.cgi?sid=$sid\" CLASS=link>$responsemsg</A>)";
			}

			my $lnkstyle = " CLASS=link";
			my $svname = $html->protectHTML($masurvey->{'Name'});
			if (length($svname) > 50) { $svname = substr($svname,0,50) . "..."; }

			$contents .= "<TR><TD ALIGN=right><A HREF=\"fillsurvey.cgi?sid=$sid\" $lnkstyle>--</A></TD>";
			$contents .= "<TD><A HREF=\"fillsurvey.cgi?sid=$sid\" $lnkstyle><B>$svname</B></A> $responseloc</TD>";
			if ($masurvey->{'Description'}) {
				$contents .= "<TR><TD ALIGN=right VALIGN=top>&nbsp;</TD>";
				$contents .= "<TD>$masurvey->{'Description'}</TD></TR>";
			}
			$contents .= "<TR><TD COLSPAN=2><HR SIZE=1 NOSHADE></TD></TR>";
		}
	}
	$query->finish;
}
else {
	$contents .= "<TR><TD COLSPAN=2>$lang->{'NoSurveys'}</TD></TR>\n";
}

$contents .= <<"END";

	</TABLE>
	</TD>
	<TD>&nbsp;</TD>
</TR>
</TABLE>

END

#-->> Output Page

$html->createPage(0, $lang->{'SurveyList'}, $contents, 0, '');
