#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Include Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new(-skipdb => 1); # Skip DB connection...
my $cgi = $perlQ->getCGI;
my $html = $perlQ->getHTML;

#-->> GET and POST Variables

my $mysqlhost = $cgi->param('mysqlhost') || 'localhost';
my $mysqluser = $cgi->param('mysqluser') || '';
my $mysqlpasswd = $cgi->param('mysqlpasswd') || '';
my $mysqldb = $cgi->param('mysqldb') || '';
my $action = $cgi->param('action') || '';
my $apasswd = $cgi->param('apasswd') || '';
my $language = $cgi->param('language') || '';
my $incgibin = $cgi->param('incgibin') ? 'y' : 'n';

#-->> Set Language
my $uselang = $perlQ->setLanguage($language, 'ADMIN');
my $lang = $perlQ->getLanguage;

#-->> MySQL Setup
# 0 - Variable Check
# 1 - MySQL Connection Test
# 2 - MySQL Database Test

my $dbh = 0;
my @ErrorCode = (0,0,0,0,0);
if ($mysqlhost && $mysqluser && $mysqlpasswd && $mysqldb) { $ErrorCode[0] = 1; }
if ($ErrorCode[0]) {
	$dbh = $perlQ->getDBH(-dsn => "DBI:mysql:database=$mysqldb;host=$mysqlhost", -user => $mysqluser, -password => $mysqlpasswd);
	if ($dbh) { $ErrorCode[1] = 1; $ErrorCode[2] = 1; }
}
if ($ErrorCode[0] && $apasswd) { $ErrorCode[3] = 1; }
if (-w $perlQ->getFilePath('perlQMod/DBInfo.cgi')) { $ErrorCode[4] = 1; }

#-->> Variables

my %htmlconfig = ('host' => $html->protectHTML($mysqlhost),
                  'user' => $html->protectHTML($mysqluser),
                  'passwd' => $html->protectHTML($mysqlpasswd),
                  'db' => $html->protectHTML($mysqldb),
                  'apasswd' => $html->protectHTML($apasswd));

my $perlQID = rand(999999999) + 1000000000;

# Attempt to locate the default path for their sendmail program...

my $sendmailpath = '';
if (-x '/usr/sbin/sendmail') {
	$sendmailpath = '/usr/sbin/sendmail';
}
elsif (-x '/usr/lib/sendmail') {
	$sendmailpath = '/usr/lib/sendmail';
}

#-->> Installation

my $contents = '';
if ($action eq $lang->{'Install'}) {
	#-->> MySQL Creation Queries

	my (@TableQuery, @InsertQuery);
	push(@TableQuery, ['perlQAdmin', "CREATE TABLE perlQAdmin (perlQID BIGINT(20) UNSIGNED NOT NULL, Version CHAR(10) NOT NULL, Passwd VARCHAR(20) NOT NULL, Template VARCHAR(50) NOT NULL, Language VARCHAR(50) NOT NULL, AdminLanguage VARCHAR(50) NOT NULL, SendmailPath VARCHAR(100) NOT NULL, SMTPServer VARCHAR(100) NOT NULL, SummaryLimit INT UNSIGNED NOT NULL DEFAULT 10, TextareaLimit INT UNSIGNED NOT NULL DEFAULT 5, PopupLimit INT UNSIGNED NOT NULL DEFAULT 5, AdvanceInterface ENUM('y','n') NOT NULL DEFAULT 'n', InCgiBin ENUM('y','n') NOT NULL DEFAULT 'y', ListSurvey ENUM('y','n') NOT NULL DEFAULT 'y', TimeOut BIGINT UNSIGNED NOT NULL, CookieDomain VARCHAR(255) NOT NULL)"]);

	push(@TableQuery, ['perlQAnswer', "CREATE TABLE perlQAnswer (UID BIGINT UNSIGNED NOT NULL, SID BIGINT UNSIGNED NOT NULL, QID BIGINT UNSIGNED NOT NULL, Answer TEXT NOT NULL, UNIQUE uniqids (SID, QID, UID), INDEX index_uid (UID))"]);

	push(@TableQuery, ['perlQQuestion', "CREATE TABLE perlQQuestion (SID BIGINT UNSIGNED NOT NULL, QID BIGINT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT, SortOrder INT UNSIGNED NOT NULL, Question TEXT NOT NULL, Type ENUM('radio','checkbox','textfield','textarea','select','selectmult','pagebreak','htmlcontent') NOT NULL DEFAULT 'radio', Mult INT UNSIGNED NOT NULL DEFAULT 1, QuestionStyle VARCHAR(255) NOT NULL, Instructions TEXT NOT NULL, Answer TEXT NOT NULL, Choose VARCHAR(11) NOT NULL, DefaultAnswer TEXT NOT NULL, LargestAID INT UNSIGNED NOT NULL, ColNumb INT UNSIGNED NOT NULL DEFAULT 1, AnswerInputStyle VARCHAR(255) NOT NULL, AnswerTextStyle VARCHAR(255) NOT NULL, AnswerStyle VARCHAR(255) NOT NULL, Attributes TEXT NOT NULL, Required ENUM('y','n') NOT NULL DEFAULT 'y', Summary ENUM('y','n') NOT NULL DEFAULT 'n')"]);

	push(@TableQuery, ['perlQSession', "CREATE TABLE perlQSession (SessionID VARCHAR(255) NOT NULL, RecentTime BIGINT UNSIGNED NOT NULL)"]);

	push(@TableQuery, ['perlQSurvey', "CREATE TABLE perlQSurvey (SID BIGINT UNSIGNED NOT NULL PRIMARY KEY AUTO_INCREMENT, Name VARCHAR(255) NOT NULL, AddDate DATETIME NOT NULL DEFAULT '0000-00-00', SurveyUsers CHAR(3) NOT NULL DEFAULT '000', SurveyResults TINYINT NOT NULL, Width VARCHAR(255) NOT NULL, Indent INT UNSIGNED NOT NULL DEFAULT 20, QuestionNumb ENUM('y','n') NOT NULL DEFAULT 'y', QuestionStyle VARCHAR(255) NOT NULL, AnswerInputStyle VARCHAR(255) NOT NULL, AnswerTextStyle VARCHAR(255) NOT NULL, AnswerStyle VARCHAR(255) NOT NULL, ErrorStyle VARCHAR(255) NOT NULL, VerifyEmail TEXT NOT NULL, EmailFrom VARCHAR(255) NOT NULL, EmailSubject VARCHAR(255) NOT NULL, Template VARCHAR(50) NOT NULL, Language VARCHAR(50) NOT NULL, OnComplete TINYINT NOT NULL, RedirectURL TEXT NOT NULL, Completed TEXT NOT NULL, Description TEXT NOT NULL, AdminNotes TEXT NOT NULL, Active ENUM('y','n') NOT NULL DEFAULT 'n', StartDate DATETIME NOT NULL DEFAULT '0000-00-00', EndDate DATETIME NOT NULL DEFAULT '0000-00-00', AdvanceInterface ENUM('y','n') NOT NULL DEFAULT 'n', ResultsWidth VARCHAR(255) NOT NULL, ResultsBorder VARCHAR(255) NOT NULL, ResultsAnswer VARCHAR(255) NOT NULL, ResultsStats VARCHAR(255) NOT NULL, ResultsGraph VARCHAR(255) NOT NULL, SubmitImageSrc VARCHAR(255) NOT NULL, SubmitImageWidth INT UNSIGNED NOT NULL, SubmitImageHeight INT UNSIGNED NOT NULL, SubmitImageText VARCHAR(255) NOT NULL, ResultImageSrc VARCHAR(255) NOT NULL, ResultImageWidth INT UNSIGNED NOT NULL, ResultImageHeight INT UNSIGNED NOT NULL, ResultImageText VARCHAR(255) NOT NULL,NextImageSrc VARCHAR(255) NOT NULL, NextImageWidth INT UNSIGNED NOT NULL, NextImageHeight INT UNSIGNED NOT NULL, NextImageText VARCHAR(255) NOT NULL, ResponseNotice TINYINT NOT NULL, ResponseEmail TEXT NOT NULL)"]);

	push(@TableQuery, ['perlQUser', "CREATE TABLE perlQUser (UID BIGINT UNSIGNED NOT NULL PRIMARY KEY DEFAULT 0, SID BIGINT UNSIGNED NOT NULL, IPAddr VARCHAR(100) NOT NULL, BlockDupe VARCHAR(40) NOT NULL, CheckType CHAR(3) NOT NULL DEFAULT '000', Email VARCHAR(255) NOT NULL, Confirm VARCHAR(50) NOT NULL, EmailConfirm ENUM('y','n') NOT NULL DEFAULT 'n', CompleteDate DATETIME NOT NULL DEFAULT '0000-00-00')"]);

	push(@InsertQuery, ['perlQAdmin', "INSERT INTO perlQAdmin VALUES ($perlQID, '".$perlQ->getVersion."', 'password', 'default', '$uselang', '$uselang', '$sendmailpath', '', 10, 5, 5, 'n', '$incgibin', 'y', 0, '')"]);

	push(@InsertQuery, ['perlQSurvey', "INSERT INTO perlQSurvey VALUES (1, 'What is your opinion of perlQ?', now(), '110', '0', '450', '20', 'y', 'font-weight: 700; color: #669933;', '', 'color: #115533;', '', 'color: red;', 'Greetings,\n\nBefore the results of the survey \"::SurveyName::\" are submitted, there is one more step you must complete.  In order to store and validate your responses, you must visit the following URL:\n\n::ConfirmURL::\n\nAlternatively, if you are still at the confirmation page that was displayed at the end of your survey, you may enter the password shown below:\n\nYour Confirmation Password is: ::ConfirmPassword::\n\nThank you for completing our survey.', 'perlQ <you\@yourdomain.com>', 'Survey Email Verification', 'default', 'english', '0', '', '<TABLE CELLPADDING=5 CELLSPACING=5 BORDER=0 WIDTH=400><TR><TD ALIGN=center>Survey Completed.</TD></TR></TABLE>', 'Example survey demonstrating several advanced features of perlQ', 'The following is an example survey that demonstrates multiple page surveys, verified email user restrictions, and cookie based user restrictions.', 'y', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 'n', '500', 'background-color: #333366; color: #FFFFFF; text-decoration: none;', 'background-color: #FFFFFF; color: #333366;', 'background-color: #DDEEFF; color: #333366;', 'background-color: #333366; height: 8px;', '', 0, 0, 'Submit', '', 0, 0, 'Show Results', '', 0, 0, 'Next', 0, '')"]);

	# If form is filled out and DBInfo.cgi is writable...
	if ($ErrorCode[0] && $ErrorCode[4]) {

		my $status = &printHead;
		$status .= &printStatus($ErrorCode[1], $lang->{'MySQLConnection'}, $lang->{'InvalidConnection'});

		# If MySQL is connected to the database...
		my ($QuerySuccess, $InsertSuccess) = (0, 0);
		if ($ErrorCode[1] && $ErrorCode[2]) {
			my ($addsuccess, $querymsg) = (0, $lang->{'NoConnection'});
			($QuerySuccess, $InsertSuccess) = (1, 1);

			for (my $i = 0; $i < @TableQuery; $i++) {
				if (&findTable($dbh, $TableQuery[$i]->[0])) {
					$querymsg = $lang->{'DuplicateTable'};
				}
				else {
					eval {
						$dbh->do($TableQuery[$i]->[1]);
						$addsuccess = 1;
					};

					if ($@) {
						$QuerySuccess = 0;
						$querymsg = $lang->{'CreateTableError'};
					}
				}
				$status .= &printStatus($addsuccess, sprintf($lang->{'CreateTable'}, $TableQuery[$i]->[0]), $querymsg);
			}

			for (my $j = 0; $j < @InsertQuery; $j++) {
				my ($addsuccess, $querymsg) = (0, '');
				if (&findTable($dbh, $InsertQuery[$j]->[0])) {
					my $qadmin = $dbh->prepare("SELECT * FROM $InsertQuery[$j]->[0] LIMIT 1");
					if ($qadmin->execute && $qadmin->rows) {
						$querymsg = $lang->{'TableData'};
					}
					else {
						eval {
							$dbh->do($InsertQuery[$j]->[1]);
							$addsuccess = 1;
						};

						if ($@) { $querymsg = $lang->{'InsertTableError'}; }
					}
					$qadmin->finish;
				}
				else {
					$querymsg = sprintf($lang->{'TableNotFound'}, $InsertQuery[$j]->[0]);
				}
				$status .= &printStatus($addsuccess, sprintf($lang->{'InsertTable'}, $InsertQuery[$j]->[0]), $querymsg);
				if (!$addsuccess) { $InsertSuccess = 0; }
			}
		}
		
		$status .= &printEnd();

		my $tail = 0;
		if ($ErrorCode[1] && $ErrorCode[2] && $QuerySuccess && $InsertSuccess) {
			&updateMySQLFile($mysqlhost, $mysqluser, $mysqlpasswd, $mysqldb);
			$tail = 1;
		}

		$contents = &getStatusPage($perlQ, $action, $status, $tail);
	}
	else {
		if (!$ErrorCode[4]) {
			$contents = &getStartPage($perlQ, $uselang, '', \%htmlconfig);
		}
		else {
			$contents = &getStartPage($perlQ, $uselang, $lang->{'CompleteAllFields'}, \%htmlconfig);
		}
	}
}
elsif ($action eq $lang->{'Upgrade'} || $action eq $lang->{'BackupDatabase'}) {
	# If form is filled out and DBInfo.cgi is writable...
	if ($ErrorCode[0] && $ErrorCode[4]) {
		# If MySQL is connected to the database...
		my ($maadmin,$breakmsg) = (0,'');
		if ($ErrorCode[1] && $ErrorCode[2]) {
			my $query = $dbh->prepare("SELECT * FROM perlQAdmin LIMIT 1");
			if ($query->execute && $query->rows) {
				$maadmin = $query->fetchrow_hashref;
				if ($maadmin->{'Passwd'} ne $apasswd) {
					$breakmsg = $lang->{'InvalidAdminPassword'};
				}

				if ($maadmin->{'Version'} > $perlQ->getVersion &&
				    $action ne $lang->{'BackupDatabase'}) {
					$breakmsg = sprintf($lang->{'VersionAlreadyExists'}, $maadmin->{'Version'});
				}
			}
			else {
				$breakmsg = $lang->{'UnknownAdminPassword'};
			}
		}
		else {
			$breakmsg = $lang->{'InvalidConnection'};
		}

		if ($breakmsg) {
			$contents = &getStartPage($perlQ, $uselang, $breakmsg, \%htmlconfig);
			&formatPage($perlQ, $contents);
		}

		if ($action eq $lang->{'BackupDatabase'}) {
			require "Export.cgi";
			my ($mday, $mon, $year) = (localtime(time))[3,4,5];
			my $date = sprintf('%04d-%02d-%02d', $year + 1900, $mon + 1, $mday);
			my $filename = "backup_$date\.perlQ";
			print $cgi->header(-type => 'text/perlQ', -Pragma => 'no-cache',
			    '-Content-Disposition' => "attachment; filename=$filename");
			&backupAllData($perlQ, 0, 0);
			$perlQ->exit;
		}

		my $successstatus = 1;
		my @statusmsg = ();
		if ($maadmin->{'Version'} < 2.1) {
			my $query = $dbh->prepare("SHOW KEYS FROM perlQAnswer");
			my $findkey = 0;
			if ($query->execute && $query->rows) {
				for (my $i = 0; $i < $query->rows; $i++) {
					my $row = $query->fetchrow_hashref;
					if (lc($row->{'Key_name'}) eq 'index_uid') {
						$findkey = 1;
						last;
					}
				}
			}

			my $keymsgleft = sprintf($lang->{'AddColumnToTable'}, 'index_uid', 'perlQAnswer');

			if (!$findkey) {
				my $addkey = $dbh->do("ALTER IGNORE TABLE perlQAnswer ADD INDEX index_uid (UID)");
				if ($addkey != 0) {
					push(@statusmsg, [$addkey, $keymsgleft, '']);
				}
				else {
					push(@statusmsg, [$addkey, $keymsgleft, $lang->{'AddColumnFailure'}]);
					$successstatus = 0;
				}
			}
			else {
				push(@statusmsg, [$findkey, $keymsgleft, '']);
			}

			my $addfields = [['perlQSurvey', 'SubmitImageSrc', 'SubmitImageSrc VARCHAR(255) NOT NULL'],
			    ['perlQSurvey', 'SubmitImageWidth', 'SubmitImageWidth INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'SubmitImageHeight', 'SubmitImageHeight INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'SubmitImageText', 'SubmitImageText VARCHAR(255) NOT NULL'],
			    ['perlQSurvey', 'ResultImageSrc', 'ResultImageSrc VARCHAR(255) NOT NULL'],
			    ['perlQSurvey', 'ResultImageWidth', 'ResultImageWidth INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'ResultImageHeight', 'ResultImageHeight INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'ResultImageText', 'ResultImageText VARCHAR(255) NOT NULL'],
			    ['perlQSurvey', 'NextImageSrc', 'NextImageSrc VARCHAR(255) NOT NULL'],
			    ['perlQSurvey', 'NextImageWidth', 'NextImageWidth INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'NextImageHeight', 'NextImageHeight INT UNSIGNED NOT NULL'],
			    ['perlQSurvey', 'NextImageText', 'NextImageText VARCHAR(255) NOT NULL']];

			my $addresult = &addColumns($perlQ, $addfields);
			$successstatus = $addresult->[0] ? $successstatus : 0;
			for (my $i=0; $i < @{ $addresult->[1] }; $i++) {
				push(@statusmsg, [$addresult->[1][$i][0], $addresult->[1][$i][1], $addresult->[1][$i][2]]);
			}

			# Set default values for new columns...
			$dbh->do("UPDATE perlQSurvey SET SubmitImageText='".$lang->{'Submit'}."', ResultImageText='".$lang->{'ShowResults'}."', NextImageText='".$lang->{'Next'}."'");

			if ($successstatus) {
				my $uversion = $dbh->do("UPDATE perlQAdmin SET Version='".$perlQ->getVersion."'");
				push(@statusmsg, [$uversion, $lang->{'UpdatingVersion'}, sprintf($lang->{'VersionInstalled'}, $perlQ->getVersion)]);
			}
			else {
				push(@statusmsg, [0, $lang->{'UpdatingVersion'}, $lang->{'VersionErrors'}]);
			}
		}

		if ($maadmin->{'Version'} < 2.2) {
			my @modfields = ("Type ENUM('radio','checkbox','textfield','textarea','select','selectmult','pagebreak','htmlcontent') NOT NULL DEFAULT 'radio'");

			my $modsuccess = 1;
			for (my $i = 0; $i < @modfields; $i++) {
				$modsuccess = $dbh->do("ALTER TABLE perlQQuestion MODIFY ".$modfields[$i]) ? $modsuccess : 0;
			}

			$successstatus = $modsuccess ? $successstatus : 0;
			push(@statusmsg, [$modsuccess, sprintf($lang->{'ModifyingColumns'}, 'perlQQuestion'), $lang->{'ModifyColumnFailure'}]);

			my $addfields = [['perlQSurvey', 'ResponseNotice', 'ResponseNotice TINYINT NOT NULL'],
			    ['perlQSurvey', 'ResponseEmail', 'ResponseEmail TEXT NOT NULL']];

			my $addresult = &addColumns($perlQ, $addfields);
			$successstatus = $addresult->[0] ? $successstatus : 0;
			for (my $i=0; $i < @{ $addresult->[1] }; $i++) {
				push(@statusmsg, [$addresult->[1][$i][0], $addresult->[1][$i][1], $addresult->[1][$i][2]]);
			}

			if ($successstatus) {
				my $uversion = $dbh->do("UPDATE perlQAdmin SET Version='".$perlQ->getVersion."'");
				push(@statusmsg, [$uversion, $lang->{'UpdatingVersion'}, sprintf($lang->{'VersionInstalled'}, $perlQ->getVersion)]);
			}
			else {
				push(@statusmsg, [0, $lang->{'UpdatingVersion'}, $lang->{'VersionErrors'}]);
			}
		}
		else {
			 push(@statusmsg, [1, sprintf($lang->{'VersionAlreadyExists'}, $maadmin->{'Version'}), '']);
		}

		my $status = &printHead;
		$status .= &printStatus($ErrorCode[1], $lang->{'MySQLConnection'}, $lang->{'InvalidConnection'});
		for (my $i = 0; $i < @statusmsg; $i++) {
			 $status .= &printStatus($statusmsg[$i]->[0], $statusmsg[$i]->[1], $statusmsg[$i]->[2]);
		}
		$status .= &printEnd;

		my $tail = 0;
		# Everything succeeded as planned...
		if ($ErrorCode[1] && $ErrorCode[2] && $successstatus) {
			&updateMySQLFile($mysqlhost, $mysqluser, $mysqlpasswd, $mysqldb);
			$tail = 1;
		}

		$contents = &getStatusPage($perlQ, $action, $status, $tail);
	}
	else {
		if (!$ErrorCode[4]) {
			$contents = &getStartPage($perlQ, $uselang, '', \%htmlconfig);
		}
		else {
			$contents = &getStartPage($perlQ, $uselang, $lang->{'CompleteAllFields'}, \%htmlconfig);
		}
	}
}
else {
	$contents = &getStartPage($perlQ, $uselang, '', \%htmlconfig);
}

&formatPage($perlQ, $contents);

#-->> Functions

sub findTable {
	my ($dbh, $table) = @_;
	my $retval = 0;

	my $query = $dbh->prepare("SHOW TABLES");
	if ($query->execute && $query->rows) {
		for (my $i = 0; $i < $query->rows; $i++) {
			if (lc($table) eq lc(($query->fetchrow_array)[0])) {
				$retval = 1;
				last;
			}
		}
	}
	$query->finish;

	return $retval;
}

sub findColumn {
	my ($dbh, $column, $table) = @_;
	my $query = $dbh->prepare("SELECT * FROM $table LIMIT 1");
	if ($query->execute && $query->rows) {
		my $row = $query->fetchrow_hashref;
		foreach my $col (keys %$row) {
			if (lc($col) eq lc($column)) {
				return 1;
			}
		}
	}
	return 0;
}

sub printHead {
	return "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";
}

sub printStatus {
	my ($condition, $text, $errormsg) = @_;

	my ($color, $status) = ('#009900', 'Success!');
	if (!$condition || $condition == 0) {
		$color = '#990000';
		$status = "Failed! - $errormsg";
	}
	
	my $result = "<TR>\n";
	$result .= "<TD ALIGN=right><B>$text:</B>&nbsp;</TD>\n";
	$result .= "<TD><FONT COLOR=\"$color\"><B>$status</B></TD>\n";
	$result .= "</TR>\n";
	
	return $result;
}

sub printEnd {
	return "</TABLE>\n";
}

sub updateMySQLFile {
	my ($mysqlhost, $mysqluser, $mysqlpasswd, $mysqldb) = @_;
	
	my $dbconfigpath = $perlQ->getFilePath('perlQMod/DBInfo.cgi');
	open(M, "$dbconfigpath");
	my $dbconfig = join('', <M>);
	close(M);

	$dbconfig =~ s/\$dsn\s*=\s*'[^']*';/\$dsn = 'DBI:mysql:database=$mysqldb;host=$mysqlhost';/;
	$dbconfig =~ s/\$user\s*=\s*'[^']*';/\$user = '$mysqluser';/;
	$dbconfig =~ s/\$password\s*=\s*'[^']*';/\$password = '$mysqlpasswd';/;

	open(M, ">$dbconfigpath");
	print M $dbconfig;
	close(M);
}

sub getStartPage {
	my ($perlQ, $uselang, $message, $htmlconfig) = @_;
	my %languages = $perlQ->getLanguages('ADMIN');
	my $imgurl = $perlQ->getImageDir(1);
	my $limgurl = $perlQ->getImageDir(0);
	my $durl = $perlQ->getImgURL('docs', 1);
	
	$message = ($message) ? "<FONT COLOR=red><B>$lang->{'ErrorMessage'}:</B> $message</FONT><BR><BR>" : "";

	my $chmodnote = '';
	if (!-w $perlQ->getFilePath('perlQMod/DBInfo.cgi')) {
		$chmodnote = "<TR><TD COLSPAN=2 ALIGN=center><NOBR>$lang->{'ChmodWarning'}</NOBR></TD></TR>";
	}

	my $moreinfotext = sprintf($lang->{'MoreInfo'}, "<a href=\"$durl/index.html#install-auto\" class=link>", '</a>');

	my $langselect = '<TR><TD>&nbsp;</TD></TR>';
	if ((keys %languages) > 1) {
		$langselect = '<TR><FORM NAME=lang METHOD=GET><TD ALIGN=right><B>'.$lang->{'Language'}.':</B> <select name=language onChange="javascript:document.lang.submit();">';
		foreach my $lang (sort { $languages{$a} cmp $languages{$b} } keys %languages) {
			my $seltext = ($lang eq $uselang) ? ' SELECTED' : '';
			$langselect .= "<OPTION$seltext VALUE=\"$lang\">$languages{$lang}</OPTION>\n";
		}
		$langselect .= '</select></TD></FORM></TR>';
	}

	my $contents = <<"END";
	$message
	<TABLE CELLPADDING=1 CELLSPACING=0 BORDER=0>
	$langselect
	<TR><TD>
	<FORM ACTION=install.cgi METHOD=POST>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 BGCOLOR="#EEEEEE">
	<TR>
		<TD>
		<TABLE CELLPADDING=1 CELLSPACING=1 BORDER=0 WIDTH=550>
		$chmodnote
		<TR>
			<TD BGCOLOR="#FFFFFF" VALIGN=top ALIGN=center WIDTH=50%>
		
	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
	<TR>
		<TD COLSPAN=3>
		<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
		<TR>
			<TD><IMG SRC="$imgurl/step1.gif" WIDTH=62 HEIGHT=62 ALT="$lang->{'Install'}"></TD>
			<TD>$lang->{'InstallText'}</TD>
		</TR>
		</TABLE>
		</TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLHostname'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_host', 'MySQLHostname')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqlhost CLASS=medium VALUE="$htmlconfig->{'host'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLUsername'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_user', 'MySQLUsername')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqluser CLASS=medium VALUE="$htmlconfig->{'user'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLPassword'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_passwd', 'MySQLPassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=password NAME=mysqlpasswd CLASS=medium VALUE="$htmlconfig->{'passwd'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLDatabase'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_db', 'MySQLDatabase')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqldb CLASS=medium VALUE="$htmlconfig->{'db'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'InCgiBin'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('a_cgibin', 'InCgiBin')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><SELECT TYPE=text NAME=incgibin><OPTION VALUE="1">$lang->{'Yes'}<OPTION VALUE="0">$lang->{'No'}</SELECT></TD><TD>&nbsp;</TD><TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD BACKGROUND="$imgurl/buttonactive.gif"><IMG SRC="$limgurl/buttondeactive.gif" WIDTH=13 HEIGHT=13 BORDER=0></TD></TR></TABLE></TD><TD ALIGN=center>&nbsp;</TD></TR></TABLE></TD>
	</TR>
	<TR>
		<TD COLSPAN=2>$lang->{'InCgiBinColors'}</TD>
		<TD><INPUT TYPE=submit NAME="action" VALUE="$lang->{'Install'}">
	</TR>
	<INPUT TYPE=hidden NAME="language" VALUE="$uselang">
	</FORM>
	</TABLE>
	
		</TD>
		<TD BGCOLOR="#FFFFFF" VALIGN=top ALIGN=center WIDTH=50%>

	<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
	<FORM ACTION="install.cgi" METHOD=POST>
	<TR>
		<TD COLSPAN=3>
		<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>
		<TR>
		<TD><IMG SRC="$imgurl/step2.gif" WIDTH=62 HEIGHT=62 ALT="$lang->{'Upgrade'}"></TD>
		<TD>$lang->{'UpgradeText'}</TD>
		</TR>
		</TABLE>
		</TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLHostname'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_host', 'MySQLHostname')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqlhost CLASS=medium VALUE="$htmlconfig->{'host'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLUsername'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_user', 'MySQLUsername')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqluser CLASS=medium VALUE="$htmlconfig->{'user'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLPassword'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_passwd', 'MySQLPassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=password NAME=mysqlpasswd CLASS=medium VALUE="$htmlconfig->{'passwd'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'MySQLDatabase'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_db', 'MySQLDatabase')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=text NAME=mysqldb CLASS=medium VALUE="$htmlconfig->{'db'}"></TD>
	</TR>
	<TR>
		<TD ALIGN=right><NOBR><B>$lang->{'AdminPassword'}:</B></NOBR></TD>
		<TD><A HREF="javascript:perlQHelp('m_apasswd', 'AdminPassword')"><IMG SRC="$imgurl/qmark.gif" WIDTH=13 HEIGHT=13 BORDER=0 ALT="$lang->{'?'}"></A></TD>
		<TD><INPUT TYPE=password NAME=apasswd CLASS=medium VALUE="$htmlconfig->{'apasswd'}"></TD>
	</TR>
	<TR>
		<TD COLSPAN=2><INPUT TYPE=submit name="action" VALUE="$lang->{'BackupDatabase'}"></TD>
		<TD><INPUT TYPE=submit NAME="action" VALUE="$lang->{'Upgrade'}">
	</TR>
	<INPUT TYPE=hidden NAME="language" VALUE="$uselang">
	</FORM>
	</TABLE>
	
		</TD>
		</TR>
		<TR>
			<TD COLSPAN=2 ALIGN=center><NOBR>$moreinfotext</NOBR></TD>
		</TR>
		</TABLE>
		</TD>
	</TR>
	</TABLE>
	</TD></TR></TABLE>
END

	return $contents;
}

sub getStatusPage {
	my ($perlQ, $action, $message, $tail) = @_;
	my $lang = $perlQ->getLanguage;
	my $imgurl = $perlQ->getImageDir(1);

	my $step = 'step1.gif';
	my $stepalt = $lang->{'Install'};
	my $status = $lang->{'InstallationStatus'};
	if ($action eq $lang->{'Upgrade'}) {
		$step = "step2.gif";
		$stepalt = $lang->{'Upgrade'};
		$status = $lang->{'UpgradeStatus'};
	}
	
	my $warning = '';
	my $button = "<INPUT TYPE=button ONCLICK=\"RestartInstallation();\" VALUE=\"Try Again\">\n";
	if ($tail) {
		$warning = sprintf($lang->{'InstallDoneText'}, $status);
		if ($action eq $lang->{'Install'}) {
			$warning .= $lang->{'InstallPasswordWarning'};
		}
		elsif ($action eq $lang->{'Upgrade'}) {
			$warning .= $lang->{'UpgradePasswordWarning'};
		}
		$warning .= "</ul>";

		$warning = "<TR><TD BGCOLOR=\"#FFFFFF\">$warning</TD></TR>\n";
		$button = "<INPUT TYPE=button ONCLICK=\"EndInstallation();\" VALUE=\"$lang->{'ProceedtoAdmin'}\">\n";
	}
	
	$contents .= <<"END";
	<TABLE CELLPADDING=1 CELLSPACING=0 BORDER=0>
	<TR><TD>&nbsp;</TD></TR>
	<TR><TD>
	<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 BGCOLOR="#EEEEEE">
	<TR>
		<TD>
		<TABLE CELLPADDING=1 CELLSPACING=1 BORDER=0>
		<TR><TD><B>$status:</B></TD></TR>
		<TR>
			<TD BGCOLOR="#FFFFFF" VALIGN=top ALIGN=center>
			<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%>
			<TR>
				<TD VALIGN=top ALIGN=left><IMG SRC="$imgurl/$step" WIDTH=62 HEIGHT=62 ALT="$stepalt"></TD>
				<TD>$message</TD>
			</TR>
			</TABLE>
			</TD>
		</TR>
		$warning
		<TR>
			<TD ALIGN=center>
			$button
			</TD>
		</TR>
		</TABLE>
		</TD>
	</TR>
	</TABLE>
	</TD></TR></TABLE>
END

	return $contents;
}

sub formatPage {
	my ($perlQ, $contents) = @_;
	my $imgurl = $perlQ->getImageDir(1); # The 1 forces use of img.cgi
	my $aimgurl = $perlQ->getImgURL('admin/images', 1);
	my $lang = $perlQ->getLanguage;
	my $durl = $perlQ->getImgURL('docs', 1);

	$contents = <<"END";
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=550>
<TR>
	<TD><IMG SRC="$imgurl/headinginstallation.gif" WIDTH=74 HEIGHT=17 ALT="$lang->{'Installation'}"></TD>
</TR>
<TR>
	<TD ALIGN=center>
	$contents
	</TD>
</TR>
</TABLE>
END

	#-->> Output Page

	# Create the chumpsoft tab.
	my $menu = "<TD><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=5 HEIGHT=1 ALT=\"\"></TD>\n";
	$menu .= "<TD><IMG SRC=\"$aimgurl/tableft.gif\" WIDTH=4 HEIGHT=15 ALT=\"\"></TD>\n";
	$menu .= "<TD BGCOLOR=#99CCFF><NOBR>\n";
	$menu .= "<B>chumpsoft :: perlQ</B></A></NOBR></TD>\n";
	$menu .= "<TD><IMG SRC=\"$aimgurl/tabright.gif\" WIDTH=7 HEIGHT=15 ALT=\"\"></TD>\n";

	my $js = <<"END";
<SCRIPT>
function EndInstallation () {
	this.location = "admin/index.cgi";
}
	
function RestartInstallation () {
	this.location = "install.cgi";
}

function perlQHelp (helpcontent, heading) {
	if (helpwin) { helpwin.close(); }
	var helpwin = window.open("admin/help.cgi?loc="+helpcontent+"&hd="+heading, "help", "directories=no,toolbar=no,menubar=no,location=no,resize=yes,status=no,resizable=yes,scrollbars=yes,width=465,height=275");
	helpwin.focus();
}
</SCRIPT>
END

	#-->> Reading Template

	open(T, $perlQ->getFilePath('admin/template.html'));
	my $templatedata = join('', <T>);
	close(T);

	# This is a hack since the template was designed to be viewed from admin/ dir
	$templatedata =~ s/HREF="..\/docs\//HREF="$durl\//g;
	$templatedata =~ s/HREF="index.cgi/HREF="admin\/index.cgi/g;
	my $aurl = $perlQ->getImgURL('admin', 1);
	$templatedata =~ s/HREF="favicon\.ico/HREF="$aurl\/favicon\.ico/g;
	$templatedata =~ s/SRC="images\//SRC="$aimgurl\//g;
	$templatedata =~ s/HREF="template\.css"/HREF="$aurl\/template\.css"/g;

	# Substitute data into template
	$templatedata =~ s/::CHARSET::/$lang->{'CHARSET'}/g;
	$templatedata =~ s/::USERMANUAL::/$lang->{'UserManual'}/g;
	$templatedata =~ s/::SURVEYNAME::/$lang->{'AdminTitle'} :: $lang->{'Installation'}/g;
	$templatedata =~ s/::JSINIT:://g;
	$templatedata =~ s/::MESSAGE:://g;
	$templatedata =~ s/::CONTENT::/$contents/g;
	$templatedata =~ s/::JSCRIPT::/$js/g;
	$templatedata =~ s/::MENU::/$menu/g;

	print $cgi->header;
	print $templatedata;
	$perlQ->exit;
}

sub addColumns {
	my $perlQ = shift;
	my $addfields = shift;
	my @statusmsg = ();
	my $successstatus = 1;

	for (my $i = 0; $i < @$addfields; $i++) {
		my $findcol = &findColumn($perlQ->getDBH, $addfields->[$i][1], $addfields->[$i][0]);
		my $colmsgleft = sprintf($lang->{'AddColumnToTable'}, $addfields->[$i][1], $addfields->[$i][1]);
		if (!$findcol) {
			my $addsuccess = $dbh->do("ALTER TABLE $addfields->[$i][0] ADD $addfields->[$i][2]");
			if ($addsuccess != 0) {
				push(@statusmsg, [1, $colmsgleft, '']);
			}
			else {
				push(@statusmsg, [0, $colmsgleft, $lang->{'AddColumnFailure'}]);
				$successstatus = 0;
			}
		}
		else {
			push(@statusmsg, [1, $colmsgleft, '']);
		}
	}

	return [$successstatus, \@statusmsg];
}
