#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

use strict;

sub grabStats {
	my ($perlQ, $sid, $stattype) = @_;
	my $dbh = $perlQ->getDBH;

	my ($contents, $maxcolumn) = ('', 1);
	my @qarray;
	my $query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? ORDER BY SortOrder");
	$query->execute($sid);
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maquestion = $query->fetchrow_hashref;
		my @answerarray = $maquestion->{'Answer'} ? split(/\|\|\|/, $maquestion->{'Answer'}) : ();
		$maxcolumn = ((@answerarray+1) > $maxcolumn) ? @answerarray+1 : $maxcolumn;
		
		if ($maquestion->{'Type'} ne 'pagebreak' && $maquestion->{'Type'} ne 'htmlcontent') { push (@qarray, $maquestion); }
	}
	$query->finish;
	
	my ($totcolumn, $colspan) = ('', 0);
	$contents .= "<TABLE BORDER=1>";
	for (my $i = 0; $i < @qarray; $i++) {
		if ($qarray[$i]->{'Type'} eq 'textfield' || $qarray[$i]->{'Type'} eq 'textarea') {
			$colspan = $maxcolumn;
		}
		elsif ($qarray[$i]->{'Type'} eq 'select' || $qarray[$i]->{'Type'} eq 'selectmult') {
			my @answers = split(/\|\|\|/, $qarray[$i]->{'Answer'});
			for (my $j = 0; $j < @answers; $j++) {
				my @tempsplit = split(/\|\|/, $answers[$j]);
				if ($tempsplit[4] ne 'Y') { next; }
				$colspan++;
			}
			$totcolumn = '<TD BGCOLOR=#333366>&nbsp;</TD></TR>';
		}
		else {
			my @cols = split(/\|\|\|/, $qarray[$i]->{'Answer'});
			$colspan = @cols;
			$totcolumn = '<TD BGCOLOR=#333366>&nbsp;</TD></TR>';
		}

		$contents .= "<TR><TD COLSPAN=$colspan BGCOLOR=#333366><FONT COLOR=#FFFFFF><B>Question ".($i+1).":</B> $qarray[$i]->{'Question'}</FONT></TD>$totcolumn</TR>";
		$contents .= &grabAnswersEX($perlQ, $sid, $qarray[$i], $stattype, $maxcolumn);
		$contents .= "<TR><TD COLSPAN=$maxcolumn BGCOLOR=#EEEEEE>&nbsp;</TD></TR>";
	}
	$contents .= "</TABLE>";
	
	return $contents;
}

sub grabAnswersEX {
	my ($perlQ, $sid, $maquestion, $stattype, $colsize) = @_;
	my $qid = $maquestion->{'QID'};
	my $qtype = $maquestion->{'Type'};
	my $dbh = $perlQ->getDBH;
	my $lang = $perlQ->getLanguage;
	my $query;

	my $contents = '';
	if ($qtype =~ /^(select|selectmult|checkbox|radio)$/) {
		my (@answerarray, @countarray, %answerid) = ();

		my @temparray = split(/\|\|\|/, $maquestion->{'Answer'});
		my $diffcolsize = $colsize - @temparray - 1;

		$contents .= "<TR>";
		my $icount = 0;
		for (my $i = 0; $i < @temparray; $i++) {
			my @tempsplit = split(/\|\|/, $temparray[$i]);
			
			if ($tempsplit[4] ne 'Y' && $qtype =~ /^(select|selectmult)$/) { next; }

			push(@answerarray, \@tempsplit);
			push(@countarray, 0);

			my $bgcolor = ($icount % 2 == 0) ? "#999999" : "#DDDDDD";
			my $aid = $answerarray[$icount]->[1];
			if (substr($answerarray[$icount]->[2],0,11) eq "Textfield:(") {
				$answerid{"O$aid"} = $icount;
			 	my $ochoice = substr($answerarray[$icount]->[2],11,-1);
			 	$contents .= "<TD BGCOLOR=$bgcolor>$ochoice</TD>";
			}
			else {
				$answerid{"N$aid"} = $icount;
				$contents .= "<TD BGCOLOR=$bgcolor>$answerarray[$icount]->[2]</TD>";
			}
			$icount++;
		}
		$contents .= "<TD BGCOLOR=#336699><FONT COLOR=#FFFFFF><B>$lang->{'Total'}</B></FONT></TD></TR>";

		if ($stattype eq 'u' || $stattype eq 'v') {
			my $cletter = ($stattype eq 'u') ? 'n' : 'y';
			$query = $dbh->prepare("SELECT perlQAnswer.Answer, COUNT(*) as total FROM perlQAnswer,perlQUser WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQUser.EmailConfirm='$cletter' GROUP BY perlQAnswer.Answer");
		}
		else {
			$query = $dbh->prepare("SELECT Answer, COUNT(*) as total FROM perlQAnswer WHERE SID=? AND QID=? GROUP BY Answer");
		}
		$query->execute($sid, $qid);

		for (my $j = 0; $j < $query->rows; $j++) {
			my $maanswercount = $query->fetchrow_hashref;
			my @qanswers = split(/\|\|/, $maanswercount->{'Answer'});

			for (my $x = 0; $x < @qanswers; $x++) {
				if ($qanswers[$x] =~ /^O/) {
					my @oanswers = split(/\|/, $qanswers[$x]);
					if (defined $answerid{$oanswers[0]}) {
						$countarray[$answerid{$oanswers[0]}] += $maanswercount->{'total'};
					}
				}
				elsif (defined $answerid{$qanswers[$x]}) {
					$countarray[$answerid{$qanswers[$x]}] += $maanswercount->{'total'};
				}
			}
		}

		my ($totalcount, $largestcount) = (0, 0);
		for (my $x = 0; $x < @countarray; $x++) {
			if ($countarray[$x] > $largestcount) { $largestcount = $countarray[$x]; }
			$totalcount += $countarray[$x];
		}

		$contents .= "<TR>";
		for (my $k = 0; $k < @countarray; $k++) {
			my $bgcolor = ($k % 2 == 0) ? "#DDDDDD" : "#FFFFFF";
			$contents .= "<TD ALIGN=LEFT BGCOLOR=$bgcolor>$countarray[$k]</TD>";
		}
		$contents .= "<TD ALIGN=LEFT BGCOLOR=#99CCFF>$totalcount</TD></TR>";
		
		$contents .= "<TR>";
		for (my $k = 0; $k < @answerarray; $k++) {
			my $bgcolor = ($k % 2 == 0) ? "#DDDDDD" : "#FFFFFF";
			my $percent = ($totalcount > 0) ? sprintf("%.1f", (($countarray[$k] / $totalcount) * 100)) : 0;
			$contents .= "<TD ALIGN=LEFT BGCOLOR=$bgcolor>$percent%</TD>";
		}
		$contents .= "<TD ALIGN=LEFT BGCOLOR=#99CCFF>100%</TD></TR>";
	}
	elsif ($qtype eq 'textfield' || $qtype eq 'textarea') {
		$contents .= "<TR><TD COLSPAN=$colsize BGCOLOR=#DDDDDD>$lang->{'PEXNoText'}</TD></TR>";
	}
	
	return $contents;
}

sub str2CSV {
	my $mystring = shift;
	$mystring =~ s/\r//g;
	$mystring =~ s/\n/ /g;
	if ($mystring =~ /"/) { $mystring =~ s/\"/\"\"/g; }

	if ($mystring =~ /(?:"|,|\n)/) { return "\"$mystring\","; }
	return "$mystring,";
}

sub str2XML {
	my $mystring = shift;
	$mystring =~ s/\r//g;
	$mystring =~ s/\&/\&amp\;/g;
	$mystring =~ s/\</\&lt\;/g;
	$mystring =~ s/\>/\&gt\;/g;
	$mystring =~ s/"/\&quot\;/g;
	
	return $mystring;
}

sub str2SQL {
	my ($perlQ, $mystring) = @_;

	if (!defined $mystring) { return 'NULL'; }
	return '"' . $perlQ->getDBH->quote($mystring) . '"';
}

sub str2PERLQ {
	my ($perlQ, $mystring) = @_;

	if (!defined $mystring) { return '=NULL='; }
	return $perlQ->getHTML->urlencode($mystring);
}

sub terminateCSV { return substr(shift, 0, -1) . "\n"; }

# $answerchoices - list of all answer choices
# 0 - sort order
# 1 - ID without 'N' or 'O'
# 2 - actual answer
# 3 - default 'D' or 'N'
# 4 - selectable 'Y' or 'N'
sub findValue {
	my ($key, $answerchoices) = @_;
	for (my $i = 0; $i < @$answerchoices; $i++) {
		my $value = $answerchoices->[$i][2];
		if (substr($value, 0, 11) eq 'Textfield:(') {
			$value = substr($answerchoices->[$i][2], 11, -1);
		}
		if (substr($key, 1) eq $answerchoices->[$i][1]) { return $value; }
	}
	return '';
}

sub backupAllData {
	my ($perlQ, $sid, $swap) = @_;
	$sid = ($sid =~ /^(\d+)$/) ? $1 : 0;
	$swap = $swap ? 1 : 0;

	my $dbh = $perlQ->getDBH;
	my $query;

	my %perlQF = (
	    'Admin' => ['perlQID','Version','Template','Language','AdminLanguage','SendmailPath','SMTPServer','SummaryLimit','TextareaLimit','PopupLimit','AdvanceInterface','InCgiBin','ListSurvey','TimeOut','CookieDomain'],
	    'Answer' => ['UID','SID','QID','Answer'],
	    'Question' => ['SID','QID','SortOrder','Question','Type','Mult','QuestionStyle','Instructions','Answer','Choose','DefaultAnswer','LargestAID','ColNumb','AnswerInputStyle','AnswerTextStyle','AnswerStyle','Attributes','Required','Summary'],
	    'Survey' => ['SID','AddDate','Name','SurveyUsers','SurveyResults','Width','Indent','QuestionNumb','QuestionStyle','AnswerInputStyle','AnswerTextStyle','AnswerStyle','ErrorStyle','VerifyEmail','EmailFrom','EmailSubject','Template','Language','OnComplete','RedirectURL','Completed','Description','AdminNotes','Active','StartDate','EndDate','AdvanceInterface','ResultsWidth','ResultsBorder','ResultsAnswer','ResultsStats','ResultsGraph','SubmitImageSrc','SubmitImageWidth','SubmitImageHeight','SubmitImageText','ResultImageSrc','ResultImageWidth','ResultImageHeight','ResultImageText','NextImageSrc','NextImageWidth','NextImageHeight','NextImageText','ResponseNotice','ResponseEmail'],
	    'User' => ['UID','SID','IPAddr','BlockDupe','CheckType','Email','Confirm','EmailConfirm','CompleteDate']);

	my $version = $perlQ->getAdminField('Version');
	if ($version < 2.2) {
		splice(@{ $perlQF{'Survey'} }, 44, 2);
	}
	if ($version < 2.1) {
		splice(@{ $perlQF{'Survey'} }, 32, 12);
	}

	my $id = 'PERLQBACKUP';
	if ($sid) {
		$id = "SURVEYBACKUP";
		if ($swap) {
			$id = "SURVEYSWAP";
			splice(@{ $perlQF{'Survey'} }, 0, 2);
			splice(@{ $perlQF{'Question'} }, 0, 2);
		}
	}
	print "<!--PERLQBACKUP " . $version . " $id-->\n"; 

	if (!$sid) {
		print "TABLE|perlQAdmin|COLUMNS|" . join(',', @{ $perlQF{'Admin'} }) . "\n";
	}

	print "TABLE|perlQSurvey|COLUMNS|" . join(',', @{ $perlQF{'Survey'} }) . "\n";
	print "TABLE|perlQQuestion|COLUMNS|" . join(',', @{ $perlQF{'Question'} }) . "\n";

	if (!$swap) {
		print "TABLE|perlQUser|COLUMNS|" . join(',', @{ $perlQF{'User'} }) . "\n";
		print "TABLE|perlQAnswer|COLUMNS|" . join(',', @{ $perlQF{'Answer'} }) . "\n";
	}

	if (!$sid) {
		$query = $dbh->prepare("SELECT * FROM perlQAdmin LIMIT 1");
		if ($query->execute && $query->rows) {
			my $maadmin = $query->fetchrow_hashref;
			my @values = ();
			for (my $m = 0; $m < @{ $perlQF{'Admin'} }; $m++) {
				push(@values, &str2PERLQ($perlQ, $maadmin->{$perlQF{'Admin'}->[$m]}));
			}
			print "TABLE|perlQAdmin|VALUES|" . join('&', @values) . "\n";
		}
		$query->finish;
	}	
	
	my $where = $sid ? ' WHERE SID=' . $dbh->quote($sid) : '';
	my @tables = $swap ? qw(Survey Question) : qw(Survey Question User Answer);

	foreach my $table (@tables) {
		my $query = $dbh->prepare("SELECT * FROM perlQ$table$where");
		$query->execute;
		for (my $i = 0; $i < $query->rows; $i++) {
			my $maquery = $query->fetchrow_hashref;
			my @values = ();
			for (my $m = 0; $m < @{ $perlQF{$table} }; $m++) {
				push(@values, &str2PERLQ($perlQ, $maquery->{$perlQF{$table}->[$m]}));
			}
			print "TABLE|perlQ".$table."|VALUES|" . join('&', @values) . "\n";
		}
	}
}

sub formatSurveyData {
	my ($perlQ, $sid, $stattype, $format) = @_;
	$format = $format ? $format : 'csv';
	my $dbh = $perlQ->getDBH;
	my $lang = $perlQ->getLanguage;

	# Retrieve the survey verification limits.
	my $masurvey;
	my @bits = (0,0,0);
	my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
	if ($query->execute($sid) && $query->rows) {
		$masurvey = $query->fetchrow_hashref;
		@bits = (substr($masurvey->{'SurveyUsers'}, 0, 1),
		         substr($masurvey->{'SurveyUsers'}, 1, 1),
		         substr($masurvey->{'SurveyUsers'}, 2, 1));
	}
	else { return ''; }

	my $contents = '';

	my @perlQSfields = ('SID','Name','AddDate','SurveyUsers','SurveyResults','Width','Indent','QuestionNumb','QuestionStyle','AnswerInputStyle','AnswerTextStyle','AnswerStyle','ErrorStyle','VerifyEmail','EmailFrom','EmailSubject','Template','Language','OnComplete','RedirectURL','Completed','Description','AdminNotes','Active','StartDate','EndDate','AdvanceInterface','ResultsWidth','ResultsBorder','ResultsAnswer','ResultsStats','ResultsGraph','SubmitImageSrc','SubmitImageWidth','SubmitImageHeight','SubmitImageText','ResultImageSrc','ResultImageWidth','ResultImageHeight','ResultImageText','NextImageSrc','NextImageWidth','NextImageHeight','NextImageText','ResponseNotice','ResponseEmail');
	my @perlQQfields = ('SID','QID','SortOrder','Question','Type','Mult','QuestionStyle','Instructions','Answer','Choose','DefaultAnswer','LargestAID','ColNumb','AnswerInputStyle','AnswerTextStyle','AnswerStyle','Attributes','Required','Summary');
	my @perlQUfields = ('UID','SID','IPAddr','BlockDupe','CheckType','Email','Confirm','EmailConfirm','CompleteDate');
	my @perlQAfields = ('UID','SID','QID','Answer');

	if ($format eq 'xml') {
		$contents .= <<"ENDDTD";
<?xml version="1.0" encoding="$lang->{'CHARSET'}"?>
<!DOCTYPE survey [
	<!ELEMENT survey (name,description?,result*)>
	<!ELEMENT name (#PCDATA)>
	<!ELEMENT description (#PCDATA)>
	<!ELEMENT result (time,ip,email?,question*)>
	<!ELEMENT time (#PCDATA)>
	<!ELEMENT ip (#PCDATA)>
	<!ELEMENT email (#PCDATA)>
	<!ELEMENT question (asked,answer*)>
	<!ELEMENT asked (#PCDATA)>
	<!ELEMENT answer (selected?,entered?)+>
	<!ELEMENT selected (#PCDATA)>
	<!ELEMENT entered (#PCDATA)>

	<!ATTLIST survey id CDATA #REQUIRED>
	<!ATTLIST result id CDATA #REQUIRED>
	<!ATTLIST email verified (y|n) #REQUIRED>
	<!ATTLIST question id CDATA #REQUIRED>
	<!ATTLIST question type (checkbox|radio|select|selectmult|textfield|textarea) #REQUIRED>
	<!ATTLIST answer id CDATA #IMPLIED>
]>
ENDDTD

		$contents .= "\n<survey id=\"" . &str2XML($masurvey->{'SID'}) . "\">\n";
		$contents .= "\t<name>" . &str2XML($masurvey->{'Name'}) . "</name>\n";
		if ($masurvey->{'Description'}) {
			$contents .= "\t<description>" . &str2XML($masurvey->{'Description'}) . "</description>\n";
		}
	}
	elsif ($format eq 'xml-c') {
		$contents .= <<"ENDDTD";
<?xml version="1.0" encoding="$lang->{'CHARSET'}"?>
<!DOCTYPE survey [
	<!ELEMENT survey (config,r*)>
	<!ELEMENT config (name,description?,question*)>
	<!ELEMENT name (#PCDATA)>
	<!ELEMENT description (#PCDATA)>
	<!ELEMENT question (EMPTY|(asked,answer*))*>
	<!ELEMENT asked (#PCDATA)>
	<!ELEMENT answer (#PCDATA)>
	<!ELEMENT r (a*)>
	<!ELEMENT a (#PCDATA|EMPTY)*>

	<!ATTLIST survey id CDATA #REQUIRED>
	<!ATTLIST question id CDATA #REQUIRED>
	<!ATTLIST question type (checkbox|radio|select|selectmult|textfield|textarea|pagebreak|htmlcontent) #REQUIRED>
	<!ATTLIST answer id CDATA #IMPLIED>
	<!ATTLIST r id CDATA #REQUIRED>
	<!ATTLIST r time CDATA #REQUIRED>
	<!ATTLIST r ip CDATA #REQUIRED>
	<!ATTLIST r email CDATA #IMPLIED>
	<!ATTLIST r verified (y|n) #IMPLIED>
	<!ATTLIST a qid CDATA #REQUIRED>
	<!ATTLIST a id CDATA #IMPLIED>
]>
ENDDTD

		$contents .= "\n<survey id=\"" . &str2XML($masurvey->{'SID'}) . "\">\n";
		$contents .= "\t<config>\n";
		$contents .= "\t\t<name>" . &str2XML($masurvey->{'Name'}) . "</name>\n";
		if ($masurvey->{'Description'}) {
			$contents .= "\t\t<description>" . &str2XML($masurvey->{'Description'}) . "</description>\n";
		}
	}
	elsif ($format eq 'csv') {
		$contents .= "User ID,Completed On,IP Address,";
		if ($bits[2]) { $contents .= "Email Address,"; }
	}
	elsif ($format eq 'sql') {
		my @uvalues = ();
		for (my $m = 0; $m < @perlQSfields; $m++) {
			push(@uvalues, &str2SQL($perlQ, $masurvey->{$perlQSfields[$m]}));
		}
		$contents .= "INSERT INTO perlQSurvey (" . join(',', @perlQSfields) . ") VALUES (" . join(',', @uvalues) . ")\n";
	}
	elsif ($format eq 'perlQ') {
		$contents .= "<!--PERLQBACKUP " . $perlQ->getVersion . " SURVEY $sid-->\n"; 
		$contents .= "<!--TABLE perlQSurvey COLUMNS " . join(',', @perlQSfields) . "-->\n";
		$contents .= "<!--TABLE perlQQuestion COLUMNS " . join(',', @perlQQfields) . "-->\n";
		$contents .= "<!--TABLE perlQUser COLUMNS " . join(',', @perlQUfields) . "-->\n";
		$contents .= "<!--TABLE perlQAnswer COLUMNS " . join(',', @perlQAfields) . "-->\n";
		my @uvalues = ();
		for (my $m = 0; $m < @perlQSfields; $m++) {
			push(@uvalues, &str2PERLQ($perlQ, $masurvey->{$perlQSfields[$m]}));
		}
		$contents .= "<!--TABLE perlQSurvey VALUES " . join('&', @uvalues) . "-->\n";
	}

	$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? ORDER BY SortOrder");
	$query->execute($sid);
	my (@ac, @qarray);
	my $qorderi = 0;
	my $qorder;
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maquestion = $query->fetchrow_hashref;
		if ($maquestion->{'Type'} ne 'pagebreak' && $maquestion->{'Type'} ne 'htmlcontent') {
			my $qnum = $maquestion->{'QID'};
			$qarray[$qnum] = $maquestion;
			$qorder->{$qnum} = $qorderi;
			if ($format eq 'xml-c') {
				$contents .= "\t\t<question id=\"" . &str2XML($qnum) . "\" type=\"" . &str2XML($maquestion->{'Type'})."\">\n\t\t\t<asked>" . &str2XML($maquestion->{'Question'}) . "</asked>\n";
			}

			if ($maquestion->{'Type'} ne 'textfield' && $maquestion->{'Type'} ne 'textarea') {
				my @actemp = split(/\|\|\|/, $maquestion->{'Answer'});
				$ac[$qnum] = \@actemp;
				for (my $k = 0; $k < @actemp; $k++) {
					my @actemp2 = split(/\|\|/, $actemp[$k]);
					$ac[$qnum][$k] = \@actemp2;
					if ($format eq 'xml-c') {
						my $value = (substr($actemp2[2], 0, 11) eq 'Textfield:(') ? substr($actemp2[2], 11, -1) : $actemp2[2];
						$contents .= "\t\t\t<answer id=\"" . $actemp2[1] . "\">" . &str2XML($value) . "</answer>\n";
					}
				}
			}
			elsif ($format eq 'xml-c' && $maquestion->{'DefaultAnswer'}) {
				$contents .= "\t\t\t<answer>" . &str2XML($maquestion->{'DefaultAnswer'}) . "</answer>\n";
			}

			if ($format eq 'csv') {
				$contents .= &str2CSV($maquestion->{'Question'});
			}
			elsif ($format eq 'xml-c') {
				$contents .= "\t\t</question>\n";
			}
			$qorderi++;
		}
		elsif ($maquestion->{'Type'} ne 'htmlcontent') {
			if ($format eq 'xml-c') {
				$contents .= "\t\t<question id=\"" . &str2XML($maquestion->{'QID'}) . "\" type=\"pagebreak\" />\n";
			}
		}

		# When creating the SQL format, we insert all questions, even page breaks
		# and html content.
		if ($format eq 'sql') {
			my @uvalues = ();
			for (my $m = 0; $m < @perlQQfields; $m++) {
				push(@uvalues, &str2SQL($perlQ, $maquestion->{$perlQQfields[$m]}));
			}
			$contents .= "INSERT INTO perlQQuestion (" . join(',', @perlQQfields) . ") VALUES (" . join(',', @uvalues) . ")\n";
		}
		elsif ($format eq 'perlQ') {
			my @uvalues = ();
			for (my $m = 0; $m < @perlQQfields; $m++) {
				push(@uvalues, &str2PERLQ($perlQ, $maquestion->{$perlQQfields[$m]}));
			}
			$contents .= "<!--TABLE perlQQuestion VALUES " . join('&', @uvalues) . "-->\n";
		}
	}

	if ($format eq 'csv') {
		$contents = &terminateCSV($contents);
	}
	elsif ($format eq 'xml-c') {
		$contents .= "\t</config>\n";
	}

	print $contents;
	$contents = '';

	my ($auid, $aqid, $qclause) = (0, 0, '');
	if ($bits[2] && $stattype eq 'u' || $stattype eq 'v') {
		my $verification = ($stattype eq 'v') ? 'y' : 'n';
		$qclause = " AND EmailConfirm='$verification'";
	}
	my $qufields = ($format eq 'sql') ? 'perlQUser.*' : 'perlQUser.CompleteDate, perlQUser.IPAddr, perlQUser.Email, perlQUser.EmailConfirm';

	$query = $dbh->prepare("SELECT $qufields,perlQAnswer.* FROM perlQUser,perlQAnswer WHERE perlQAnswer.SID=? AND perlQAnswer.UID=perlQUser.UID$qclause ORDER BY perlQUser.CompleteDate DESC,perlQUser.UID");
	$query->execute($sid);
	my @displayqvalues = ();
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maanswer = $query->fetchrow_hashref;
		if ($maanswer->{'UID'} != $auid) {
			if ($format eq 'xml') {
				if ($auid) {
					$displayqvalues[$qorder->{$aqid}] .= "\t\t</question>\n";
					print join('', @displayqvalues);
					print "\t</result>\n";
					@displayqvalues = ();
					$aqid = 0;
				}
				$displayqvalues[0] .= "\t<result id=\"" . &str2XML($maanswer->{'UID'}) . "\">\n";
				$displayqvalues[0] .= "\t\t<time>" . &str2XML($maanswer->{'CompleteDate'}) . "</time>\n";
				$displayqvalues[0] .= "\t\t<ip>" . &str2XML($maanswer->{'IPAddr'}) . "</ip>\n";
				if ($bits[2] && $maanswer->{'Email'}) {
					my $confirm = ($maanswer->{'EmailConfirm'} eq 'y') ? 'y' : 'n';
					$displayqvalues[0] .= "\t\t<email verified=\"$confirm\">" . &str2XML($maanswer->{'Email'}) . "</email>\n";
				}
			}
			elsif ($format eq 'xml-c') {
				if ($auid) {
					print join('', @displayqvalues);
					print "\t</r>\n";
					@displayqvalues = ();
				}
				$displayqvalues[0] .= "\t<r id=\"" . &str2XML($maanswer->{'UID'}) . "\" time=\"" . &str2XML($maanswer->{'CompleteDate'}) . "\" ip=\"" . &str2XML($maanswer->{'IPAddr'}) . "\"";
				if ($bits[2] && $maanswer->{'Email'}) {
					my $confirm = ($maanswer->{'EmailConfirm'} eq 'y') ? 'y' : 'n';
					$displayqvalues[0] .= " email=\"" . &str2XML($maanswer->{'Email'}) . "\" verified=\"$confirm\"";
				}
				$displayqvalues[0] .= ">\n";
			}
			elsif ($format eq 'csv') {
				if ($auid) {
					print &terminateCSV(join('', @displayqvalues));
					@displayqvalues = ();
				}
				$displayqvalues[0] .= &str2CSV($maanswer->{'UID'});
				$displayqvalues[0] .= &str2CSV($maanswer->{'CompleteDate'});
				$displayqvalues[0] .= &str2CSV($maanswer->{'IPAddr'});
				if ($bits[2]) { $displayqvalues[0] .= &str2CSV($maanswer->{'Email'}); }
			}
			elsif ($format eq 'sql') {
				my @uvalues = ();
				for (my $m = 0; $m < @perlQUfields; $m++) {
					push(@uvalues, &str2SQL($perlQ, $maanswer->{$perlQUfields[$m]}));
				}
				print "INSERT INTO perlQUser (" . join(',', @perlQUfields) . ") VALUES (" . join(',', @uvalues) . ")\n";
			}
			$auid = $maanswer->{'UID'};
		}

		if ($maanswer->{'QID'} != $aqid) {
			if ($format eq 'xml') {
				if ($aqid) {
					$displayqvalues[$qorder->{$aqid}] .= "\t\t</question>\n";
				}
			}

			$aqid = $maanswer->{'QID'};

			if ($format eq 'xml') {
				$displayqvalues[$qorder->{$aqid}] .= "\t\t<question id=\"" . &str2XML($maanswer->{'QID'}) . "\" type=\"" . &str2XML($qarray[$maanswer->{'QID'}]->{'Type'}) . "\">\n";
				$displayqvalues[$qorder->{$aqid}] .= "\t\t\t<asked>" . &str2XML($qarray[$maanswer->{'QID'}]->{'Question'}) . "</asked>\n";
			}
		}

		if ($qarray[$maanswer->{'QID'}]->{'Type'} eq 'textfield' || $qarray[$maanswer->{'QID'}]->{'Type'} eq 'textarea') {
			if ($format eq 'xml') {
				$displayqvalues[$qorder->{$aqid}] .= "\t\t\t<answer>\n";
				$displayqvalues[$qorder->{$aqid}] .= "\t\t\t\t<entered>" . &str2XML($maanswer->{'Answer'}) . "</entered>\n";
				$displayqvalues[$qorder->{$aqid}] .= "\t\t\t</answer>\n";
			}
			elsif ($format eq 'xml-c') {
				$displayqvalues[$qorder->{$aqid}] .= "\t\t<a qid=\"" . &str2XML($maanswer->{'QID'}) . "\">" . &str2XML($maanswer->{'Answer'}) . "</a>\n";
			}
			elsif ($format eq 'csv') {
				$displayqvalues[$qorder->{$aqid}] .= &str2CSV($maanswer->{'Answer'});
			}
		}
		else {
			my @parseanswer = split(/\|\|/, $maanswer->{'Answer'});

			if ($format eq 'xml' || $format eq 'xml-c') {
				for (my $j = 0; $j < @parseanswer; $j++) {
					if ($parseanswer[$j] =~ /\|/) {
						my ($key, $textfield) = split(/\|/, $parseanswer[$j]);
						my $id = substr($key, 1);
						if ($format eq 'xml') {
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t<answer id=\"$id\">\n";
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t\t<selected>" . &str2XML(&findValue($key,$ac[$maanswer->{'QID'}])) . "</selected>\n";
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t\t<entered>" . &str2XML($textfield) . "</entered>\n";
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t</answer>\n";
						}
						elsif ($format eq 'xml-c') {
							$displayqvalues[$qorder->{$aqid}] .= "\t\t<a qid=\"$maanswer->{'QID'}\" id=\"$id\">" . &str2XML($textfield) . "</a>\n";
						}
					}
					elsif ($parseanswer[$j] ne '') {
						my $id = substr($parseanswer[$j], 1);
						if ($format eq 'xml') {
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t<answer id=\"$id\">\n";
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t\t<selected>" . &str2XML(&findValue($parseanswer[$j],$ac[$maanswer->{'QID'}])) . "</selected>\n";
							$displayqvalues[$qorder->{$aqid}] .= "\t\t\t</answer>\n";
						}
						elsif ($format eq 'xml-c') {
							$displayqvalues[$qorder->{$aqid}] .= "\t\t<a qid=\"$maanswer->{'QID'}\" id=\"$id\"/>\n";
						}
					}
				}
			}

			elsif ($format eq 'csv') {
				my $answer = '';
				for (my $j = 0; $j < @parseanswer; $j++) {
					if ($parseanswer[$j] =~ /\|/) {
						my ($key, $textfield) = split(/\|/, $parseanswer[$j]);
						$answer .= &findValue($key, $ac[$maanswer->{'QID'}]) . ": $textfield; ";
					}
					else {
						$answer .= &findValue($parseanswer[$j], $ac[$maanswer->{'QID'}]) . "; ";
					}
				}
				$displayqvalues[$qorder->{$aqid}] .= &str2CSV(substr($answer, 0, -2));
			}
		}

		if ($format eq 'sql') {
			my @uvalues = ();
			for (my $m = 0; $m < @perlQAfields; $m++) {
				push(@uvalues, &str2SQL($perlQ, $maanswer->{$perlQAfields[$m]}));
			}
			print "INSERT INTO perlQAnswer (" . join(',', @perlQAfields) . ") VALUES (" . join(',', @uvalues) . ")\n";
		}
	}

	if ($format eq 'xml') {
		$displayqvalues[$qorder->{$aqid}] .= "\t\t</question>\n";
		print join('', @displayqvalues);
		print "\t</result>\n</survey>\n";
	}
	elsif ($format eq 'xml-c') {
		print join('', @displayqvalues);
		print "\t</r>\n</survey>\n";
	}
	elsif ($format eq 'csv') {
		print &terminateCSV(join('', @displayqvalues));
	}
	
	@displayqvalues = ();
}

1;
