#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

package perlQMod::HTML;
use strict;

sub new {
	my $type = shift;
	my $this = {};
	$this->{'_state'} = shift || 0;

	$this->{'_message'} = '';
	@{ $this->{'_cookies'} } = ();

	return bless $this, $type;
}

sub getMessage { my $this = shift; return $this->{'_message'}; }
sub setMessage { my $this = shift; $this->{'_message'} = shift; }
sub getState { my $this = shift; return $this->{'_state'}; }

sub protectHTML {
	my $this = shift;
	my $text = shift || '';

	$text =~ s/\&/\&amp\;/g;
	$text =~ s/</\&lt\;/g;
	$text =~ s/>/\&gt\;/g;
	$text =~ s/"/\&quot\;/g;

	return $text;
}

sub freeHTML {
	my $this = shift;
	my $text = shift;

	$text =~ s/\&amp\;/\&/g;
	$text =~ s/\&lt\;/</g;
	$text =~ s/\&gt\;/>/g;
	$text =~ s/\&quot\;/"/g;

	return $text;
}

sub setcookie {
	my $this = shift;
	my %args = (-domain => $this->getState->getAdminField('CookieDomain'), -path => '/', @_);
	push(@{ $this->{'_cookies'} }, $this->getState->getCGI->cookie(%args));
}

sub redirect {
  my $this = shift;
  my $perlQ = $this->getState;
  my $cgi = $perlQ->getCGI;
  my %args = (@_);
  if (@{ $this->{'_cookies'} }) {
    print $cgi->header(-cookie => \@{ $this->{'_cookies'} });
    print "<html><head><meta http-equiv=\"Refresh\" content=\"0; URL=".$this->protectHTML($args{'-url'})."\"></head></html>";
  }
  else {
    print $cgi->redirect(%args);
  }
  $perlQ->exit;
}

sub page {
	my $this = shift;
	my $data = shift;
	my $perlQ = $this->getState;
	my $cgi = $perlQ->getCGI;

	my %args = ();
	if ($this->{'_cookies'}) {
		%args = (-cookie => \@{ $this->{'_cookies'} });
	}
	print $cgi->header(%args);
	print $data;
	$perlQ->exit;
}

sub createPage {
	my ($this, $sid, $title, $contents, $admin, $jsinfo, $cs) = @_;
	$cs = $cs || 0;
	$cs = ($cs =~ /^(\d+)$/) ? $1 : 0;
	my $perlQ = $this->getState;
	my $dbh = $perlQ->getDBH;
	my $lang = $perlQ->getLanguage;
	my $aimgurl = $perlQ->getImgURL('admin/images');

	#-->> Loading Template

	if ($sid eq 'stats' && !$admin) {
		$sid = $title->{'SID'};
		$title = "$title->{'Name'} : $lang->{'SurveyResultsTitle'}";
	}
	elsif ($sid eq 'stats') {
		$title = $lang->{'SurveyResultsTitle'};
	}

	my $template = $perlQ->getAdminField('Template') || 'default';
	$template = "templates/$template/index.html";
	if ($admin) {
		$template = 'admin/template.html';
	}
	elsif ($sid =~ /^\d+$/) {
		my $query = $dbh->prepare("SELECT Template FROM perlQSurvey WHERE SID=?");
		if ($query->execute($sid) && $query->rows) {
			my $masurvey = $query->fetchrow_hashref;
			if ($masurvey->{'Template'}) {
				$template = "templates/$masurvey->{'Template'}/index.html"
			}
		}
	}
	$template = $perlQ->getFilePath($template);

	#-->> Loading Default JS

	my $jsinit = '';
	if ($admin) {
		if ($sid eq 'login') {
			$jsinit = "ONLOAD=\"Init()\"";
		}
		elsif ($sid eq 'question') {
			$jsinit = "ONLOAD=\"Init()\"";
		}
	}

	$jsinfo =~ s/%%([^%]+)%%/$lang->{$1}/eg;

	#-->> Admin Menu

	my $menu;
	if ($sid eq 'login') {
		$menu = "<TD><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=5 HEIGHT=1 ALT=\"\"></TD>\n";
		$menu .= "<TD><IMG SRC=\"$aimgurl/tableft.gif\" WIDTH=4 HEIGHT=15 ALT=\"\"></TD>\n";
		$menu .= "<TD BGCOLOR=#99CCFF><NOBR>\n";
		$menu .= "<B>chumpsoft :: perlQ</B></NOBR></TD>\n";
		$menu .= "<TD><IMG SRC=\"$aimgurl/tabright.gif\" WIDTH=7 HEIGHT=15 ALT=\"\"></TD>\n";
	}
	elsif ($sid eq 'main') {
		$menu = $this->printTabs(1, $cs);
	}
	elsif ($sid eq 'admin') {
		$menu = $this->printTabs(4, $cs);
	}
	elsif ($sid eq 'choose' || $sid eq 'view') {
		$menu = $this->printTabs(3, $cs);
	}
	elsif ($sid eq 'stats') {
		$menu = $this->printTabs(3, $cs);
	}
	elsif ($sid eq 'survey' || $sid eq 'question') {
		$menu = $this->printTabs(2, $cs);
	}

	#-->> Output Page

	if (-r $template) {
		open(T,"$template");
		my $templatedata = join('',<T>);
		close(T);

		my $durl = $perlQ->getImgURL('docs');
		if ($admin) {
			$templatedata =~ s/\b(images\/\w+\.(?:gif|jpg|png))/$perlQ->getImgURL('admin\/' . $1)/eg;
			my $aurl = $perlQ->getImgURL('admin');
			$templatedata =~ s/HREF="favicon\.ico/HREF="$aurl\/favicon\.ico/ig;
			$templatedata =~ s/HREF="template\.css"/HREF="$aurl\/template\.css"/ig;
			$templatedata =~ s/HREF="..\/docs\//HREF="$durl\//ig;

			# This is kind of a hack, but it works...
			if ($sid eq 'stats') {
				$templatedata =~ s/HREF="index\.cgi/HREF="admin\/index\.cgi/ig;
			}
		}
		else {
			$templatedata =~ s/\b((?:templates\/\w+|docs|admin)\/images\/\w+\.(gif|jpg|png))/$perlQ->getImgURL($1)/eg;
			$templatedata =~ s/\b(templates\/\w+\/\w+\.(css|ico))/$perlQ->getImgURL($1)/eg;
		}

		$templatedata =~ s/::CHARSET::/$lang->{'CHARSET'}/g;
		$templatedata =~ s/::USERMANUAL::/$lang->{'UserManual'}/g;
		$templatedata =~ s/::SURVEYNAME::/$title/g;
		my $pn = $perlQ->getPageNumber;
		$templatedata =~ s/::PAGENUMBER::/$pn/eg;
		$templatedata =~ s/::JSINIT::/$jsinit/g;
		$templatedata =~ s/::JSCRIPT::/$jsinfo/g;
		$templatedata =~ s/::MENU::/$menu/g;
		$templatedata =~ s/::MESSAGE::/$this->getMessage/eg;
		$templatedata =~ s/::CONTENT::/$contents/g;

		$this->page($templatedata);
	}
	else {
		print $perlQ->getCGI->header;
		print $lang->{'NoTemplate'};
		$perlQ->exit;
	}
}

sub printTabs {
	my $this = shift;
	my ($tabindex, $cs) = @_;
	my $perlQ = $this->getState;
	my $lang = $perlQ->getLanguage;
	my $aimgurl = $perlQ->getImgURL('admin/images');

	my $uri = $perlQ->inAdmin ? '' : 'admin/';
	my $menuarray = [[$lang->{'TabMain'}, $uri."main.cgi?cs=$cs"],
	    [$lang->{'TabSurveyEditor'}, $uri."survey.cgi?cs=$cs"],
	    [$lang->{'TabSurveyResults'}, $uri."choose.cgi?cs=$cs"],
	    [$lang->{'TabConfiguration'}, $uri."admin.cgi?cs=$cs"],
	    [$lang->{'TabLogoff'}, $uri."index.cgi?logoff=1"]];

	my $menu = '';
	for (my $i=0; $i<@$menuarray; $i++) {
		my $tabcss = 'tab';
		my $leftimg = 'tableft.gif';
		my $rightimg = 'tabright.gif';
		my $bgcolor = '#99CCFF';
		if ($i == $tabindex-1) {
			$tabcss = "tabon";
			$leftimg = "tablefton.gif";
			$rightimg = "tabrighton.gif";
			$bgcolor = "#BBFF33";
		}
		$menu .= "<TD><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=5 HEIGHT=1 ALT=\"\"></TD>\n";
		$menu .= "<TD><IMG SRC=\"$aimgurl/$leftimg\" WIDTH=4 HEIGHT=15 ALT=\"\"></TD>\n";
		$menu .= "<TD BGCOLOR=$bgcolor><NOBR><A HREF=\"".$menuarray->[$i][1]."\"";
		$menu .= " CLASS=$tabcss><B>".$menuarray->[$i][0]."</B></A></NOBR></TD>\n";
		$menu .= "<TD><IMG SRC=\"$aimgurl/$rightimg\" WIDTH=7 HEIGHT=15 ALT=\"\"></TD>\n";
	}

	return $menu;
}

sub printMessage {
	my $this = shift;
	my $message = shift;
	my $width = shift;
	my $align = shift;

	if (!defined $width) { $width = 400; }
	if (!defined $align) { $align = 'center'; }

	if ($width ne '') { $width = " WIDTH=$width"; }
	if ($align ne '') { $align = " ALIGN=$align"; }

	return <<"END MESSAGE";
<TABLE CELLPADDING=5 CELLSPACING=5 BORDER=0$width>
<TR><TD$align>$message</TD></TR>
</TABLE>
END MESSAGE
}

sub createSurvey {
	my $this = shift;
	my ($masurvey, $cq, $page, $admin) = @_;

	my $cgi = $this->getState->getCGI;
	my $lang = $this->getState->getLanguage;

	my $action = ($admin) ? 'preview' : '';
	my $width = ($masurvey->{'Width'}) ? "WIDTH=$masurvey->{'Width'}" : '';
	my $scriptname = $cgi->url;
	
	my $contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 $width>\n";
	$contents .= "<FORM ACTION=\"$scriptname\" METHOD=POST>\n";

	if (length($masurvey->{'SurveyUsers'}) == 3 && !$admin && $cq > 1 &&
	    substr($masurvey->{'SurveyUsers'},1,1) && !$cgi->cookie('perlQTest')) {
		$contents .= "<TR><TD STYLE=\"$masurvey->{'ErrorStyle'}\">";
		$contents .= "$lang->{'SurveyCookieWarning'}<BR><BR></TD></TR>";
	}

	$contents .= $page;

	# Ensure that this survey can only be submitted once.
	my $ufid = $cgi->param('ufid') || '';
	if (!$ufid) {
		$ufid = $ENV{'REMOTE_ADDR'}.'-'.time.'-'.int(rand(999999999) + 1000000000);
	}
	$contents .= "<INPUT TYPE=hidden NAME=ufid VALUE=\"$ufid\">\n";

	if ($admin) {
		$contents .= "<INPUT TYPE=hidden NAME=action VALUE=preview>\n";
	}
	$contents .= "<INPUT TYPE=hidden NAME=sid VALUE=$masurvey->{'SID'}>\n";
	$contents .= "</FORM>\n";
	$contents .= "</TABLE>\n";

	return $contents;
}

sub urlencode {
	my $this = shift;
	my $string = shift;

	$string =~ s/([^a-zA-Z0-9_\-. ])/uc sprintf("%%%02x",ord($1))/egs;
	$string =~ tr/ /+/;
	return $string;
}

sub urldecode {
	my $this = shift;
	my $string = shift;

	$string =~ tr/+/ /;
	$string =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	return $string;
}

1;
