#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

use strict;

sub getQuestions {
	my ($perlQ, $currentquestion, $questioncount, $masurvey) = @_;
	my $dbh = $perlQ->getDBH;
	my $cgi = $perlQ->getCGI;
	my $html = $perlQ->getHTML;
	my $lang = $perlQ->getLanguage;

	my $preview = $cgi->param('action') || '';
	my $skip = (defined $cgi->param('skip') && $preview) ? 1 : 0;

	$preview = ($preview eq 'preview' && $perlQ->isAdmin) ? 1 : 0;

	my $cquestion = ($currentquestion eq 'done') ? ($questioncount + 1) : $currentquestion;
	my $pagebreak = 0;
	my $overallvalidity = 1;
	my $nextcq = 0;
	my $contents = '';

	my $prevcq = 0;
	my $squestion = 0;
	if ($preview) {
		my $query = $dbh->prepare("SELECT SortOrder,Type FROM perlQQuestion WHERE SID=? AND SortOrder<? ORDER BY SortOrder DESC");

		# This ensures that if submit was pressed, we don't backtrack 2 pagebreaks.
		my $foundpb = ($cquestion > $questioncount) ? 1 : 0;
		if ($query->execute($masurvey->{'SID'}, $cquestion) && $query->rows) {
			for (my $i = 0; $i < $query->rows; $i++) {
				my ($sorder, $type) = $query->fetchrow_array;
				if ($type eq 'pagebreak') { if ($foundpb) { last; } $foundpb++; }
				else { $squestion = $sorder; }
			}
		}
		$query->finish;
	}


	my $validthru = 0;
	my $hiddenfields = '';
	my $query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND SortOrder<? AND SortOrder>=? ORDER BY SortOrder");
	if (!$skip && $query->execute($masurvey->{'SID'}, $cquestion, $squestion) && $query->rows) {
		for (my $i = 0; $i < $query->rows; $i++) {
			my $qref = $query->fetchrow_hashref;
			$prevcq = !$prevcq ? $qref->{'SortOrder'} : $prevcq;
			if ($qref->{'Type'} eq 'pagebreak') { $prevcq = 0; next; }
			my @answervalidity = &storeAnswer($perlQ, $qref, $masurvey);
			if ($answervalidity[0]) {
				foreach my $value ($cgi->param("Q$qref->{'QID'}")) {
					$hiddenfields .= "<input type=hidden name=\"Q$qref->{'QID'}\" value=\"" . $html->protectHTML($value) . "\">\n";
					if ($qref->{'Type'} =~ /^(radio|checkbox|select|selectmult)$/ &&
					    $cgi->param("Q$qref->{'QID'}$value")) {
						$hiddenfields .= "<input type=hidden name=\"Q$qref->{'QID'}$value\" value=\"" . $html->protectHTML($cgi->param("Q$qref->{'QID'}$value")) . "\">\n";
					}
				}
				$validthru = $qref->{'SortOrder'};
			}
			else {
				last;
			}
		}
	}
	$query->finish;

	if ($prevcq) { $cquestion = $prevcq; }

	if ($masurvey->{'AdminNotes'} && $cquestion == 1) {
		$contents .= "<TR><TD>$masurvey->{'AdminNotes'}<BR><BR></TD></TR>\n";
	}

	# If all questions have been successfully answered, return complete...
	if ($validthru >= $questioncount) { return (1, 'complete', ''); }

	# Determine page count information...
	my ($pagecount, $currentpage) = (0, 0);
	$query = $dbh->prepare("SELECT COUNT(*) FROM perlQQuestion WHERE SID=? AND Type=?");
	if ($query->execute($masurvey->{'SID'}, 'pagebreak') && $query->rows) {
		$pagecount = ($query->fetchrow_array)[0];
	}
	$query->finish;

	$query = $dbh->prepare("SELECT COUNT(*) FROM perlQQuestion WHERE SID=? AND SortOrder<? AND Type=?");
	if ($query->execute($masurvey->{'SID'}, $cquestion, 'pagebreak') && $query->rows) {
		$currentpage = ($query->fetchrow_array)[0];
	}
	$query->finish;

	if ($pagecount > 0) {
		$perlQ->setPageNumber(sprintf($lang->{'PageNumber'}, $currentpage+1, $pagecount+1));
	}

	my $totalerrors = 0;
	$contents .= '::PAGEERRORS::';
	while (!$pagebreak) {
		$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND SortOrder=?");
		if ($query->execute($masurvey->{'SID'}, $cquestion) && $query->rows) {
			my $maquestion = $query->fetchrow_hashref;
			if ($maquestion->{'Type'} eq 'pagebreak') {
				$pagebreak = 1;
				$nextcq = $cquestion+1;
				$contents .= &printSubmit($perlQ, 'next', $masurvey);
			}
			else {
				if (!$skip) {
					my $answered = $cgi->param("Q$maquestion->{'QID'}" . 'Answered');
					if ($answered) {
						my @answervalidity = &storeAnswer($perlQ, $maquestion, $masurvey);
						if (!$answervalidity[0]) {
							$contents .= $answervalidity[1];
							$totalerrors++;
							$overallvalidity = 0;
						}
					}
					else {
						$overallvalidity = 0;
					}
				}

				$contents .= &printQuestion($perlQ, $maquestion, $masurvey);
				$contents .= &printAnswers($perlQ, $maquestion, $masurvey, 0, 0);
				$hiddenfields .= &printHiddenVars($maquestion->{'QID'});
			}
		}
		elsif ($cquestion > $questioncount) {
			$pagebreak = 1;
			$nextcq = 'done';
			$contents .= &printSubmit($perlQ, 'submit', $masurvey);
		}
		$cquestion++;
	}

	my $errhtml = '';
	if ($totalerrors) {
		my $estring = $totalerrors == 1 ? 'error' : 'errors';
		my $errtext = sprintf($lang->{'PleaseCorrect'}, sprintf($lang->{$estring}, $totalerrors));
		$errhtml = "<TR><TD STYLE=\"$masurvey->{'ErrorStyle'}\">$errtext</TD></TR><TR><TD>&nbsp;</TD></TR>";
	}

	$contents =~ s/::PAGEERRORS::/$errhtml/;

	$contents .= $hiddenfields;
	$contents .= "<input type=hidden name=\"cq\" value=\"$nextcq\">\n";

	# Return Array
	# 0 - True if every answer is valid otherwise false
	# 1 - The first question count in the survey
	# 2 - The content output of the survey

	return ($overallvalidity, $nextcq, $contents);
}

sub validAnswerChoices {
	my $qanswer = shift;
	my @validanswers = split(/\|\|\|/, $qanswer);
	for (my $i = 0; $i < @validanswers; $i++) {
		my @tempchoice = split(/\|\|/, $validanswers[$i]);
		$validanswers[$i] = (substr($tempchoice[2],0,11) eq "Textfield:(") ?  "O$tempchoice[1]" : "N$tempchoice[1]";
	}

	return @validanswers;
}

sub storeAnswer {
	my ($perlQ, $maquestion, $masurvey) = @_;
	my $cgi = $perlQ->getCGI;
	my $html = $perlQ->getHTML;
	my $lang = $perlQ->getLanguage;

	my $message = '';
	my ($answervalidity, $invalidselect) = (1, 0);
	my $qid = $maquestion->{'QID'};
	my $errorstyle = $masurvey->{'ErrorStyle'};
	my $required = ($maquestion->{'Required'} eq 'n') ? 0 : 1;
	my $contents = '';

	my $qtype = $maquestion->{'Type'};     # Question Type
	my $qanswer = $maquestion->{'Answer'}; # Default Answer
	my @uanswer = $cgi->param("Q$qid");    # User Answer

	if ($qtype eq 'textfield' || $qtype eq 'textarea') {
		if (!@uanswer) { @uanswer = (''); }
		if ($uanswer[0] eq '') {
			if ($required) {
				$answervalidity = 0;
				$message = $lang->{'EmptyAnswer'};
			}
		}

		if ($answervalidity) {
			$contents = $uanswer[0];
		}
	}
	elsif ($qtype eq 'selectmult' || $qtype eq 'checkbox') {
		if (!@uanswer) {
			if ($required) {
				$answervalidity = 0;
				$message = $lang->{'EmptyAnswer'};
			}
		}
		else {
			my %validanswers = map { $_ => 1 } (&validAnswerChoices($qanswer));
			for (my $i = 0; $i < @uanswer; $i++) {
				if (!defined $validanswers{$uanswer[$i]}) {
					$answervalidity = 0;
					$message = $lang->{'InvalidAnswer'};
				}
			}

			if ($answervalidity && $maquestion->{'Choose'}) {
				my @choose = split(/:/, $maquestion->{'Choose'});
				my $cmsg = '';
				if ($choose[0] eq 'e' && @uanswer != $choose[1]) {
					$cmsg = ($choose[1] == 1) ? $lang->{'ExactCount1'} : $lang->{'ExactCount'};
				}
				elsif ($choose[0] eq 'l' && @uanswer < $choose[1]) {
					$cmsg = ($choose[1] == 1) ? $lang->{'AtLeastCount1'} : $lang->{'AtLeastCount'};
				}
				elsif ($choose[0] eq 'm' && @uanswer > $choose[1]) {
					$cmsg = ($choose[1] == 1) ? $lang->{'AtMostCount1'} : $lang->{'AtMostCount'};
				}

				if ($cmsg ne '') {
					$answervalidity = 0;
					$message = sprintf($cmsg, $choose[1]);
				}
			}
		}

		my @choices = split(/\|\|\|/, $qanswer);
		my $tempanswer = '';
		my %uanswer = map { $_ => 1 } @uanswer;

		for (my $k = 0; $k < @choices; $k++) {
			my @qparts = split(/\|\|/, $choices[$k]);
			my $subid = "N$qparts[1]";
			my $optiontext = $qparts[2];
			if (substr($qparts[2],0,11) eq 'Textfield:(') {
				$subid = "O$qparts[1]";
				$optiontext = substr($qparts[2],11,-1);
			}

			if ($qtype eq 'selectmult') { $optiontext = $html->protectHTML($optiontext); }
			my $answervar3 = $cgi->param("Q$qid$subid");
			if (!defined $answervar3) { $answervar3 = ''; }

			if (@uanswer && $uanswer{$subid}) {
				if ($qtype eq 'selectmult' && $qparts[4] eq 'N') {
					if ($required) {
						$answervalidity = 0;
						$message = sprintf($lang->{'UnselectableOption'}, $optiontext);
					}
					else {
						$invalidselect = 1;
					}
				}
				else {
					$tempanswer .= "||$subid";
					if (substr($subid,0,1) eq 'O') {
						if ($answervar3 ne '') {
							$tempanswer .= "|$answervar3";
						}
						else {
							$answervalidity = 0;
							$message = sprintf($lang->{'CompleteTextfield'}, $optiontext);
						}
					}
				}
			}
			elsif (substr($subid,0,1) eq 'O' && $answervar3 ne '') {
				$answervalidity = 0;
				$message = sprintf($lang->{'SelectTextfield'}, $optiontext);
			}
		}

		$tempanswer = substr($tempanswer,2);
		if ($answervalidity && !$invalidselect) {
			$contents = $tempanswer;
		}
	}
	elsif ($qtype eq 'radio' || $qtype eq 'select') {
		if (!@uanswer) { @uanswer = (''); }
		my $optiontext = '';
		my $tempanswer = '';
		if ($uanswer[0] eq '') {
			if ($required) {
				$answervalidity = 0;
				$message = $lang->{'EmptyAnswer'};
			}
		}
		else {
			my %validanswers = map { $_ => 1 } &validAnswerChoices($qanswer);
			if (!defined $validanswers{$uanswer[0]}) {
				$answervalidity = 0;
				$message = $lang->{'InvalidAnswer'};
			}

			my @choices = split(/\|\|\|/, $qanswer);
			for (my $k = 0; $k < @choices; $k++) {
				my @qparts = split(/\|\|/, $choices[$k]);
				my $subid = "N$qparts[1]";
				my $optiontext = $qparts[2];
				if (substr($qparts[2],0,11) eq "Textfield:(") {
					$subid = "O$qparts[1]";
					$optiontext = substr($qparts[2],11,-1);
				}

				if ($qtype eq 'select') { $optiontext = $html->protectHTML($optiontext); }
				my $answervar3 = $cgi->param("Q$qid$subid");
				if (!defined $answervar3) { $answervar3 = ''; }

				if ($uanswer[0] eq $subid) {
					if ($qtype eq 'select' && $qparts[4] eq 'N') {
						if ($required) {
							$answervalidity = 0;
							$message = sprintf($lang->{'UnselectableOption'}, $optiontext);
						}
						else {
							$invalidselect = 1;
						}
					}
					else {
						$tempanswer = $uanswer[0];
						if (substr($subid,0,1) eq 'O') {
							if ($answervar3 ne '') {
								$tempanswer .= "|$answervar3";
							}
							else {
								$answervalidity = 0;
								$message = sprintf($lang->{'CompleteTextfield'}, $optiontext);
							}
						}
					}
				}
				elsif (substr($subid,0,1) eq 'O' && $answervar3 ne '') {
					$answervalidity = 0;
					$message = sprintf($lang->{'SelectTextfield'}, $optiontext);
				}
			}
		}

		if ($answervalidity && !$invalidselect) {
			$contents = $tempanswer;
		}
	}

	if (!$answervalidity && $message) {
		$contents = "<TR><TD>";
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>";
		$contents .= "<TD STYLE=\"$errorstyle\">$message</TD>";
		$contents .= "</TR></TABLE>";
		$contents .= "</TD></TR>";
	}

	return ($answervalidity, $contents);
}

sub printQuestion {
	my ($perlQ, $maquestion, $masurvey) = @_;
	my $lang = $perlQ->getLanguage;
	my $question = $maquestion->{'Question'};
	my $questionstyle = $maquestion->{'QuestionStyle'} ? $maquestion->{'QuestionStyle'} : $masurvey->{'QuestionStyle'};
	my $required = ($maquestion->{'Required'} eq 'n') ? 0 : 1;

	my $dbh = $perlQ->getDBH;
	my $qnum = -1;
	my $query = $dbh->prepare("SELECT COUNT(*) as qnum FROM perlQQuestion WHERE SID=? AND SortOrder<? AND Type != 'pagebreak' AND Type != 'htmlcontent'");
	if ($query->execute($maquestion->{'SID'}, $maquestion->{'SortOrder'}) &&
	    $query->rows) {
		$qnum = ($query->fetchrow_array)[0];
	}
	$query->finish;
	
	my $contents = "<TR><TD>\n";
	if ($maquestion->{'Instructions'}) {
		$contents .= $maquestion->{'Instructions'};
	}

	if ($maquestion->{'Type'} ne 'htmlcontent') {
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>";
		if ($masurvey->{'QuestionNumb'} eq 'y') {
			if ($required) {
				$contents .= "<TD VALIGN=top><B>$lang->{'*'}</B></TD>\n";
			}
			else { $contents .= "<TD>&nbsp;</TD>\n"; }
			$contents .= "<TD STYLE=\"$questionstyle\" ALIGN=right VALIGN=top><B>".($qnum+1).".</B></TD>\n";
		}

		$contents .= "<TD WIDTH=100% STYLE=\"$questionstyle\">$question</TD>\n";
		$contents .= "</TR></TABLE>\n";
	}
	$contents .= "</TD></TR>\n";

	return $contents;
}

sub printAnswers {
	my ($perlQ, $maquestion, $masurvey, $uidanswer, $print) = @_;
	my $cgi = $perlQ->getCGI;
	my $html = $perlQ->getHTML;

	my $qid = $maquestion->{'QID'} || 0;
	my $type = $maquestion->{'Type'} || '';
	my $indent = $masurvey->{'Indent'} || 0;
	my $questionstyle = $maquestion->{'QuestionStyle'} || $masurvey->{'QuestionStyle'} || '';
	my $answertextstyle = $maquestion->{'AnswerTextStyle'} || $masurvey->{'AnswerTextStyle'} || '';
	my $answerinputstyle = $maquestion->{'AnswerInputStyle'} || $masurvey->{'AnswerInputStyle'} || '';
	my $answerstyle = $maquestion->{'AnswerStyle'} || $masurvey->{'AnswerStyle'} || '';
	my $attributes = $maquestion->{'Attributes'};
	my $answer = $html->protectHTML($maquestion->{'Answer'} || '');
	my $defaultanswer = $maquestion->{'DefaultAnswer'};
	my $colnumb = $maquestion->{'ColNumb'};
	my $mult = $maquestion->{'Mult'};
	my $sortorder = $maquestion->{'SortOrder'};
	my $required = ($maquestion->{'Required'} eq 'n') ? 0 : 1;
	my $contents = "<TR><TD>\n";

	if ($type eq 'radio') {
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";
		$contents .= "<TR><TD WIDTH=$indent></TD><TD>\n";
		$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
		my @choices = split(/\|\|\|/, $answer);
		my $count = 0;
		for (my $i = 0; $i < @choices; $i++) {
			my @parts = split(/\|\|/, $choices[$i]);
			my $subqid = $parts[1];

			# Checking for previous input by user else default answer

			my ($tfanswer,$checked) = ('','');
			if ($cgi->param("Q$qid".'Answered')) {
				if (substr($cgi->param("Q$qid"),1) eq $subqid) { $checked = 'CHECKED'; }
				if (defined $cgi->param("Q$qid" . "O$subqid")) {
					$tfanswer = $cgi->param("Q$qid" . "O$subqid");
				}
			}
			else {
				if ($parts[3] eq 'D') { $checked = 'CHECKED'; }
			}

			# Grabbing answer (uidanswer) from database

			if ($uidanswer) {
				if (substr($uidanswer,0,1) eq 'O') {
					my @radiochoice = split(/\|/, $uidanswer);
					if (substr($radiochoice[0],1) eq $subqid) { $checked = 'CHECKED'; }
					if ($radiochoice[0] eq "O$subqid" && $radiochoice[1]) {
						$tfanswer = $radiochoice[1];
					}
				}
				else {
					if (substr($uidanswer,1) eq $subqid) { $checked = 'CHECKED'; }
				}
			}

			# Displaying answer choices

			my $radioid = 'Q'.$qid.'_'.$subqid;
			if (substr($parts[2],0,11) eq 'Textfield:(') {
				$tfanswer = $html->protectHTML($tfanswer);
				my $choicetext = substr($parts[2],11,length($parts[2])-12);
				if ($print) {
					$contents .= $checked ? "<TD STYLE=\"$answertextstyle\">" . $html->freeHTML($choicetext) . "&nbsp;[$tfanswer]</TD>" : '';
				}
				else {
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=radio NAME=\"Q$qid\" $checked ID=\"$radioid\" VALUE=\"O$subqid\"></TD>";
					$contents .= "<TD STYLE=\"$answertextstyle\"><LABEL FOR=\"$radioid\">".$html->freeHTML($choicetext) . "</LABEL>&nbsp;</TD>";
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=text STYLE=\"$answerstyle\" $attributes";
					$contents .= "NAME=\"Q$qid"."O$subqid\" VALUE=\"$tfanswer\">&nbsp;</TD>\n";
				}
			}
			else {
				if ($print) {
					$contents .= $checked ? "<TD STYLE=\"$answertextstyle\">" . $html->freeHTML($parts[2]) . "</TD>\n" : '';
				}
				else {
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=radio NAME=\"Q$qid\" $checked ID=\"$radioid\" VALUE=\"N$subqid\"></TD>";
					$contents .= "<TD STYLE=\"$answertextstyle\" COLSPAN=2><LABEL FOR=\"$radioid\">". $html->freeHTML($parts[2]) . "</LABEL>&nbsp;</TD>\n";
				}
			}

			# Correct columns when printing results...
			if ($print) { $count += $checked ? 1 : 0; }
			else { $count = $i; }

			if ((!$colnumb || (($count+1) % $colnumb) == 0) && $count != (@choices)) {
				$contents .= "</TR><TR>\n";
			}
		}
		$contents .= "</TR></TABLE>\n";
		$contents .= "</TD></TR></TABLE>\n";
	}
	elsif ($type eq 'select') {
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";

		if ($print) {
			$contents .= "<TR><TD WIDTH=$indent></TD><TD>\n";
			$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
		}
		else {
			$contents .= "<TR><TD WIDTH=$indent></TD><TD STYLE=\"$answerinputstyle\">\n";
			$contents .= "<SELECT NAME=Q$qid STYLE=\"$answertextstyle\">";
		}

		my @choices = split(/\|\|\|/, $answer);
		my $seltextfield = 0;

		# Traversing through each Select choice

		my $tfanswer = '';
		for (my $i = 0; $i < @choices; $i++) {
			my @parts = split(/\|\|/, $choices[$i]);
			my $subqid = $parts[1];
			my $selected = '';

			# Checking for previous input by user else default answer
			if ($cgi->param("Q$qid".'Answered')) {
				if (substr($cgi->param("Q$qid"),1) eq $subqid) { $selected = "SELECTED"; }
				my $tf = $cgi->param("Q$qid"."O$subqid");
				if (defined $tf && $tf ne '') { $tfanswer = $tf; }
			}
			else {
				if ($parts[3] eq 'D') { $selected = "SELECTED"; }
			}

			# Grabbing answer (uidanswer) from database

			if ($uidanswer) {
				if (substr($uidanswer,0,1) eq 'O') {
					my @radiochoice = split(/\|/, $uidanswer);
					if (substr($radiochoice[0],1) eq $subqid) { $selected = "SELECTED"; }
					if (substr($radiochoice[0],1) eq $subqid && $radiochoice[1]) { $tfanswer = $radiochoice[1]; }
				}
				else {
					if (substr($uidanswer,1) eq $subqid) { $selected = "SELECTED"; }
				}
			}

			# Determining if there is a textfield

			if (substr($parts[2],0,11) eq 'Textfield:(') {
				$seltextfield = $subqid;
				my $choicetext = substr($parts[2],11,-1);
				if ($print) {
					$tfanswer = $html->protectHTML($tfanswer);
					$contents .= $selected ? "<TD STYLE=\"$answertextstyle\">$choicetext&nbsp;[$tfanswer]</TD>" : '';
				}
				else {
					$contents .= "<OPTION $selected VALUE=\"O$subqid\">$choicetext</OPTION>";
				}
			}
			else {
				if ($print) {
					$contents .= $selected ? "<TD STYLE=\"$answertextstyle\">$parts[2]</TD>" : '';
				}
				else {
					$contents .= "<OPTION $selected VALUE=\"N$subqid\">$parts[2]</OPTION>";
				}
			}
		}

		if ($print) { $contents .= "</TR></TABLE></TD></TR>\n"; }
		else { $contents .= "</SELECT></TD></TR>\n"; }

		# Printing the textfield if there is one

		if ($seltextfield && !$print) {
			$tfanswer = $html->protectHTML($tfanswer);
			$contents .= "<TR><TD></TD><TD STYLE=\"$answerinputstyle\"><INPUT TYPE=text STYLE=\"$answerstyle\" $attributes NAME=\"Q$qid"."O$seltextfield\" VALUE=\"$tfanswer\"></TD></TR>\n";
		}
		$contents .= "</TABLE>\n";
	}
	elsif ($type eq 'checkbox') {
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";
		$contents .= "<TR><TD WIDTH=$indent></TD><TD>\n";
		$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
		my @choices = split(/\|\|\|/, $answer);
		my $count = 0;
		for (my $i = 0; $i < @choices; $i++) {
			my @parts = split(/\|\|/, $choices[$i]);
			my $subqid = $parts[1];

			# Checking for previous input by user else default answer
			
			my ($tfanswer, $checked) = ('', '');
			if ($cgi->param("Q$qid".'Answered')) {
				my @uanswer = $cgi->param("Q$qid");
				for (my $j = 0; $j < @uanswer; $j++) {
					if (substr($uanswer[$j],1) == $subqid) { $checked = "CHECKED"; }
				}
				my $tf = $cgi->param("Q$qid"."O$subqid");
				if (defined $tf && $tf ne '') { $tfanswer = $tf; }
			}
			else {
				if ($parts[3] eq 'D') { $checked = "CHECKED"; }
			}
		 
			# Grabbing answer (uidanswer) from database
			
			if ($uidanswer) {
				($tfanswer, $checked) = ('', '');
				my @uidchoices = split(/\|\|/, $uidanswer);
				for (my $j = 0; $j < @uidchoices; $j++) {
					if (substr($uidchoices[$j],0,1) eq 'O') {
						my @txtchoice = split(/\|/, $uidchoices[$j]);
						if (substr($txtchoice[0],1) eq $subqid) { $checked = "CHECKED"; }
						if (substr($txtchoice[0],1) eq $subqid && $txtchoice[1] ne '') { $tfanswer = $txtchoice[1]; }
					}
					else {
						if (substr($uidchoices[$j],1) eq $subqid) { $checked = "CHECKED"; }
					}
				}
			}

			# Determining if there is a textfield

			my $checkid = 'Q'.$qid.'_'.$subqid;
			if (substr($parts[2],0,11) eq 'Textfield:(') {
				$tfanswer = $html->protectHTML($tfanswer);
				my $choicetext = substr($parts[2],11,length($parts[2])-12);
				if ($print) {
					$contents .= $checked ? "<TD STYLE=\"$answertextstyle\">".$html->freeHTML($choicetext)."&nbsp;[$tfanswer]</TD>" : '';
				}
				else {
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=checkbox NAME=\"Q$qid\" $checked ID=\"$checkid\" VALUE=\"O$subqid\"></TD>";
					$contents .= "<TD STYLE=\"$answertextstyle\"><LABEL FOR=\"$checkid\">".$html->freeHTML($choicetext)."</LABEL>&nbsp;</TD>";
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=text STYLE=\"$answerstyle\" $attributes ";
					$contents .= "NAME=\"Q".$qid."O$subqid\" VALUE=\"$tfanswer\"></TD>\n";
				}
			}
			else {
				if ($print) {
					$contents .= $checked ? "<TD STYLE=\"$answertextstyle\">".$html->freeHTML($parts[2])."</TD>" : '';
				}
				else {
					$contents .= "<TD STYLE=\"$answerinputstyle\"><INPUT TYPE=checkbox NAME=\"Q$qid\" $checked ID=\"$checkid\" VALUE=\"N$subqid\"></TD>";
					$contents .= "<TD STYLE=\"$answertextstyle\" COLSPAN=2><LABEL FOR=\"$checkid\">".$html->freeHTML($parts[2])."</LABEL>&nbsp;</TD>\n";
				}
			}

			# Correct columns during a $print
			if ($print) { $count += $checked ? 1 : 0; }
			else { $count = $i; }

			if ((!$colnumb || (($count+1) % $colnumb) == 0) && $count != (@choices)) {
				$contents .= "</TR><TR>\n";
			}
		}
		$contents .= "</TR></TABLE>\n";
		$contents .= "</TD></TR></TABLE>\n";
	}
	elsif ($type eq 'selectmult') {
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0>\n";
		if ($print) {
			$contents .= "<TR><TD WIDTH=$indent></TD><TD>\n";
			$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
		}
		else {
			$contents .= "<TR><TD WIDTH=$indent></TD><TD STYLE=\"$answerinputstyle\">\n";
			$contents .= "<SELECT NAME=Q".$qid." STYLE=\"$answertextstyle\" SIZE=$mult MULTIPLE>";
		}

		my @choices = split(/\|\|\|/, $answer);
		my $seltextfield = 0;
		my $optext = '';
		my @uanswer = $cgi->param("Q$qid");
		for (my $i = 0; $i < @choices; $i++) {
			my @parts = split(/\|\|/, $choices[$i]);
			my $subqid = $parts[1];

			# Checking for previous input by user else default answer

			my $selected = '';
			if ($cgi->param("Q$qid".'Answered')) {
				my $tf = $cgi->param("Q$qid"."O$subqid");
				if (defined $tf && $tf ne '') { $optext = $tf; }
				for (my $j = 0; $j < @uanswer; $j++) {
					if (substr($uanswer[$j],1) eq $subqid) { $selected = "SELECTED"; }
				}
			}
			else {
				if ($parts[3] eq 'D') { $selected = "SELECTED"; }
			}

			# Grabbing answer (uidanswer) from database

			if ($uidanswer) {
				$selected = '';
				my @uidchoices = split(/\|\|/, $uidanswer);
				for (my $j = 0; $j < @uidchoices; $j++) {
					my @optionsplit = split(/\|/, $uidchoices[$j]);
					if (@optionsplit == 2) { $optext = $optionsplit[1]; }
					if (substr($optionsplit[0],1) eq $subqid) { $selected = "SELECTED"; }
				}
			}

			# Determining if there is a textfield

			if (substr($parts[2],0,11) eq 'Textfield:(') {
				$seltextfield = $subqid;
				my $choicetext = substr($parts[2],11,length($parts[2])-12);
				if ($print) {
					$contents .= $selected ? "<TR><TD STYLE=\"$answertextstyle\">$choicetext&nbsp;[" . $html->protectHTML($optext) . "]</TD></TR>" : '';
				}
				else {
					$contents .= "<OPTION $selected VALUE=\"O$subqid\">$choicetext</OPTION>";
				}
			}
			else {
				if ($print) {
					$contents .= $selected ? "<TR><TD STYLE=\"$answertextstyle\">$parts[2]</TD></TR>" : '';
				}
				else {
					$contents .= "<OPTION $selected VALUE=\"N$subqid\">$parts[2]</OPTION>";
				}
			}
		}

		if ($print) { $contents .= "</TABLE></TD></TR>"; }
		else { $contents .= "</SELECT></TD></TR>\n"; }

		if ($seltextfield && !$print) {
			$optext = $html->protectHTML($optext);
			$contents .= "<TR><TD></TD><TD STYLE=\"$answerinputstyle\"><INPUT TYPE=text STYLE=\"$answerstyle\" $attributes ";
			$contents .= "NAME=\"Q$qid"."O$seltextfield\" VALUE=\"$optext\"></TD></TR>\n";
		}
		$contents .= "</TABLE>\n";
	}
	elsif ($type eq 'textfield') {
		if ($uidanswer) { $defaultanswer = $uidanswer; }
		if ($cgi->param("Q$qid".'Answered')) {
			my $tf = $cgi->param("Q$qid");
			if (!defined $tf) { $tf = ''; }
			$defaultanswer = $tf;
		}
		$defaultanswer = $html->protectHTML($defaultanswer);
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>\n";
		$contents .= "<TD WIDTH=$indent></TD>\n";
		if ($print) {
			$contents .= "<TD STYLE=\"$answertextstyle\">$defaultanswer</TD>\n";
		}
		else {
			$contents .= "<TD STYLE=\"$answerinputstyle\">";
			$contents .= "<INPUT TYPE=text STYLE=\"$answerstyle\" NAME=\"Q$qid\" $attributes VALUE=\"$defaultanswer\"></TD>\n";
		}
		$contents .= "</TR></TABLE>\n";
	}
	elsif ($type eq 'textarea') {
		if ($uidanswer) { $defaultanswer = $uidanswer; }
		if ($cgi->param("Q$qid".'Answered')) {
			my $tf = $cgi->param("Q$qid");
			if (!defined $tf) { $tf = ''; }
			$defaultanswer = $tf;
		}
		$defaultanswer = $html->protectHTML($defaultanswer);
		$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>\n";
		$contents .= "<TD WIDTH=$indent></TD>\n";
		if ($print) {
			$defaultanswer =~ s/\n/<br>/g;
			$contents .= "<TD STYLE=\"$answertextstyle\">$defaultanswer</TD>\n";
		}
		else {
			$contents .= "<TD STYLE=\"$answerinputstyle\">\n";
			$contents .= "<TEXTAREA STYLE=\"$answerstyle\" NAME=\"Q$qid\" $attributes>$defaultanswer</TEXTAREA></TD>\n";
		}
		$contents .= "</TR></TABLE>\n";
	}
	elsif ($type eq 'htmlcontent') {
		return "<TR><TD>&nbsp;</TD></TR>\n";
	}

	$contents .= "</TD></TR>\n";
	$contents .= "<TR><TD>&nbsp;</TD></TR>\n";

	return $contents;
}

sub printClose {
	my $perlQ = shift;
	my $lang = $perlQ->getLanguage;
	my $contents = "<TR><TD ALIGN=center>\n";
	$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>\n";
	$contents .= "<TD><INPUT TYPE=button ONCLICK=\"window.close();\" VALUE=\"$lang->{'Close'}\"></TD>\n";
	$contents .= "</TR></TABLE>\n";
	$contents .= "</TD></TR>\n";

	return $contents;
}

sub printSubmit {
	my ($perlQ, $buttontext, $masurvey) = @_;
	my $action = $perlQ->getCGI->param('action') || '';
	my $lang = $perlQ->getLanguage;

	my $button = &getButton($perlQ, $masurvey, lc($buttontext));
	my $contents = "<TR><TD ALIGN=center>\n";
	$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>\n";
	$contents .= "<TD>$button</TD>\n";
	if ($masurvey->{'SurveyResults'} == 2) {
		my $button = &getButton($perlQ, $masurvey, 'results');
		$contents .= "<TD>&nbsp;</TD><TD>$button</TD>";
	}
	if ($perlQ->isAdmin && $action eq 'preview') {
		my $sep = '-&nbsp;';
		if ($buttontext ne 'submit') {
			$contents .= "<TD>&nbsp;$sep</TD><TD><INPUT TYPE=submit VALUE=\"$lang->{'Skip'}\" name=\"skip\"></TD>";
			$sep = '';
		}
		$contents .= "<TD>&nbsp;$sep</TD><TD><INPUT TYPE=button ONCLICK=\"window.close();\" VALUE=\"$lang->{'Close'}\"></TD>";
	}
	$contents .= "</TR></TABLE>\n";
	$contents .= "</TD></TR>\n";

	return $contents;
}

sub getButton {
	my ($perlQ, $masurvey, $buttontext) = @_;
	my $html = $perlQ->getHTML;
	my $button;
	my $index = '';

	if ($buttontext eq 'submit') { $index = 'Submit'; }
	elsif ($buttontext eq 'next') { $index = 'Next'; }
	elsif ($buttontext eq 'results') { $index = 'Result'; }

	if ($masurvey->{$index.'ImageSrc'} && $masurvey->{$index.'ImageWidth'} > 0 && $masurvey->{$index.'ImageHeight'} > 0) {
		my $buttonsrc = $html->protectHTML($masurvey->{$index.'ImageSrc'});
		my $buttonwidth = $masurvey->{$index.'ImageWidth'} ? " WIDTH=$masurvey->{$index.'ImageWidth'}" : '';
		my $buttonheight = $masurvey->{$index.'ImageHeight'} ? " HEIGHT=$masurvey->{$index.'ImageHeight'}" : '';
		my $buttonalt = $masurvey->{$index.'ImageText'} ? " ALT=\"$masurvey->{$index.'ImageText'}\"" : '';
		$button = "<INPUT TYPE=\"image\" NAME=\"$buttontext\" SRC=\"$buttonsrc\"$buttonwidth$buttonheight BORDER=0$buttonalt VALUE=\"1\">";
	}
	else {
		my $bstyle = '';
		if ($masurvey->{$index.'ImageWidth'} || $masurvey->{$index.'ImageHeight'}) {
			$bstyle = ' STYLE="';
			$bstyle .= $masurvey->{$index.'ImageWidth'} ? "width: $masurvey->{$index.'ImageWidth'}px; " : '';
			$bstyle .= $masurvey->{$index.'ImageHeight'} ? "height: $masurvey->{$index.'ImageHeight'}px; " : '';
			$bstyle .= '"';
		}
		$button = "<INPUT TYPE=submit NAME=\"$buttontext\" VALUE=\"$masurvey->{$index.'ImageText'}\"$bstyle>";
	}
	
	return $button;
}

sub printHiddenVars {
	my $qid = shift;
	return "<INPUT TYPE=hidden NAME=\"Q$qid" . "Answered\" VALUE=1>\n";
}

1;
