#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

use strict;

sub recreateSurvey {
	my ($perlQ, $sid, $uid, $cq, $masurvey, $print) = @_;
	my $lang = $perlQ->getLanguage;
	my $html = $perlQ->getHTML;

	my $contents;
	my $dbh = $perlQ->getDBH;
	my $query = $dbh->prepare("SELECT * FROM perlQUser WHERE SID=? AND UID=?");
	if ($query->execute($sid, $uid) && $query->rows) {
		my $mainfo = $query->fetchrow_hashref;

		my $ipaddr = $mainfo->{'IPAddr'} ? $mainfo->{'IPAddr'} : $lang->{'unavailable'};
		$contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=$masurvey->{'Width'}>\n";
		$contents .= "<TR><TD ALIGN=right><B>$lang->{'Date'}:</B>&nbsp;</TD><TD>$mainfo->{'CompleteDate'}</TD></TR>\n";
		$contents .= "<TR><TD ALIGN=right><B>$lang->{'IPAddress'}:</B>&nbsp;</TD><TD>$ipaddr</TD></TR>\n";

		if (!$print) {
			$contents .= "<TR><TD ALIGN=right><B>$lang->{'ResultsView'}:</B>&nbsp;</TD><TD>";
			$contents .= "<B>$lang->{'HTMLResults'}</B> | <A HREF=\"view.cgi?sid=$sid&uid=$uid&print=1\">$lang->{'PrinterResults'}</A>";
			$contents .= "</TD></TR>\n";
		}

		my @restrictions = ();
		if (substr($mainfo->{'CheckType'},0,1)) {
			push(@restrictions, $lang->{'UniqueIPAddress'});
		}
		if (substr($mainfo->{'CheckType'},1,1)) {
			push(@restrictions, $lang->{'Cookies'});
		}
		if (substr($mainfo->{'CheckType'},2,1)) {
			my $email = $mainfo->{'Email'} ? $mainfo->{'Email'} : $lang->{'notentered'};
			if ($mainfo->{'Email'}) {
				$email .= ($mainfo->{'EmailConfirm'} eq 'y') ? ' '.$lang->{'confirmed'} : ' '.$lang->{'unconfirmed'};
			}
			$email = $html->protectHTML($email);
			if (!$print || $mainfo->{'Email'}) {
				$contents .= "<TR><TD ALIGN=right><B>$lang->{'Email'}:</B>&nbsp;</TD><TD>$email</TD></TR>\n";
			}
			push(@restrictions, $lang->{'VerifiedEmailAddress'});
		}

		if (@restrictions && !$print) {
			$contents .= "<TR><TD ALIGN=right><B>$lang->{'UserRestrictions'}:</B>&nbsp;</TD><TD>" . join(', ', @restrictions) . "</TD></TR>\n";
		}
		$contents .= "</TABLE>\n";
	}
	$query->finish;
	$contents .= "<BR>\n";
		
	$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=$masurvey->{'Width'}\n";
	if (!$print) {
		$contents .= "<FORM>\n";
	}

	my $next = 0;
	$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND SortOrder>=? ORDER BY SortOrder");
	$query->execute($sid, $cq);
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maquestion = $query->fetchrow_hashref;
		if ($maquestion->{'Type'} ne 'pagebreak' && (!$print || $maquestion->{'Type'} ne 'htmlcontent')) {
			my $uquery = $dbh->prepare("SELECT * FROM perlQAnswer WHERE SID=? AND QID=? AND UID=?");
			my $uidanswer = '';
			if ($uquery->execute($sid, $maquestion->{'QID'}, $uid) && $uquery->rows) {
				my $mauidanswer = $uquery->fetchrow_hashref;
				$uidanswer = $mauidanswer->{'Answer'} || '';
			}
			$uquery->finish;
			$contents .= &printQuestion($perlQ, $maquestion, $masurvey);
			$contents .= &printAnswers($perlQ, $maquestion, $masurvey, $uidanswer, $print);
		}
		else {
			if (!$print) {
				$next = 1;
				last;
			}
		}
		$cq++;
	}
	$query->finish;

	if (!$print) {
		$contents .= "</FORM><FORM ACTION=\"view.cgi\">";
		my $buttontext = $next ? $lang->{'Next'} : $lang->{'Close'};
		$contents .= &printNextButton($perlQ, $sid, $buttontext);

		$contents .= "<INPUT TYPE=hidden NAME=sid VALUE=\"$sid\">\n";
		$contents .= "<INPUT TYPE=hidden NAME=uid VALUE=\"$uid\">\n";
		$contents .= "<INPUT TYPE=hidden NAME=cq VALUE=\"".($cq+1)."\">\n";
		$contents .= "</FORM>\n";
	}

	$contents .= "</TABLE>\n";

	return $contents;
}

sub printNextButton {
	my ($perlQ, $sid, $buttontext) = @_;
	my $lang = $perlQ->getLanguage;
	my $submittype = ($buttontext eq $lang->{'Close'}) ? "button" : "submit";
	my $clickjs = ($buttontext eq $lang->{'Close'}) ? "ONCLICK=\"window.close()\"" : "";

	my $contents = "<TR><TD ALIGN=center>\n";
	$contents .= "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0><TR>\n";
	$contents .= "<TD><INPUT TYPE=$submittype $clickjs VALUE=\"$buttontext\"></TD>\n";
	$contents .= "</TR></TABLE>\n";
	$contents .= "</TD></TR>\n";

	return $contents;
}


1;
