#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Include Files

use strict;
require "State.cgi";
import perlQMod::State;
require "Question.cgi";

my $perlQ = perlQMod::State->new;
my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> Setting Variables

my $sid = $cgi->param('sid') || 0;
my $qc = $cgi->param('qc') || 0;
my $qid = $cgi->param('qid') || 0;

if (!$sid || !$qid || !$qc) { $html->redirect(-url => "error.cgi"); }

#-->> Admin Preview Only

if (!$perlQ->isAdmin) { $html->redirect(-url => 'admin/index.cgi'); }

my ($masurvey, $maquestion) = (0, 0);
my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
if ($query->execute($sid) && $query->rows) {
	$masurvey = $query->fetchrow_hashref;
}
$query->finish;

$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND QID=?");
if ($query->execute($sid, $qid) && $query->rows) {
	$maquestion = $query->fetchrow_hashref;
}
$query->finish;

if (!$masurvey || !$maquestion) { $html->redirect(-url => 'error.cgi'); }

#-->> Set Language
$perlQ->setLanguage($masurvey->{'Language'});

#-->> Grab Question

my $question = &printQuestion($perlQ, $maquestion, $masurvey);
$question .= &printAnswers($perlQ, $maquestion, $masurvey, 0);
$question .= &printClose($perlQ);

my $contents = $html->createSurvey($masurvey, 0, $question, 0);

#-->> Output Page

$html->createPage($sid, $masurvey->{'Name'}, $contents, 0, '');
