#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Include Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new;

my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> GET and POST Variables

my $st = (($cgi->param('st') || 'a') =~ /^(a|v|u)$/) ? $1 : 'a'; # single character
my $vw = $cgi->param('vw') || '';
my $sid = (($cgi->param('sid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $cq = (($cgi->param('cq') || 1) =~ /^(\d+)$/) ? $1 : 1;
my $qcount = (($cgi->param('qcount') || 1) =~ /^(\d+)$/) ? $1 : 1;
my $fa = ($cgi->param('fa') && $cgi->param('fa') == 1) ? 1 : 0;

my $masurvey = 0;
my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
if ($query->execute($sid) && $query->rows) {
	$masurvey = $query->fetchrow_hashref;
}
$query->finish;

if (!$masurvey) { $html->redirect(-url => 'error.cgi'); }

#-->> Logging In (if survey results are not public)

my $admin = $perlQ->isAdmin;

if (!$admin) {
	if (!$masurvey->{'SurveyResults'}) {
		$html->redirect(-url => "admin/index.cgi");
	}
	elsif ($masurvey->{'Active'} eq 'n') {
		$html->redirect(-url => "fillsurvey.cgi?sid=$sid");
	}
}
elsif (!$fa) { $admin = 0; }

#-->> Set Language

if ($admin) { $perlQ->setLanguage('', 'ADMIN'); }
else { $perlQ->setLanguage($masurvey->{'Language'}); }
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');

#-->> Results

$vw = ($vw eq 'a' || $vw eq 'p' || substr($vw,0,1) eq 'q') ? $vw : 'n';

my $headingimg;
if ($st eq 'v') {
	$headingimg = $admin ? "<IMG SRC=\"$imgurl/headingresults2.gif\" WIDTH=157 HEIGHT=22 ALT=\"$lang->{'VerifiedSurveyResults'}\">" : "<h2>$lang->{'VerifiedSurveyResults'}</h2>";
}
elsif ($st eq 'u') {
	$headingimg = $admin ? "<IMG SRC=\"$imgurl/headingresults3.gif\" WIDTH=171 HEIGHT=22 ALT=\"$lang->{'UnverifiedSurveyResults'}\">" : "<h2>$lang->{'UnverifiedSurveyResults'}</h2>";
}
else {
	$headingimg = $admin ? "<IMG SRC=\"$imgurl/headingresults.gif\" WIDTH=98 HEIGHT=22 ALT=\"$lang->{'AllSurveyResults'}\">" : "<h2>$lang->{'AllSurveyResults'}</h2>";
}

my $contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>\n";
$contents .= "<TR><TD>$headingimg</TD></TR>\n";
$contents .= "<TR><TD>\n";

$contents .= &tableOfContents($perlQ, $masurvey, $st, $vw, $admin);

if ($vw eq 'a' || $vw eq 'p') {
	$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND SortOrder>=? ORDER BY SortOrder");
	$query->execute($sid, $cq);
	my $foundq = 0;
	for (my $i = 0; $i < $query->rows; $i++) {
		my $maquestion = $query->fetchrow_hashref;
		$cq++;
		if ($maquestion->{'Type'} eq 'htmlcontent') { next; }
		if ($maquestion->{'Type'} ne 'pagebreak') {
			$contents .= &printQuestion($perlQ, $masurvey, $maquestion, $qcount, $st, $admin);
			$contents .= &printBorder($admin, $masurvey->{'ResultsWidth'});
			$foundq = 1;
			$qcount++;
		}
		elsif ($vw eq 'p' && $foundq) {
			$contents .= &printSubmit($perlQ, $masurvey, $qcount, $cq, $sid, $st, $vw, $admin);
			last;
		}
	}
	$query->finish;
}
elsif (substr($vw,0,1) eq 'q') {
	$query = $dbh->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND QID=? AND Type != 'pagebreak' AND Type != 'htmlcontent'");
	if ($query->execute($sid, substr($vw,1)) && $query->rows) {
		my $maquestion = $query->fetchrow_hashref;
		my $num = 0;
		my $nquery = $dbh->prepare("SELECT COUNT(*) as num FROM perlQQuestion WHERE SID=? AND Type != 'pagebreak' AND Type != 'htmlcontent' AND SortOrder<?");
		if ($nquery->execute($sid, $maquestion->{'SortOrder'}) && $nquery->rows) {
			$num = ($nquery->fetchrow_array)[0];
		}
		$nquery->finish;

		$contents .= &printQuestion($perlQ, $masurvey, $maquestion, $num+1, $st, $admin);
	}
	$query->finish;
}

$contents .= "</TD></TR>\n";
$contents .= "</TABLE>\n";

#-->> Output Page

open(JS, $perlQ->getFilePath('perlQMod/jsstats.txt'));
my $jsinfo = join('', <JS>);
close(JS);

$html->createPage('stats', $masurvey, $contents, $admin, $jsinfo);

sub printQuestion {
	my ($perlQ, $masurvey, $maquestion, $qcount, $stattype, $admin) = @_;
	my $lang = $perlQ->getLanguage;
	my $required = '';
	if ($maquestion->{'Required'} ne 'n') {
		$required = $admin ? '<SPAN STYLE="color: red;">'.$lang->{'*'}.'</SPAN>&nbsp;' : $lang->{'*'}.'&nbsp;';
	}

	my $tablewidth = $admin ? 500 : ($masurvey->{'ResultsWidth'} || 500);
	my $contents = "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=$tablewidth>\n";
	$contents .= "<TR><TD><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>";
	$contents .= "<TD VALIGN=top><NOBR><B>$required$lang->{'Question'}&nbsp;$qcount:&nbsp;</NOBR></B></TD>";
	$contents .= "<TD>$maquestion->{'Question'}</TD>";
	$contents .= "</TR></TABLE></TD></TR>\n";
	$contents .= "<TR><TD ALIGN=center>\n";
	$contents .= &grabAnswers($perlQ, $masurvey, $maquestion, $stattype, $admin);
	$contents .= "</TD></TR>\n";
	$contents .= "</TABLE>\n";

	return $contents;
}

sub grabAnswers {
	my ($perlQ, $masurvey, $maquestion, $stattype, $admin) = @_;
	my $qid = $maquestion->{'QID'};
	my $sid = $masurvey->{'SID'};
	my $lang = $perlQ->getLanguage;
	my $dbh = $perlQ->getDBH;
	my $query;

	my $tablewidth = $admin ? 500 : ($masurvey->{'ResultsWidth'} || 500);
	my $barsize = $tablewidth - 110;
	my $textfieldlimit = $perlQ->getAdminField('TextareaLimit') || 10;
	my $type = $maquestion->{'Type'};
	my $typeheader = sprintf($lang->{'QuestionTypeLabel'}, $lang->{$type});


	my $contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>\n";
	my $tcolspan = $admin ? 3 : 4;
	$tcolspan -= ($type eq 'textfield' || $type eq 'textarea') ? 1 : 0;
	if ($admin) {
		$contents .= "<TR BGCOLOR=#333366><TD HEIGHT=17 COLSPAN=$tcolspan ALIGN=center STYLE=\"color: #FFFFFF;\">$typeheader</TD><TD WIDTH=7 ALIGN=right VALIGN=top><IMG SRC=\"$aimgurl/bound1.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD></TR>";
	}
	else {
		$contents .= "<TR><TD HEIGHT=17 COLSPAN=$tcolspan ALIGN=center STYLE=\"$masurvey->{'ResultsBorder'}\">$typeheader</TD></TR>";
	}

	my $bordercol = "<TD HEIGHT=16 BGCOLOR=#333366 BACKGROUND=\"$aimgurl/%bound%\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=2 HEIGHT=1 ALT=\"\"></TD>";
	if (!$admin) {
		$bordercol = "<TD HEIGHT=16 STYLE=\"$masurvey->{'ResultsBorder'}\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=2 HEIGHT=1 ALT=\"\"></TD>";
	}

	my ($leftbordera,$leftborderr) = ($bordercol,$bordercol);
	my ($rightbordera,$rightborderr) = ($bordercol,$bordercol);
	if ($admin) {
		$leftbordera =~ s/\%bound\%/bound2\.gif/;
		$rightbordera =~ s/\%bound\%/bound3\.gif/;
		$leftborderr =~ s/\%bound\%/bound7\.gif/;
		$rightborderr =~ s/\%bound\%/bound8\.gif/;
	}

	my $totalcount = 0;
	my $seemore = '';
	if ($type =~ /^(select|selectmult|checkbox|radio)$/) {
		my @answerarray = ();

		my @temparray = split(/\|\|\|/, $maquestion->{'Answer'});
		my $count = 0;
		my (%answerid,@countarray,@answertext);
		for (my $i = 0; $i < @temparray; $i++) {
			my @tempsplit = split(/\|\|/, $temparray[$i]);
			
			if ($tempsplit[4] ne 'Y' && $type =~ /^(select|selectmult)$/) { next; }
			push(@answerarray, \@tempsplit);
			push(@countarray,0);

			my $temptext = '';
			if (substr($answerarray[$count]->[2],0,11) eq 'Textfield:(') {
				my $aid = "O$answerarray[$count]->[1]";
			 	$answerid{$aid} = $count;
			 	my $ochoice = substr($answerarray[$count]->[2],11,-1);
				if ($type ne 'checkbox' && $type ne 'radio') {
					$ochoice = $html->protectHTML($ochoice);
				}

				if ($admin) {
			 		$temptext = "<TD BGCOLOR=#FFFFFF COLSPAN=2 WIDTH=100%>";
			 		$temptext .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>";
			 		$temptext .= "<TR><TD><B>".($count+1).".</B>&nbsp;$ochoice&nbsp;</TD>";
			 		$temptext .= "<TD ALIGN=right><!--javascript:ViewOptions($sid,$qid,'$aid','$stattype','$admin')--></TD>";
			 		$temptext .= "</TR></TABLE></TD>";
				}
				else {
			 		$temptext = "<TD COLSPAN=2 WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\">";
			 		$temptext .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>";
			 		$temptext .= "<TR><TD STYLE=\"$masurvey->{'ResultsAnswer'}\"><B>".($count+1).".</B>&nbsp;$ochoice&nbsp;</TD>";
			 		$temptext .= "<TD ALIGN=right STYLE=\"$masurvey->{'ResultsAnswer'}\"><!--javascript:ViewOptions($sid,$qid,'$aid','$stattype','$admin')--></TD>";
			 		$temptext .= "</TR></TABLE></TD>";
				}
			}
			else {
				my $ochoice = $answerarray[$count]->[2];
				if ($type ne 'checkbox' && $type ne 'radio') {
					$ochoice = $html->protectHTML($ochoice);
				}
			 	$answerid{"N$answerarray[$count]->[1]"} = $count;
				if ($admin) {
					$temptext = "<TD BGCOLOR=#FFFFFF COLSPAN=2 WIDTH=100%><B>".($count+1).".</B>&nbsp;$ochoice</TD>";
				}
				else {
					$temptext = "<TD COLSPAN=2 WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\"><B>".($count+1).".</B>&nbsp;$ochoice</TD>";
				}
			}
			push(@answertext, "<TR>$leftbordera$temptext$rightbordera</TR>");
			$count++;
		}

		if ($stattype eq 'u' || $stattype eq 'v') {
			my $cletter = ($stattype eq 'u') ? 'n' : 'y';
			$query = $dbh->prepare("SELECT perlQAnswer.Answer FROM perlQAnswer, perlQUser WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQUser.EmailConfirm='$cletter'");
		}
		else {
			$query = $dbh->prepare("SELECT Answer FROM perlQAnswer WHERE SID=? AND QID=?");
		}
		$query->execute($sid, $qid);
		for (my $j = 0; $j < $query->rows; $j++) {
			my $maanswer = ($query->fetchrow_array)[0] || '';
			my @qanswers = split(/\|\|/, $maanswer);

			for (my $x = 0; $x < @qanswers; $x++) {
				if ($qanswers[$x] =~ /^O/) {
					my @oanswers = split(/\|/, $qanswers[$x]);
					if (defined $answerid{$oanswers[0]}) {
						$countarray[$answerid{$oanswers[0]}]++;
					}
				}
				elsif (defined $answerid{$qanswers[$x]}) {
					$countarray[$answerid{$qanswers[$x]}]++;
				}
			}
		}
		$query->finish;

		my $largestcount = 0;
		for (my $x = 0; $x < @countarray; $x++) {
			if ($countarray[$x] > $largestcount) { $largestcount = $countarray[$x]; }
			$totalcount += $countarray[$x];
		}

		for (my $k = 0; $k < @answerarray; $k++) {
			my $percent = ($totalcount > 0) ? sprintf("%.1f", (($countarray[$k] / $totalcount) * 100)) : 0;
			my $barwidth = ($largestcount > 0) ? int(($countarray[$k] / $largestcount) * $barsize) : 1;
			if ($barwidth < 1) { $barwidth = 1; }

			# Only show tresultbutton if there were textfield results.
			if ($countarray[$k]) {
				if ($admin) {
					$answertext[$k] =~ s/<!--javascript:([^\-]+)-->/<A HREF=\"javascript:$1\"><IMG SRC=\"$imgurl\/tresultbutton.gif\" WIDTH=108 HEIGHT=12 BORDER=0 ALT=\"$lang->{'TextfieldResultsLink'}\"><\/A>/;
				}
				else {
					$answertext[$k] =~ s/<!--javascript:([^\-]+)-->/<A HREF="javascript:$1" STYLE="$masurvey->{'ResultsAnswer'}"><NOBR>$lang->{'TextfieldResultsLink'}<\/NOBR><\/A>/;
				}
			}
			$contents .= $answertext[$k];
			$contents .= "<TR>$leftborderr";
			if ($admin) {
				$contents .= "<TD BGCOLOR=#DDEEFF ALIGN=right>$countarray[$k]&nbsp;($percent%)&nbsp;</TD>";
				$contents .= "<TD BGCOLOR=#DDEEFF WIDTH=$barsize><IMG SRC=\"$aimgurl/bar.gif\" WIDTH=$barwidth HEIGHT=8 ALT=\"\"></TD>";
			}
			else {
				$contents .= "<TD ALIGN=right STYLE=\"$masurvey->{'ResultsStats'}\">$countarray[$k]&nbsp;($percent%)&nbsp;</TD>";
				$contents .= "<TD STYLE=\"$masurvey->{'ResultsStats'}\" WIDTH=$barsize><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD STYLE=\"$masurvey->{'ResultsGraph'}\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=$barwidth HEIGHT=1 ALT=\"\"></TD></TR></TABLE></TD>";
			}
			$contents .= "$rightborderr</TR>\n";
		}
	}
	elsif ($type eq 'textfield' || $type eq 'textarea') {
		if ($stattype eq 'u' || $stattype eq 'v') {
			my $cletter = ($stattype eq 'u') ? 'n' : 'y';
			$query = $dbh->prepare("SELECT COUNT(*) as num FROM perlQAnswer,perlQUser WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQAnswer.Answer != '' AND perlQUser.EmailConfirm='$cletter'");
		}
		else {
			$query = $dbh->prepare("SELECT COUNT(*) as num FROM perlQAnswer WHERE SID=? AND QID=? AND Answer!=''");
		}
		if ($query->execute($sid, $qid) && $query->rows) {
			$totalcount = ($query->fetchrow_array)[0];
		}
		$query->finish;

		my $qclause = '';
		if ($stattype eq 'u' || $stattype eq 'v') {
			my $cletter = ($stattype eq 'u') ? 'n' : 'y';
			$qclause = " AND perlQUser.EmailConfirm='$cletter'";
		}
		$query = $dbh->prepare("SELECT perlQAnswer.Answer, perlQUser.UID, perlQUser.Email, perlQUser.IPAddr, DATE_FORMAT(perlQUser.CompleteDate, '$lang->{'MySQLDateFormat'}') as FDate FROM perlQAnswer,perlQUser WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQAnswer.Answer!=''$qclause ORDER BY perlQUser.CompleteDate DESC LIMIT $textfieldlimit");
		$query->execute($sid, $qid);
		for (my $i = 0; $i < $query->rows; $i++) {
			my $matanswer = $query->fetchrow_hashref;

			$contents .= "<TR>$leftbordera";
			if ($admin) {
				$contents .= "<TD BGCOLOR=#FFFFFF ALIGN=right>";
			}
			else {
				$contents .= "<TD ALIGN=right STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\">";
			}
			if (substr($masurvey->{'SurveyUsers'},2,1)) {
				my $email = $matanswer->{'Email'} ? $html->protectHTML($matanswer->{'Email'}) : $lang->{'notentered'};
				$contents .= "<B>$lang->{'Email'}:</B> $email&nbsp;&nbsp;&nbsp;";
			}
			else {
				$contents .= "<B>$lang->{'IP'}:</B> " . $html->protectHTML($matanswer->{'IPAddr'})."&nbsp;&nbsp;&nbsp;";
			}
			my $fdate = $matanswer->{'FDate'};
			if ($admin) {
				$fdate = "<A HREF=\"view.cgi?sid=$sid&uid=$matanswer->{'UID'}\" CLASS=link TARGET=_blank>$fdate</A>";
			}
			$contents .= "<B>$lang->{'Date'}:</B> $fdate";
			$contents .= "</TD>$rightbordera</TR><TR>$leftborderr";
			if ($admin) {
				$contents .= "<TD BGCOLOR=#DDEEFF WIDTH=100%>";
			}
			else {
				$contents .= "<TD WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsStats'}\">";
			}
			$contents .= "<B>".($i+1).".</B>&nbsp;".$html->protectHTML($matanswer->{'Answer'})."</TD>$rightborderr</TR>\n";
		}
		$query->finish;

		if (!$totalcount) {
			if ($admin) {
				$contents .= "<TR>$leftbordera<TD BGCOLOR=#FFFFFF WIDTH=100%>$lang->{'NoResults'}</TD>$rightbordera</TR>";
			}
			else {
				$contents .= "<TR>$leftbordera<TD WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\">$lang->{'NoResults'}</TD>$rightbordera</TR>";
			}
		}

		if ($totalcount > $textfieldlimit) {
			my $style = $admin ? 'color: #FFFFFF;' : $masurvey->{'ResultsBorder'};
			my $class = $admin ? ' CLASS=link' : '';
			$seemore = "&nbsp;&nbsp;<A HREF=\"javascript:ViewText($sid,$qid,'$stattype','$admin')\"$class STYLE=\"$style\"><B>$lang->{'SeeMoreLink'}</B></A>&nbsp;&nbsp;";
		}
	}

	if ($admin) {
		$contents .= "<TR BGCOLOR=#333366>";
		$contents .= "<TD><IMG SRC=\"$aimgurl/bound9.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
		$contents .= "<TD ALIGN=right HEIGHT=17 COLSPAN=$tcolspan STYLE=\"color: #FFFFFF;\">";
		$contents .= "<NOBR><B>$lang->{'Total'}:</B> $totalcount&nbsp;&nbsp;$seemore</NOBR></TD></TR>";
	}
	else {
		$contents .= "<TR><TD ALIGN=right HEIGHT=17 COLSPAN=$tcolspan STYLE=\"$masurvey->{'ResultsBorder'}\"><NOBR><B>$lang->{'Total'}:</B> $totalcount&nbsp;&nbsp;$seemore</NOBR></TD></TR>";
	}
	$contents .= "</TABLE>\n";

	return $contents;
}

sub tableOfContents {
	my ($perlQ, $masurvey, $stattype, $view, $admin) = @_;
	my $lang = $perlQ->getLanguage;
	my $sid = $masurvey->{'SID'};
	my $tablewidth = $admin ? 500 : ($masurvey->{'ResultsWidth'} || 500);
	my $class = $admin ? ' CLASS=link' : '';
	my $fa = $admin ? '&fa=1' : '';

	my $contents = "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=$tablewidth>\n";

	$contents .= "<TR><TD COLSPAN=3 ALIGN=center>\n";
	$contents .= ($view ne 'n') ? "<A HREF=\"stats.cgi?sid=$sid&st=$stattype&vw=n$fa\"$class><B>$lang->{'TableofContents'}</B></A>" : "<B>[ $lang->{'TableofContents'} ]</B>";
	$contents .= " : ";
	$contents .= ($view ne 'p') ? "<A HREF=\"stats.cgi?sid=$sid&st=$stattype&vw=p$fa\"$class><B>$lang->{'ViewwithPagebreaks'}</B></A>" : "<B>[ $lang->{'ViewwithPagebreaks'} ]</B>";
	$contents .= " : ";
	$contents .= ($view ne 'a') ? "<A HREF=\"stats.cgi?sid=$sid&st=$stattype&vw=a$fa\"$class><B>$lang->{'ViewAllQuestions'}</B></A>" : "<B>[ $lang->{'ViewAllQuestions'} ]</B>";
	$contents .= "</TD></TR>\n";

	$contents .= &printBorder2($admin);

	my $reqstyle = $admin ? ' STYLE="color: red;"' : '';
	if ($view eq 'n') {
		$contents .= "<TR><TD></TD><TD ALIGN=center COLSPAN=2>".sprintf($lang->{'AsteriskText'}, $reqstyle)."</TD></TR>\n";

		$contents .= &printBorder2($admin);

		my $query = $perlQ->getDBH->prepare("SELECT * FROM perlQQuestion WHERE SID=? AND Type != 'pagebreak' AND Type != 'htmlcontent' ORDER BY SortOrder");
		$query->execute($sid);
		my $qcount = 1;
		for (my $i = 0; $i < $query->rows; $i++) {
			my $maquestion = $query->fetchrow_hashref;
			my $qloc = "stats.cgi?sid=$sid&st=$stattype&vw=q$maquestion->{'QID'}$fa";
			$contents .= "<TR><TD VALIGN=top>";
			$contents .= ($maquestion->{'Required'} ne 'n') ? "<B$reqstyle>$lang->{'*'}</B>" : '&nbsp;';
			$contents .= "</TD><TD VALIGN=top><NOBR><B>$lang->{'Question'} $qcount:</B></NOBR></TD>";
			$contents .= "<TD WIDTH=100%><A HREF=\"$qloc\"$class>$maquestion->{'Question'}</A></TD></TR>\n";
			$qcount++;
		}
		$query->finish;
	}

	$contents .= "</TABLE>\n";

	return $contents;
}

sub printSubmit {
	my ($perlQ, $masurvey, $qcount, $cq, $sid, $stattype, $view, $admin) = @_;
	my $fa = $admin ? "<INPUT TYPE=hidden NAME=fa VALUE=1>" : '';
	my $button = &getButton($perlQ, $masurvey, 'next');
	my $contents = "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>\n";
	$contents .= "<FORM ACTION=\"stats.cgi\">\n";
	$contents .= "<TR><TD ALIGN=center>$button</TD></TR>\n";
	$contents .= "<INPUT TYPE=hidden NAME=sid VALUE=\"$sid\">\n";
	$contents .= "<INPUT TYPE=hidden NAME=st VALUE=\"$stattype\">\n";
	$contents .= "<INPUT TYPE=hidden NAME=vw VALUE=\"$view\">\n";
	$contents .= "<INPUT TYPE=hidden NAME=cq VALUE=\"$cq\">\n";
	$contents .= $fa;
	$contents .= "<INPUT TYPE=hidden NAME=qcount VALUE=\"$qcount\">\n";
	$contents .= "</FORM>\n";
	$contents .= "</TABLE>\n";

	return $contents;
}

sub getButton {
	my ($perlQ, $masurvey, $buttontext) = @_;
	my $html = $perlQ->getHTML;
	my $button;
	my $index = '';

	if ($buttontext eq 'submit') { $index = 'Submit'; }
	elsif ($buttontext eq 'next') { $index = 'Next'; }
	elsif ($buttontext eq 'results') { $index = 'Result'; }

	if ($masurvey->{$index.'ImageSrc'} && $masurvey->{$index.'ImageWidth'} > 0 && $masurvey->{$index.'ImageHeight'} > 0) {
		my $buttonsrc = $html->protectHTML($masurvey->{$index.'ImageSrc'});
		my $buttonwidth = $masurvey->{$index.'ImageWidth'} ? " WIDTH=$masurvey->{$index.'ImageWidth'}" : '';
		my $buttonheight = $masurvey->{$index.'ImageHeight'} ? " HEIGHT=$masurvey->{$index.'ImageHeight'}" : '';
		my $buttonalt = $masurvey->{$index.'ImageText'} ? " ALT=\"$masurvey->{$index.'ImageText'}\"" : '';
		$button = "<INPUT TYPE=\"image\" NAME=\"$buttontext\" SRC=\"$buttonsrc\"$buttonwidth$buttonheight BORDER=0$buttonalt VALUE=\"1\">";
	}
	else {
		my $bstyle = '';
		if ($masurvey->{$index.'ImageWidth'} || $masurvey->{$index.'ImageHeight'}) {
			$bstyle = ' STYLE="';
			$bstyle .= $masurvey->{$index.'ImageWidth'} ? "width: $masurvey->{$index.'ImageWidth'}px; " : '';
			$bstyle .= $masurvey->{$index.'ImageHeight'} ? "height: $masurvey->{$index.'ImageHeight'}px; " : '';
			$bstyle .= '"';
		}
		$button = "<INPUT TYPE=submit NAME=\"$buttontext\" VALUE=\"$masurvey->{$index.'ImageText'}\"$bstyle>";
	}
	
	return $button;
}

sub printBorder {
	my ($admin, $tablewidth) = @_;
	$tablewidth = $admin ? 500 : ($tablewidth || 500);
	my $border = $admin ? "<TD BACKGROUND=\"$aimgurl/border.gif\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=100 HEIGHT=2 ALT=\"\"></TD>" : "<TD><HR SIZE=1 NOSHADE></TD>";
	my $contents = "<BR>\n";
	$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=$tablewidth>\n";
	$contents .= "<TR>$border</TR>\n";
	$contents .= "</TABLE>\n";
	$contents .= "<BR>\n";

	return $contents;
}

sub printBorder2 {
	my ($admin) = @_;
	my $border = $admin ? "<TD BACKGROUND=\"$aimgurl/border.gif\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=100 HEIGHT=2 ALT=\"\"></TD>" : "<TD><HR SIZE=1 NOSHADE></TD>";
	my $contents = "<TR><TD COLSPAN=3>\n";
	$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>\n";
	$contents .= "<TR>$border</TR>\n";
	$contents .= "</TABLE>\n";
	$contents .= "</TD></TR>\n";

	return $contents;
}

