#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
require "Question.cgi";
require "View.cgi";
import perlQMod::State;

#-->> Logging In

my $perlQ = perlQMod::State->new;

my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

if (!$perlQ->isAdmin) { $html->redirect(-url => 'admin/index.cgi'); }

#-->> Setting Variables

my $action = $cgi->param('action') || '';
my $sid = (($cgi->param('sid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $cq = (($cgi->param('cq') || 1) =~ /^(\d+)$/) ? $1 : 1;
my $uid = (($cgi->param('uid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $print = $cgi->param('print') ? 1 : 0;

#-->> Checking SID and UID

if (!&uidValid($perlQ, $uid)) {
	$html->redirect(-url => "admin/choose.cgi");
}

my $masurvey = 0;
my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
if ($query->execute($sid) && $query->rows) {
	$masurvey = $query->fetchrow_hashref;
}
$query->finish;

if (!$masurvey) { $html->redirect(-url => "admin/choose.cgi"); }

#-->> Set Language

$perlQ->setLanguage($masurvey->{'Language'});
my $lang = $perlQ->getLanguage;

#-->> Survey

my $contents = &recreateSurvey($perlQ, $sid, $uid, $cq, $masurvey, $print);

#-->> Output Page

$perlQ->getHTML->createPage($sid, sprintf($lang->{'ViewSurvey'}, $uid), $contents, 0, '');

sub uidValid {
	my ($perlQ, $uid) = @_;
	my $dbh = $perlQ->getDBH;
	my $retval = 0;

	if ($uid !~ /^\d+$/) { return 0; }

	my $query = $dbh->prepare("SELECT 1 FROM perlQUser WHERE UID=?");
	if ($query->execute($uid) && $query->rows) { $retval = 1; }
	$query->finish;
	return $retval;
}

