#!/usr/bin/perl
################################################################################
# perlQuestionnaire                          Version 2.2                       #
# Copyright 2003-2005 chumpsoft, inc.        March 28, 2005                    #
################################################################################
#              SCRiPTMAFiA 2005 - THE DiRTY HANDS ON YOUR SCRiPTS              #
################################################################################

#-->> Push correct path into @INC depending on whether this is Unix/Windows.
if ($0 =~ /(.*)\\[^\\]+/) { unshift (@INC, "$1\\perlQMod"); }
elsif ($0 =~ /(.*)\/[^\/]+/) { unshift (@INC, "$1/perlQMod"); }
else { unshift (@INC, "perlQMod"); }

#-->> Including Files

use strict;
require "State.cgi";
import perlQMod::State;

my $perlQ = perlQMod::State->new;

my $cgi = $perlQ->getCGI;
my $dbh = $perlQ->getDBH;
my $html = $perlQ->getHTML;

#-->> GET and POST Variables

my $sid = (($cgi->param('sid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $qid = (($cgi->param('qid') || 0) =~ /^(\d+)$/) ? $1 : 0;
my $cc = (($cgi->param('cc') || 1) =~ /^(\d+)$/) ? $1 : 1;
my $fa = (($cgi->param('fa') || 0) == 1) ? 1 : 0;
my $oid = $cgi->param('oid') || '';
my $st = (($cgi->param('st') || '') =~ /^(\w)$/) ? $1 : 'a'; # single character
my $tp = (($cgi->param('tp') || '') =~ /^(\w)$/) ? $1 : ''; # single character

my $masurvey = 0;
my $query = $dbh->prepare("SELECT * FROM perlQSurvey WHERE SID=?");
if ($query->execute($sid) && $query->rows) {
	$masurvey = $query->fetchrow_hashref;
}
$query->finish;

if (!$masurvey) { $html->redirect(-url => 'error.cgi'); }

#-->> Logging In (if survey results are not public)

my $admin = $perlQ->isAdmin;
if (!$admin) {
	if (!$masurvey->{'SurveyResults'}) {
		$html->redirect(-url => 'admin/index.cgi');
	}
	if ($masurvey->{'Active'} eq 'n') {
		$html->redirect(-url => "fillsurvey.cgi?sid=$sid");
	}
}
elsif (!$fa) { $admin = 0; }

#-->> Set Language

if ($admin) { $perlQ->setLanguage('', 'ADMIN'); }
else { $perlQ->setLanguage($masurvey->{'Language'}); }
my $lang = $perlQ->getLanguage;
my $imgurl = $perlQ->getImageDir;
my $aimgurl = $perlQ->getImgURL('admin/images');

#-->> Checking SID

my $relocate = ($qid && ($tp eq 't' || ($tp eq 'o' && $oid))) ? 0 : 1;
if ($relocate) { $html->redirect(-url => 'error.cgi'); }

my $maxleftright = 4;
my $title = '';
if ($tp eq 'o') {
	$query = $dbh->prepare("SELECT Answer FROM perlQQuestion WHERE SID=? AND QID=?");
	if ($query->execute($sid, $qid) && $query->rows) {
		my @choice = split(/\|\|\|/, ($query->fetchrow_array)[0]);
		for (my $i = 0; $i < @choice; $i++) {
			my @option = split(/\|\|/, $choice[$i]);
			if ("O$option[1]" eq $oid && substr($option[2],0,11) eq 'Textfield:(') {
				$title = substr($option[2],11,-1);
			}
		}
	}
	$query->finish;
}
else {
	$query = $dbh->prepare("SELECT Question FROM perlQQuestion WHERE SID=? AND QID=?");
	if ($query->execute($sid, $qid) && $query->rows) {
		$title = ($query->fetchrow_array)[0];
	}
	$query->finish;
}

my $limit = $perlQ->getAdminField('PopupLimit') || 10;

my $moid = '(^|\|)' . $oid . '\|';
if ($st eq 'u' || $st eq 'v') {
	my $cletter = ($st eq 'v') ? 'y' : 'n';
	$query = $dbh->prepare("SELECT COUNT(*) as num FROM perlQAnswer, perlQQuestion, perlQUser WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQAnswer.QID=perlQQuestion.QID AND perlQAnswer.SID=perlQQuestion.SID AND (((perlQQuestion.type='textarea' OR perlQQuestion.type='textfield') AND perlQAnswer.Answer != '') OR (perlQQuestion.type!='textarea' AND perlQQuestion.type !='textfield' AND perlQUser.EmailConfirm=\"$cletter\" AND perlQAnswer.Answer RLIKE ?))");
}
else {
	$query = $dbh->prepare("SELECT COUNT(*) as num FROM perlQAnswer, perlQQuestion WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.QID=perlQQuestion.QID AND perlQAnswer.SID=perlQQuestion.SID AND (((perlQQuestion.type='textarea' OR perlQQuestion.type='textfield') AND perlQAnswer.Answer != '') OR (perlQQuestion.type!='textarea' AND perlQQuestion.type !='textfield' AND perlQAnswer.Answer RLIKE ?))");
}

my $max = 0;
if ($query->execute($sid, $qid, $moid) && $query->rows) {
	$max = ($query->fetchrow_array)[0];
}
$query->finish;

my $start = ($cc-1 < $max) ? $cc-1 : 0;
my $end = ($cc+$limit-2 < $max) ? $cc+$limit-2 : $max-1;

my $qclause = '';
if ($st eq 'u' || $st eq 'v') {
	my $cletter = ($st eq 'v') ? 'y' : 'n';
	$qclause = " AND perlQUser.EmailConfirm=\"$cletter\"";
}
$query = $dbh->prepare("SELECT perlQAnswer.Answer, perlQUser.UID, perlQUser.Email, perlQUser.IPAddr, DATE_FORMAT(perlQUser.CompleteDate, '$lang->{'MySQLDateFormat'}') as mdate FROM perlQAnswer, perlQUser, perlQQuestion WHERE perlQAnswer.SID=? AND perlQAnswer.QID=? AND perlQAnswer.UID=perlQUser.UID AND perlQAnswer.QID=perlQQuestion.QID AND perlQAnswer.SID=perlQQuestion.SID AND (((perlQQuestion.type='textarea' OR perlQQuestion.type='textfield') AND perlQAnswer.Answer != '') OR (perlQQuestion.type!='textarea' AND perlQQuestion.type !='textfield'$qclause AND perlQAnswer.Answer RLIKE ?)) ORDER BY perlQUser.CompleteDate DESC LIMIT $start,$limit");
$query->execute($sid, $qid, $moid);

my $bordercol = "<TD HEIGHT=16 BGCOLOR=#333366 BACKGROUND=\"$aimgurl/%bound%\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=2 HEIGHT=1 ALT=\"\"></TD>";
if (!$admin) {
	$bordercol = "<TD HEIGHT=16 STYLE=\"$masurvey->{'ResultsBorder'}\"><IMG SRC=\"$aimgurl/invdot.gif\" WIDTH=2 HEIGHT=1 ALT=\"\"></TD>";
}

my ($leftbordera,$leftborderr) = ($bordercol,$bordercol);
my ($rightbordera,$rightborderr) = ($bordercol,$bordercol);
if ($admin) {
	$leftbordera =~ s/\%bound\%/bound2\.gif/;
	$rightbordera =~ s/\%bound\%/bound3\.gif/;
	$leftborderr =~ s/\%bound\%/bound7\.gif/;
	$rightborderr =~ s/\%bound\%/bound8\.gif/;
}

my @answerlist = ();
my $acount = 0;
for (my $i = 0; $i < $query->rows; $i++) {
	my $maanswer = $query->fetchrow_hashref;

	my $mdate = $maanswer->{'mdate'};
	if ($admin) {
		$mdate = "<A HREF=\"view.cgi?sid=$sid&uid=$maanswer->{'UID'}\" CLASS=link TARGET=_blank>$maanswer->{'mdate'}</A>";
	}
	my $heading = "<B>$lang->{'Date'}:</B> $mdate&nbsp;&nbsp;&nbsp;";
	if (substr($masurvey->{'SurveyUsers'},2,1)) {
		my $email = $maanswer->{'Email'} || $lang->{'notentered'};
		if (length($email) > 20) { $email = substr($email,0,20) . "..."; }
		$heading .= "<B>$lang->{'Email'}:</B> " . $html->protectHTML($email);
	}
	else {
		$heading .= "<B>$lang->{'IP'}:</B> $maanswer->{'IPAddr'}";
	}

	if ($tp eq 't') {
		my $tempanswer = "<TR>$leftbordera";
		if ($admin) {
			$tempanswer .= "<TD BGCOLOR=#FFFFFF WIDTH=100%><B>".($acount+1+$start).".</B>&nbsp;$heading</TD>";
		}
		else {
			$tempanswer .= "<TD WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\"><B>".($acount+1+$start).".</B>&nbsp;$heading</TD>";
		}
		$tempanswer .= "$rightbordera</TR><TR>$leftborderr";
		if ($admin) {
			$tempanswer .= "<TD BGCOLOR=#DDEEFF>".$html->protectHTML($maanswer->{'Answer'})."</TD>";
		}
		else {
			$tempanswer .= "<TD STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsStats'}\">".$html->protectHTML($maanswer->{'Answer'})."</TD>";
		}
		$tempanswer .= "$rightborderr</TR>";

		push (@answerlist, $tempanswer);
		$acount++;
	}
	else {
		my @choices = split(/\|\|/, $maanswer->{'Answer'});
		for (my $j = 0; $j < @choices; $j++) {
			if (substr($choices[$j],0,1) eq 'O') {
				my @answer = split(/\|/, $choices[$j]);
				if ($answer[0] eq $oid) {
					my $realanswer = $html->protectHTML($answer[1]);

					my $tempanswer = "<TR>$leftbordera";
					if ($admin) {
						$tempanswer .= "<TD BGCOLOR=#FFFFFF WIDTH=100%><B>".($acount+1+$start).".</B>&nbsp;$heading</TD>";
					}
					else {
						$tempanswer .= "<TD WIDTH=100% STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsAnswer'}\"><B>".($acount+1+$start).".</B>&nbsp;$heading</TD>";
					}
					$tempanswer .= "$rightbordera</TR><TR>$leftborderr";
					if ($admin) {
						$tempanswer .= "<TD BGCOLOR=#DDEEFF>$realanswer</TD>";
					}
					else {
						$tempanswer .= "<TD STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsStats'}\">$realanswer</TD>";
					}
					$tempanswer .= "$rightborderr</TR>";

					push(@answerlist, $tempanswer);
					$acount++;
				}
			}
		}
	}
}
$query->finish;

my $contents = "<TABLE CELLPADDING=2 CELLSPACING=0 BORDER=0 WIDTH=100%><TR><TD>\n";
if ($admin) {
	$contents .= "<IMG SRC=\"$imgurl/headingwizard1.gif\" WIDTH=112 HEIGHT=17 ALT=\"$lang->{'TextfieldResults'}\">";
}
else {
	$contents .= "<H2>$lang->{'TextfieldResults'}</H2>";
}
$contents .= "</TD></TR><TR><TD>";

$contents .= "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=100%>\n";
if ($admin) {
	$contents .= "<TR BGCOLOR=#333366><TD COLSPAN=2 ALIGN=center STYLE=\"padding-left: 5px; padding-right: 5px;\"><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=100%><TR><TD STYLE=\"color: #FFFFFF;\">";
	$contents .= "<B>".$html->protectHTML($title)."</B></TD><TD ALIGN=right><SPAN STYLE=\"color: #99CCFF;\"><NOBR><B>$lang->{'Total'}:</B> $max</NOBR></SPAN></TD></TR></TABLE>";
	$contents .= "</TD><TD VALIGN=top ALIGN=right><IMG SRC=\"$aimgurl/bound1.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD></TR>\n";
}
else {
	$contents .= "<TR><TD HEIGHT=17 COLSPAN=3 ALIGN=center STYLE=\"padding-left: 5px; padding-right: 5px; $masurvey->{'ResultsBorder'}\"><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>";
	$contents .= "<TR><TD STYLE=\"$masurvey->{'ResultsBorder'}\"><B>".$html->protectHTML($title)."</B></TD><TD ALIGN=right STYLE=\"$masurvey->{'ResultsBorder'}\"><NOBR><B>$lang->{'Total'}:</B> $max</NOBR></TD></TR></TABLE></TD></TR>\n";
}

for (my $i = 0; $i < $limit && $i < @answerlist; $i++) {
	$contents .= $answerlist[$i];
}

if (!$max) {
	my $style = $admin ? ' BGCOLOR=#FFFFFF' : " STYLE=\"$masurvey->{'ResultsAnswer'}\"";
	$contents .= "<TR>$leftbordera";
	$contents .= "<TD WIDTH=100% ALIGN=center$style>$lang->{'NoResults'}</TD>";
	$contents .= "$rightbordera</TR>";
}

if ($admin) {
	$contents .= "<TR BGCOLOR=#333366><TD><IMG SRC=\"$aimgurl/bound9.gif\" WIDTH=7 HEIGHT=17 ALT=\"\"></TD>";
	$contents .= "<TD COLSPAN=2 ALIGN=center STYLE=\"color: #FFFFFF;\">&nbsp;";
}
else {
	$contents .= "<TR><TD COLSPAN=3 STYLE=\"$masurvey->{'ResultsBorder'}\" ALIGN=center HEIGHT=17>&nbsp;";
}

my $next = $cc+$limit;
my $prev = $cc-$limit;
my $lastindex = $max / $limit;
$lastindex = (int($lastindex) == $lastindex) ? $lastindex : int($lastindex) + 1;

if ($next <= $max || $prev > 0) {
	my $fa = $admin ? '&fa=1' : '';
	my $baseq = "sid=$sid&qid=$qid&oid=$oid&tp=$tp&st=$st$fa";
	my $style = $admin ? 'color: #FFFFFF;' : $masurvey->{'ResultsBorder'};
	my $selstyle = $admin ? ' STYLE="color: #99CCFF;"' : '';
	my $class = $admin ? ' CLASS=link' : '';

	# Previous Link

	if ($prev > 0) {
		$contents .= "<A HREF=\"viewoption.cgi?$baseq&cc=$prev\"$class STYLE=\"$style\"><B>$lang->{'Previous'}</B></A> : ";
	}

	# Index Links

	for (my $k = 1; $k <= $lastindex; $k++) {
		my $startindex = int($start/$limit) + 1;
		if ($k == 1 || $k == $lastindex ||
				($k >= $startindex-$maxleftright && $k <= $startindex+$maxleftright)) {
			my $indexcc = ($k-1) * $limit + 1;
			my $indexlink = "<A HREF=\"viewoption.cgi?$baseq&cc=$indexcc\"$class STYLE=\"$style\">$k</A>";
			$contents .= ($k > 1) ? " " : "";
			$contents .= ($k == $lastindex && $k-1 > $startindex+$maxleftright && $lastindex > 2*$maxleftright+1) ? "... " : "";
			$contents .= ($indexcc-1 == $start) ? "<B$selstyle>[$k]</B>" : "<B>$indexlink</B>";
			$contents .= ($k == 1 && $k+1 < $startindex-$maxleftright && $lastindex > 2*$maxleftright+1) ? " ..." : "";
		}
	}

	# Next Link

	if ($next <= $max) {
		$contents .= " : <A HREF=\"viewoption.cgi?$baseq&cc=$next\"$class STYLE=\"$style\"><B>$lang->{'Next'}</B></A>";
	}
}

$contents .= "</TD></TR>\n";
$contents .= "</TABLE></TD></TR></TABLE>\n";

if (!$admin) {
	$html->createPage('stats', $masurvey, $contents, $admin, '');
}
else {
	open(T, $perlQ->getFilePath('admin/poptemplate.html'));
	my $templatedata = join('', <T>);
	close(T);

	my $aurl = $perlQ->getImgURL('admin');
	$templatedata =~ s/SRC="images\//SRC="$aimgurl\//g;
	$templatedata =~ s/HREF="template.css"/HREF="$aurl\/template.css"/g;

	$templatedata =~ s/::SURVEYNAME::/$lang->{'AdminTitle'} :: $lang->{'TextfieldResults'}/g;
	$templatedata =~ s/::CHARSET::/$lang->{'CHARSET'}/g;
	$templatedata =~ s/::CONTENT::/$contents/g;

	print $cgi->header;
	print $templatedata;
	$perlQ->exit;
}

